;Towards thee I roll, thou all-destroying but
;unconquering whale; to the last I grapple with
;thee; from hell's heart, I stab at thee; for
;hate's sake, I spit my last breath at thee.
;	-Ahab

.plugin string86

;to do:

;"overburdened" warning?
;rewrite entire object system :P
;death ai?  (in addition to ai and response ai...)
;custom font?  riiiiiiight
;optimize like you've never optimized before
;draw up some 'flava' objects
;level selector - make it prettier (light gray background?)
;	also make it support more than 8 levels
;item stats screen?
;larger than 8x8 objects?  (how?)
;map screen?
;rewrite pause screen so it's nicer
;redesign flag system to use less code
;	use some of the extra bits to signal floot? etc...
;use stdargs for normal ai
;stuff that "wakes up" when visible?
;when using killobject, the next object in the ai list is skipped -- bad
;	make a "killqueue"?
;maybe problem with animate2 / animate4 and flags?

;note: pathed ai routines have been taken out...

;save file format:
;	inventory (116 bytes)
;	objflags (1024)
;	objlist, objfreespace (512)
;	selected game variables, attribs, proficiencies (?)
;	all rle'd

;note for later - it's ok to have the response
;routines destroy af', so optimize away

;consider having table for the routines that load
;	attack stats, similar to what you did for defense
;	stats

;*** = cannot be moved
;** = must not cross a 256 byte boundary
;*N = must be aligned to an N byte boundary
;@@@ = used in precalculation only (ok to fill with rendering data)
;@@ = can be destoryed after rendering is done


#include key86.inc
#include char86.inc
#include bload.inc			;has rom86.h, ram86.h, flag86.inc in it
#include helpdata.inc

;** temporary stuff (used once, ok to destroy) **
curstring equ $a401			;1 byte, current string
numstrings equ $a402      	;1 byte, number of level files
stringlist equ $a403      	;?? bytes, list of level files
quitroutine equ $8100		;?? bytes, need to load page d when quitting...

;** stuff on page 1 **
colbufferlow equ $8040    	;16 bytes, um stuff
colmap equ $8050          	;** 160 bytes, locations of objects
colbufferhigh equ $80f0   	;16 bytes

alitantable equ $8100      	;*256 33 bytes, tangents...
doorgfx equ $8100+33		;96 bytes
doorswinggfx equ doorgfx+96	;96 bytes
doorswing2gfx equ doorswinggfx+96	;96 bytes
dooropengfx equ doorswing2gfx+96	;96 bytes
lampgfx equ dooropengfx+96
lampgfx2 equ lampgfx+96
lampgfx3 equ lampgfx2+96
lampgfx4 equ lampgfx3+96
gooballgfx1 equ lampgfx4+96
gooballgfx2 equ gooballgfx1+96
gooballgfx3 equ gooballgfx2+96

inventory equ $8520+33		;3*32 bytes, inventory items

;** stuff that determines battle stats **
swordtype equ inventory+96	;1 byte, type of sword (0-6 or 7)
swordmod1 equ inventory+97	;1 byte, prefix modifier
swordmod2 equ inventory+98	;1 byte, suffix modifier
shieldtype equ inventory+99
shieldmod1 equ inventory+100
shieldmod2 equ inventory+101
armortype equ inventory+102	;1 byte, type of armor
armormod1 equ inventory+103	;1 byte
armormod2 equ inventory+104	;1 byte
potmods equ inventory+105	;10 bytes, modifiers due to potions/spells
skilltype equ inventory+115	;1 byte, which skill to use

;some space here...

lootlist equ $8600			;256 bytes, pre-randomized loot

alimasktable equ $8700    	;*** 8 bytes, used in findpixel
swordgfx equ $8700+8		;192 bytes

textspace equ $8700+200		;needs 9-10 bytes max?
shotdata equ $8700+210		;7 bytes, temp space for shooter enemies

;* attacking object battle stats *
oabattlestats equ $8700+230
oadir equ oabattlestats+0
oaatt equ oabattlestats+1
oadam equ oabattlestats+2
oacritrate equ oabattlestats+3
oacritmod equ oabattlestats+4
oastuntime equ oabattlestats+5
oapushback equ oabattlestats+6

;* defending object battle stats *
odbattlestats equ $8700+237
oddir equ odbattlestats+0
odshield equ odbattlestats+1
oddef equ odbattlestats+2
oddamreduct equ odbattlestats+3
odcritreduct equ odbattlestats+4
odrecoverytime equ odbattlestats+5
odaddress equ odbattlestats+6

litmapdark equ $8800     	;*1k 1024 bytes each, fully lit screens
litmaplight equ $8c00
spritedata equ $9000      	;*4k 4096 bytes, huge table of pre-shifted sprite gfx

stairgfx equ $a000			;96 bytes
chestgfx equ stairgfx+96
playergfx equ chestgfx+96
playergfx2 equ playergfx+96
playergfxp equ playergfx2+96
playergfxd equ playergfxp+96
playergfxa equ playergfxd+96
playergfxa2 equ playergfxa+96
playergfxa3 equ playergfxa2+96
;1 space and then
;some change left

objflags equ $a400        	;*1024 1024 bytes, tells what objects are active
rayfield equ $a800        	;@@ *1k? (don't remember) 1024 bytes, raycasting done here...

enemy1 equ $ac00
enemy2 equ enemy1+(96*6)
enemy3 equ enemy2+(96*6)
enemy4 equ enemy3+(96*6)

giantunrolledmess equ $b500	;727 bytes, unrolled loop to display the screen
clippadlow equ $b7f0
clipfield equ $b800        	;1024 bytes, **must follow rayfield by $1000**
clippadhigh equ $bc00     	;16 bytes each, padding for clipfield
unrolledldir equ $bc10    	;516 bytes, bunch of ldi's

;** stuff in graph mem **
;none currently

;** stuff in _asm_exec_ram **

spawntemp equ $d748			;*256 7 bytes, temp space for reltrigger

;little space here

blackfield equ $d800
blackfield1 equ $d800		;*1k 1024 bytes each, to be copied into rayfield
blackfield2 equ $dc00
blackfield3 equ $e000
blackfield4 equ $e400


playerx equ $e800         	;*8 1 byte each, player coordinates
playery equ $e801
playersprite equ $e802    	;1 byte, player gfx (tabular)
playeranimframe equ $e803	;1 byte, offset from sprite
playercode equ $e804      	;1 byte, routine for object handling
playercode2 equ $e805      	;1 byte, similar
objlist equ $e808      		;*8 space for 31 objects, 8 bytes each
                       		; format: x,y,->gfx,ai type,response type, 2 arguments

objfreespace equ $e900		;*256 8 bytes of free space for each object (32)
playerhealth equ $e900
playerstun equ $e901
playerdir equ $e904			;1 byte, direction of the  player
playeranim equ $e905		;1 byte, animation counter
playerwindtime equ $e907	;1 byte, wind-up animation timer

tilemap equ $ea00       	;@@@ ** 112 bytes, space to decompress the tilemap

;game-related stuff here
gamevars equ $ea00+112
numobj equ gamevars+0      	;1 byte, number of objects
levelfile equ gamevars+1   	;9 bytes, name of the current level
animcount equ gamevars+10  	;1 byte, animation counter
screen equ gamevars+11     	;1 byte, which (small) map we're on
mapwidth equ gamevars+12   	;1 byte, width of the world map
curprof	 equ gamevars+13	;1 byte, proficiency in your current weapon
swordtimer equ gamevars+14	;1 byte, animation timer for the weapon
menubyte equ gamevars+15	;1 byte, draw menus on the left or right...
swordframes equ gamevars+16	;1 byte, number of animation frames for the weapon
swordstate equ gamevars+17	;1 byte, normally 0, non-0 if using weapon
maxhealth equ gamevars+18	;1 byte, total hit points...
redrawarmorflag equ gamevars+19	;1 byte, redraws health bar if non-0
redrawswordflag equ gamevars+20	;1 byte, redraws the sword icon if non-0
sworddir equ gamevars+21	;1 byte, sword direction
world equ gamevars+22 		;1 byte, current world in level file
pottimers equ gamevars+23	;10 bytes, timers for potions
maxburden equ gamevars+33	;1 byte, maximum burden (based on strength)
bdelaybase equ gamevars+34	;1 byte, animation delay for blackfield
bdelay equ gamevars+35		;1 byte, counter...
bframesbase equ gamevars+36	;1 byte, number of animation frames for blackfield
bframes equ gamevars+37		;1 byte, counter...
createtemp equ gamevars+38	;5 bytes, temporary space for character creation
plevel equ gamevars+43		;1 byte, character level
							;	also used as end-of-game flag
playerxp equ gamevars+44	;2 bytes, total xp
stdargs equ gamevars+46		;2 bytes, arguments carried to objects
savedesc equ gamevars+48	;2 bytes, -> description for save-game screen
lootseeds equ gamevars+50	;3 bytes, random seeds for random loot...
invselectpos equ gamevars+53
invbase equ gamevars+54		;1 byte each, inventory screen selector position

attribpoints equ gamevars+55		;1 byte, free points to apply to attributes

;** base attributes **
attribs equ gamevars+56		;physical attributes, 1 byte each
bstr equ attribs+0			;strength
bdex equ attribs+1			;dexterity
bcon equ attribs+2			;constitution
bper equ attribs+3			;perception

profpoints equ gamevars+60	;1 byte, free points to apply to proficiencies

;** proficiencies **
proficiencies equ gamevars+61		;1 byte for each
profshort equ proficiencies+0		;short sword proficiency
proflong equ proficiencies+1		;long sword proficiency
proftwo equ proficiencies+2			;two-handed sword...
profscim equ proficiencies+3		;scimitar...

;**stats**
stats equ gamevars+65		;your stats (modifiable by spells, skills, etc)
skill1 equ stats+0			;5 different attacks possible for each weapon
v_skill1 equ 0
skill2 equ stats+1			;  (which further modify stats)
v_skill2 equ 1
skill3 equ stats+2
v_skill3 equ 2
skill4 equ stats+3
v_skill4 equ 3
skill5 equ stats+4
v_skill5 equ 4
swordbase equ stats+5		;start frame
v_swordbase equ 5
swordnext equ stats+6		;# of frames to next (typ 1)
v_swordnext equ 6
stimerbase equ stats+7		;animation delay - higher=slower
v_stimerbase equ 7
sframesbase equ stats+8		;# of frames to draw
v_sframesbase equ 8
special1 equ stats+9		;code to execute after a swing
v_special1 equ 9
special2 equ stats+10		;and on a successful hit
v_special2 equ 10
pstr equ stats+11			;physical stats...
v_pstr equ 11
pdex equ stats+12
v_pdex equ 12
pcon equ stats+13
v_pcon equ 13
pper equ stats+14
v_pper equ 14
pwindup equ stats+15
v_pwindup equ 15
windframe equ stats+16		;attack windup animation (only 4*4 and 4*6 are valid)
v_windframe equ 16

;* player battle stats *	;more stats, but these are used in the battle engine
pabattlestats equ stats+20
patt equ pabattlestats+0	;attack rating
v_patt equ 20
pdamage equ pabattlestats+1	;how much damage per hit
v_pdamage equ 21
pcritrate equ pabattlestats+2	;minimum number for a critical hit
v_pcritrate equ 22
pcritmod equ pabattlestats+3	;multiplier for critical hits
v_pcritmod equ 23
pstuntime equ pabattlestats+4	;how long your enemy is stunned when hit...
v_pstuntime equ 24
ppushback equ pabattlestats+5	;how far to push the enemy back
v_ppushback equ 25
pdbattlestats equ stats+26
pshield equ pdbattlestats+0		;bonus to defesne from front
v_pshield equ 26
pdef equ pdbattlestats+1		;defense rating (armor like AD&D)
v_pdef equ 27
pdamreduct equ pdbattlestats+2	;damage is reduced by some amount
v_pdamreduct equ 28
pcritreduct equ pdbattlestats+3	;criticals are reduced by some amount (more=better protection)
v_pcritreduct equ 29
precoverytime equ pdbattlestats+4	;how fast you recover from a hit (more=slower, can be negative)
v_precoverytime equ 30

alicostable equ $eb00     	;*256 33 bytes, cosines

;space here

;interrupts at $ebeb!  ne touchez pas!

;** stuff in upper memory **
vectable equ $ed00        	;*256 257 bytes, im 2 vector table
                          	;interrupts also use 3 bytes at $ebeb-$ec??
intcounter equ $ee01      	;1 byte, used to control speed
romcall equ $ee02			;28 bytes, special rom call function...
keydata equ $ee02+28		;8 bytes, data from interrupt key handler
lightdata equ keydata+8		;@@@ -size varies- data for generating blackfield
newstack equ $ef00        	;*256 256 bytes, stack moved to here

;** equates **
walktile equ 18           	;tiles below this are walls
vistiles equ 15				;tiles below this block light
itemtypes equ 14			;types of items that can show up as loot
objecttypes equ 20			;number of objects to generate gfx for
run_token equ %10101010		;for the rle compressor ($AA)

;objfreespace format:
;0		hit points
;1		stun timer
;2		minor path counter
;3		major path counter
;4		direction
;5		animation counter
;6		count-down for shooter enemies, pause timer for fireballs,
;		flag for pathed enemies
;7		attack counter for enemies

;objlist format:
;0,1	coordinates
;2		graphic (table-form)
;3		animation offset
;4		ai
;5		response ai
;6,7	free space


.org $4002


    ;****************************
    ;* Initialize Program Stuff *
    ;****************************

	;** check if we were relocated **
	sbc a,a				;0 if nc, $ff if c				;$9f
	ld (relocflag+1),a									;$32

	call page1

    ;** move the stack **
    ld hl,$fb00
    ld de,newstack
    ld bc,256
    ldir
    ld h,(newstack-$fb00)/256           ;l=0
    add hl,sp
    ld sp,hl

	;** set up rom calls **
	ld hl,callrom
	ld de,romcall
	ld bc,endcallrom-callrom
	ldir

	;** generate sprites **
	;(won't be able to do this later as the data
	;is in _asm_exec_ram)
	ld hl,gfxgenlist
	ld b,objecttypes
genspritesloop:
		push bc
		ld e,(hl)
		inc hl
		ld d,(hl)
		inc hl
		push hl
		call $0033
		call genspritegfx24
		pop hl
		inc hl
		inc hl
		pop bc
		djnz genspritesloop

	ld hl,swordright
	ld de,swordgfx
	call genspritegfx48

	;** get ready for grayscale... **
	ld hl,$fc00
	ld de,$f800
	ld bc,1024
	ldir

    ;** set up interrupts **
    ld hl,vectable                      ;vector table starts here
    ld a,h
    ld i,a                              ;put table address in i
    ld b,1                              ;ld bc,256 -- c = 0
    ld d,h                              ;put vectable+1 in de
    ld e,b
    ld (hl),$eb                         ;table points to $ebeb
    ldir                                ;table is 257 bytes
    ld d,(hl)
    ld e,d                              ;ld de,$eeee
	ld hl,intcode
	ld c,endintcode-intcode
	ldir
    im 2                                ;tell calc to use im 2
    ei									;bload has a di...

afterdeath:
	;** make a note that the program is just starting **
	ld a,4
	ld (titleoptions),a


	;******************
	;** Title Screen **
	;******************

titlescreen:
	ld a,$f8
	ld (page+1),a

	;but...  isn't the picture already in _asm_exec_ram?!
	;can't you decompress it from there?!
	;NO!  the d86i routine only works from $8000 to $bfff

	call openloader
	ld de,titlepic-_asm_exec_ram+4
	add hl,de
	ld de,$f000
	call d86i
	call page1

	;***************************
    ;** generate table of gfx **
	;***************************
	;put this here cause it's needed for the text,
	;but it takes a second, so it should go after
	;the title picture
    ld hl,spritedata
    ld d,l
gengfx:
    ld c,0
    ld b,c
gfxloop:
      push bc
      ld b,d
      ld a,d
      or a
      jr z,notshifted
      xor a
shiftloop:
        srl c
        rra
        djnz shiftloop
notshifted:
      ld (hl),c
      inc h
      ld (hl),a
      dec h
      inc hl
      pop bc
      inc c
      djnz gfxloop
    inc h
    inc d
    ld a,d
    cp 8
    jr nz,gengfx


	;********************************
	;** Continue with title screen **
	;********************************

	call set_textplane_low
	xor a
	ld (startcol),a
	ld a,127
	ld (wrapcol),a
titleoptions equ $+1
	ld b,4
	call set_text_inverse
	ld hl,titletext
dotitletexts:
		push bc
		ld e,(hl)
		inc hl
		ld d,(hl)
		inc hl
		ld (_penCol),de
		call printwithwrap
		inc hl
		pop bc
		djnz dotitletexts
	call set_textplane_high
	call set_text_normal


	;***********************************
	;** Initialize more program stuff **
	;***********************************

    ;** generate mask table for findpixel **
	ld a,%01111111
	ld hl,alimasktable
createmasks:
		ld (hl),a
		rrca
		inc l
		jr c,createmasks

    ;** copy tangent and cosine tables for raycasting engine **
    ld a,(rendermode+1)
	or a
	call z,slowrendering
	call nz,fastrendering

    ;** generate routine that displays the screen **
    ld de,giantunrolledmess
    ld a,$08            ;ex af,af'
    ld (de),a
    inc de
    ld b,8
unrollloopout:
      push bc
      ld a,14
unrollloop:
        ld hl,combinecode
        ld bc,6
        ldir
        dec a
        jr nz,unrollloop
      ld hl,combinecode2
      ld c,6
      ldir
      pop bc
      djnz unrollloopout
    ld hl,combinecode3
    ld c,6
    ldir

    ;** generate routine that copies blackfield into rayfield **
    ld hl,unrolledldir
    push hl
    ld b,0
ldirloop:
      ld (hl),$ed
      inc hl
      ld (hl),$a0
      inc hl
      djnz ldirloop
    pop de
    ld (hl),$ea             ;jp pe
    inc hl
    ld (hl),e
    inc hl
    ld (hl),d
    inc hl
    ld (hl),$c9             ;ret


	;*****************************
	;** More Title Screen Stuff **
	;*****************************

	call waitrelease

	bit ex_asm_module,(iy+anumeditflgs)
	res ex_asm_module,(iy+anumeditflgs)
	jp nz,shellload

titlescreenloop:
	call burncheckkey
	push af
	call titleconkeys
	pop af
	cp K_EXIT
	jp z,quit
	sub K_F5
	jr z,continuegame
	dec a
	jr z,helpscreen
	dec a
	jp z,quit
	dec a
	jp z,loadfromtitle
	dec a
	jr z,startnewgame

	jr titlescreenloop

helpscreen:
	call loadblacklow
	call openloader
	ld de,helpdata-_asm_exec_ram+4
	add hl,de
	ld de,blackfield
	call decomptorayfield
	ld hl,rayfield-1
	ld b,19
	call displayhelp
	call loadblacklow
	ld hl,rayfield+helptext2-helptext1-1
	ld b,17
	call displayhelp
	jp titlescreen


continuegame:
	ld a,(titleoptions)
	cp 5
	jr c,titlescreenloop
	call rebuildstats
	call dographics
	call transition
	jr main

startnewgame:
	;** initialize gameplay stuff **
	call initgame

    ;***********************
    ;* --=< Main Loop >=-- *
    ;***********************
main:
    ;** deal with various counters **
    xor a
    ld (intcounter),a

	ld hl,redrawarmorflag
	ld a,(hl)
	or a
	jr z,noaredraw
	dec (hl)
	call z,drawarmoricon
noaredraw:

	ld hl,redrawswordflag
	ld a,(hl)
	or a
	jr z,nosredraw
	dec (hl)
	call z,drawswordicon
nosredraw:

	ld bc,10*256
	ld hl,pottimers
	ld de,potmods
potloop:
		ld a,(hl)
		or a
		jr z,nopotion
		dec (hl)
		jr nz,nopotion
			xor a
			ld (de),a
			ld c,1
nopotion:
		inc hl
		inc de
		djnz potloop
	dec c
	call z,potionoff

	;** check if player is dead **
	ld e,0
	call checkflag
	jp nc,playerdead

    ;** handle general key stuff **
	ld hl,keydata+6
    bit 6,(hl)			   		;check exit
    jp z,titlescreen
	call generalkeys

	in a,(3)
	bit 3,a
	call z,turnoff

    ;** handle object AI **
    ld de,playerx
    ld b,0
objloop:
    	push bc
    	push de
		ld hl,4
		ld b,h
		add hl,de
		ld a,(hl)
      add a,a
      ld c,a
      ld hl,ailist
      add hl,bc
      ld a,(hl)
      inc hl
      ld h,(hl)
      ld l,a
      call callhl
      pop hl
      ld bc,8
      add hl,bc
	  ex de,hl
      pop bc
      inc b
      ld a,(numobj)
      cp b
      jr nc,objloop

	;** check end of game condition **
	ld a,(plevel)
	inc a
	jp z,afterdeath

    ;** draw sprites, raycast, display screen **
    call dographics

	;** more counters **
    ld hl,animcount
    inc (hl)

	;** switch video buffers **
	call xorpage
	ld (page+1),a

    ;** regulate game speed **
regloop:
    ld a,(intcounter)
	;cheap frame rate counter
	;-----------------
	;	push af
	;	ld hl,123+(256*57)
	;	ld (_penCol),hl
	;	call displaya
	;	pop af
	;-----------------
    cp 15                       ;take a look at this later
    jp nc,main
    halt
    jr regloop


precalculate:
    ;******************
    ;* Precalculation *
    ;******************

    ;** load tilemap **
    call openworld
	in a,(6)
	push af
    ld de,15
    add hl,de
    ex de,hl
	ld a,(screen)
	ld l,a
    add hl,hl
    add hl,hl
    add hl,de
    push hl
    call loadptrde
    ld de,tilemap
	call d86i

	;* load lightsources *
	call loadlights

	;** generate collision map (no objects) **
	call docolmap

    ;** load objects **
    pop hl
	pop af
	out (6),a

    inc hl
	inc hl
    call loadptrde
	xor a
	ld (numobj),a
	ld a,(hl)
	ld (origobjs),a
	call loadobjects

    ;** generate clip field **
	;0=visible tile
	;-$a8=wall
	;$ff=clip boundary

    ld hl,clippadlow
    ld bc,16+1024+15            ;go through clippadlow, clipfield, clippadhigh
    call blacken

    ;write 8x8 white tiles where there are visible spots
    ld hl,clipfield+1
    ld de,tilemap
    ld b,8
cliploopout:
    push bc
    ld b,14
cliploop:
      push bc
      push hl
	  push de
      ld a,(de)
	  ld de,16
	  ld c,d
	  ld b,8
      cp vistiles
	  jr nc,ffloop
	  ld c,$100-$a8
ffloop:
        ld (hl),c
        add hl,de
        djnz ffloop
	  pop de
      pop hl
      pop bc
      inc hl
      inc de
      djnz cliploop
    ld c,2+(16*7)
    add hl,bc
    pop bc
    djnz cliploopout

	;** load tile graphics **
	call openloader
	ld de,tilegfx-_asm_exec_ram+4
	add hl,de
	ld de,blackfield			;not being used yet...
	call d86i
	call page1

    ;** draw fully-lit map **
	ld hl,litmapdark
	ld bc,2048
	call zerofill
	ld hl,tilemap+111
	ld d,8*7
drawlitmapv:
	ld e,8*14
drawlitmaph:
		push de
		push hl
		ld l,(hl)
		ld h,0
		add hl,hl
		add hl,hl
		add hl,hl
		add hl,hl
		ld bc,blackfield
		add hl,bc
		ld b,h
		ld c,l
		ld h,(litmapdark/256)/4
		call basicspriteh
		pop hl
		dec hl
		pop de
		ld a,e
		sub 8
		ld e,a
		jr nz,drawlitmaph
	ld a,d
	sub 8
	ld d,a
	jr nc,drawlitmapv

    ;** generate black field **
	jp doblackfield


gencolmap:
	;this originally did the collision map for all the
	;objects, but now it only needs to do the player...
    ld de,(playerx)
    call lookuptile
    ld (hl),0
	ld c,%00001111		;reset keys
	ret

setup:
	call rebuildstats
    call scrollcommon
	call gencolmap
	jp transition

    ;**********************
    ;* ~~~~ Routines ~~~~ *
    ;**********************

speciallist:
	;some specials take c as an object for input....
	;or de as the sword object...
	;note to self: the special list was a dumb idea
	.dw static
spec_fire equ 1
	.dw launchfire
spec_heal equ 2
	.dw restore2health
spec_reverse equ 3
	.dw reversesword


	;** turn calc off... **
turnoff:
	call offwait

	ld a,%00000001			;turn off lcd and timer ints
	out (3),a

	halt

offwait:					;wait till they let go of the on key
	ld bc,2500				;need to check that it's set consistently (key bounce?)
offwaitloop:
	in a,(3)
	bit 3,a
	jr z,offwait
	cpi
	ret po
	jr offwaitloop


	;** load and execute 'special' code from the level file **
	;code needs to be compressed
	;only $d748 to $e800 is writable
	;(maybe use text mem after that?)
docode:
	call openfile
	ld de,14
	ld b,d
	add hl,de
	call loadptrde
	ld a,(stdargs)
	ld c,a
	inc hl
	add hl,bc
	add hl,bc
	call loadptrde
	ld de,_asm_exec_ram
	call d86i
	call page1
	call _asm_exec_ram
	jp doblackfield


	;** replace an object's ai bytes and arguments **
	;(also sets up objfreespace)
	;(replaces the graphic too)
alterai:
	call loadargptr
	ld e,(hl)
	ld d,objlist/256
	call incptrhl
	push de
	inc e
	inc e
	ld a,(hl)
	ld (de),a
	inc e
	xor a
	ld (de),a
	ld b,4
alterailoop:
		inc e
		call incptrhl
		ld a,(hl)
		ld (de),a
		djnz alterailoop
	pop hl
	call initfreespace
	jp page1


	;** tell the main loop to end the game... **
endofgame:
	ld a,$ff
	ld (plevel),a
	ret


	;** routines to set normal or inverse text **
	;(more convenient than using iy anyway...)
set_text_inverse:
	ld a,$ae
set_text_logic:
	ld (blogic1),a
	ld (blogic2),a
	ret

set_text_normal:
	ld a,$b6
	jr set_text_logic


	;** routines for setting text output plane **
set_textplane_low:
	ld a,$f0/4
set_textplane:
	ld (textplane),a
	ret

set_textplane_high:
	ld a,$f8/4
	jr set_textplane


	;** routines for setting text box width **
set_box_wide:
	ld a,2
set_box_extend:
	ld (boxextend),a
	ret

set_box_normal:
	ld a,0				;don't want to affect flags
	jr set_box_extend


	;** replacement for _vputmap **
	;or/xor logic instead of overwrite, works with grayscale
rputmap:
	push bc
	push hl
	call romcall
	.dw _get_vchar
	in a,(6)
	push af
	call page1
	ld hl,_penCol
	ld bc,_charmap
	ld a,(bc)
	add a,(hl)
	ld (hl),a
	sub 8
	ld e,a
	inc hl
	ld d,(hl)
textplane equ $+1
	ld h,$f8/4
	call findpixel
	add a,a
	add a,spritedata/256
	ld d,a
	inc bc
	push bc
	ld a,6
	call bspriteloop
	ld bc,$3a0
	add hl,bc
	pop bc
	ld a,6
	call bspriteloop
	pop af
	out (6),a
	pop hl
	pop bc
	ret

	;** generate collision map (no objects) **
    ;$ff = clear tile
    ;1 = wall
    ;other = contains object
docolmap:
    ld hl,colbufferlow
    ld bc,160+16+15
    call blacken
    ld de,tilemap
    ld hl,colmap+17
    ld c,8
coltileloopout:
    ld b,14
coltileloop:
    ld a,(de)
    cp walktile
    jr nc,walkable
    ld (hl),1
walkable:
    inc e
    inc l
    djnz coltileloop
    inc l
    inc l
    dec c
    jr nz,coltileloopout
	ret

lighttrigger:
	push de
	call loadlightsources
	pop de
	jp removetotal

loadlightsources:
	call loadargptr
	call loadlights
	jp doblackfield

	;** loads light data from (hl) **
loadlights:
	ld de,lightdata
loadlightloop:
  	  call checkpage
	  ld a,(hl)
	  cp $fe
	  ldi
	  jr nz,loadlightloop
	jp page1

	;** generates black field **
	;(needs lightdata to be set)
doblackfield:
	xor a
	ld (bframesbase),a
	ld (bframes),a
    ld hl,lightdata
	ld b,a
	ld c,a
	ld a,(hl)
	cp $fe
	adc hl,bc
	ld (bdelaybase),a
	ld (bdelay),a
	ld de,blackfield1
blackloopout:
	push hl
	push de
    ld hl,rayfield
    ld bc,1023
    call blacken
	pop de
	pop hl
blackloop:
      ld a,(hl)
	  inc hl
	  cp $fe
	  jr c,dolightsource
	    push hl
		ld hl,bframesbase
		inc (hl)
		ld hl,rayfield
		ld bc,1024
		ldir
		pop hl
	  cp $fe
	  ret z
	  jr blackloopout
dolightsource:
	  push de
	  ld e,a
	  ld d,(hl)
	  inc hl
	  push hl
	  call raycast
	  pop hl
	  pop de
	  jr blackloop


shellload:
	call set_box_wide
	call loadblackscreen
	call setlowplane
	call romcall
	.dw _OP6TOOP1
	call loademup
	call set_box_normal
	jr loadcontinue

loadblacklow:
	ld hl,$f000
	jr endblackscreen

loadblackscreen:
	ld hl,$f800
endblackscreen:
	ld bc,2047
	jp blacken

	;** loads a saved game from the title screen **
loadfromtitle:
	call set_box_wide
	call loadblackscreen
	call loadstate
	call set_box_normal
loadcontinue:
	call page1
	jp c,titlescreen
	call rebuildstats
	jp main


	;** handles non-gameplay keys in the main loop **
generalkeys:
	;inputs: hl=keydata+6
	ld a,(hl)
	bit 7,a					;check more
	jp z,pause
	and %00011111			;check F-keys
	xor %00011111
	jp nz,fkeyhit

	dec l
	dec l
	bit 1,(hl)				;check 1
	jp z,pause
	bit 2,(hl)				;check 4
	jp z,pausealtstat
	bit 7,(hl)				;check x-var
	jp z,fastsave

	dec l
	bit 1,(hl)				;check 2
	jp z,pauseinv
	bit 2,(hl)				;check 5
	jp z,pausesave

	dec l
	bit 6,(hl)				;check custom
	jp z,rendermode
	bit 1,(hl)				;check 3
	jp z,pausestat

	dec l
	ld a,(hl)
	bit 6,a					;check clear
	jp z,quicksave
	rra
	rra						;check +
	jp nc,contrastup
	rra						;-
	jp nc,contrastdown
	rra						;*
	jp nc,graymix

	ret



    ;*****************************
    ;* Initialize Gameplay Stuff *
    ;*****************************
initgame:

	;** zero-fill game variables **
	ld hl,playerx
	ld bc,(256*3)-1
	call zerofill

#ifdef LEVEL_SELECTOR
    ;** find level files **
    xor a
    ld (numstrings),a
	ld (curstring),a
    ld hl,stringa
    rst 20h
    ld de,stringlist
findlevels:
    push de
    xor a
    call romcall
	.dw _findAlphaUp
    jr c,nomorelevels
    dec hl
    ld e,(hl)
    dec hl
    ld d,(hl)
    dec hl
    ld a,(hl)
    ex de,hl
	call romcall
    .dw _get_word_ahl
	call romcall
    .dw _get_word_ahl
    ld hl,'r'*256+$fe
    or a
	sbc hl,de
    pop de
    jr nz,findlevels
 	call page1
    ld hl,_OP1+1
    ld bc,9
    ldir
    ld hl,numstrings
    inc (hl)
    jr findlevels
nomorelevels:
    pop de
    call page1
    ld a,(numstrings)
    or a
    jp z,quitpop
    dec a
    jp z,onefile

	;** display level select screen **
	call romcall
	.dw _clrLCD
	inc bc
	ld (_penCol),bc
	ld hl,selecttext
	call printwithwrap
	ld hl,(256*57)+1
	ld (_penCol),hl
	ld hl,selecttext2
	call printwithwrap
	xor a
	call invert
	ld a,57
	call invert

	ld hl,(7*256)+1
	ld (_penCol),hl

	ld a,(numstrings)
	cp 8
	jr c,lessthan8
	ld a,8
lessthan8:
	ld b,a
	ld hl,stringlist-1
stringloop:
		push bc
  		push hl
		call openfilehl
		inc hl
		inc hl
		inc hl
		inc hl
		call loadptrde
		call printwithwrap
		call glnewline
		pop hl
		call page1
		ld bc,9
		add hl,bc
		pop bc
		djnz stringloop

	xor a
	ld (selector),a
	call invertbar

selectloop:
	call dupeall
	call keycheck
	ld de,curstring
	dec a
	push af
	call z,bardown
	pop af
	push af
	cp K_UP-1
	call z,barup
	pop af
	cp K_EXIT-1
	jp z,quitpop
	cp K_ENTER-1
	jr z,finishselect
	cp K_SECOND-1
	jr nz,selectloop
finishselect:



onefile:
	ld a,(curstring)
	ld c,a
	add a,a
	add a,a
	add a,a
	add a,c
	ld b,0
	ld c,a
	ld hl,stringlist
	add hl,bc
    ld de,levelfile
    ld c,9
    ldir

#else

	ld hl,blmapname
	ld de,levelfile
	ld bc,9
	ldir
#endif

    ;set player object handling routines to the right place...
    ld hl,$8000
    ld (playercode),hl

	;set initial xp needed
	ld a,100
	ld (playerxp),a

	;create random seeds for loot
	call reseedloot

	;** set default save-game description **
	call openfile
	ld de,12
	add hl,de
	call checkpage
	ld e,(hl)
	call incptrhl
	ld d,(hl)
	ex de,hl
	call page1
	ld (savedesc),hl

	;** wipe inventory **
	ld hl,inventory
	ld bc,115
	call zerofill

    ;** set up initial player sprite **
    ld a,object_player
    ld (playersprite),a

	;** character creation screen **
	ld hl,proficiencies
	ld bc,3
	call zerofill
	ld hl,attribs
	ld c,3
	ld (hl),4
	call fill

	ld a,16
	ld (attribpoints),a
	ld a,4
	ld (profpoints),a

	ld hl,$f000
	ld bc,4095
	call blacken

	call set_box_wide

	call attribscreen

	call profscreen

	call set_box_normal

	;** set initial weapon **
	ld b,4
	ld c,0
	ld hl,profscim
weaponselect:
		ld a,(hl)
		cp c
		jr c,weaponbad
			ld c,a
			ld a,b
			ld (swordtype),a
weaponbad:
		dec hl
		djnz weaponselect

	;** set initial inventory **
	ld hl,inventory
	ld (hl),item_herb

	;** draw side bar, find player stats, etc **
	call initworld

    ;** Precalculation **
	call setup
	jp introtext

	;*********************
	;*********************




	;*** rle compressor ***
rle:
	;inputs:	hl->uncompressed source
	;			de->compressed destination
	;			bc->uncompressed length
	;outputs:	hl preserved
	;			de->next byte after compressed destination
	;			ie/hl-de = compressed length

	;push de
rleloop:
	ld a,(hl)
	push bc
	push hl
	push de
	;* see how long this byte runs... *
	ld e,0
findrun:
		inc e
		jr z,longestrun		;nc
		cpi
		jp po,finalrun		;can't go past the end of the file...
		cp (hl)
		jr z,findrun
finalrun:
	ld a,e
	cp 4
longestrun:
	ld a,e
	pop de
	pop hl
	pop bc
	jr c,norun
	;* if over 3 bytes, encode a run *
		ex de,hl
		ld (hl),run_token
		inc hl
		ld (hl),a
		inc hl
		ex de,hl
		dec a
adjust:
			inc hl
			dec bc
			dec a
			jr nz,adjust
			jr normalbyte
norun:
	;* if the byte is the run token, we must encode it *
	ld a,(hl)
	cp run_token
	jr nz,normalbyte
		ex de,hl
		ld (hl),a
		inc hl
		ld (hl),1
		inc hl
		ex de,hl
normalbyte:
	ldi
	jp pe,rleloop
;	pop hl
;	ex de,hl
;	or a
;	sbc hl,de
	ret

	;** and decompressor **
derle:
	;inputs:	hl->compressed source
	;			de->uncompressed destination
	;			bc->uncompressed length
	;outputs:	hl->byte after compressed source
	;			de->byte after uncompressed destination
	;			bc=0

	call checkpage
	ld a,(hl)
	cp run_token
	jr z,decode
reenter:
		ldi
		ret po
		jr derle
decode:
	call incptrhl
	ld a,(hl)
	push af
	call incptrhl
	pop af
decodeloop:
	dec a
	jr z,reenter
	ldi
	dec hl
	jr decodeloop

burncheckkey:
	ld hl,$fc00
	ld bc,15
	push bc
	call blacken
	pop bc
	ld hl,$f800
	call blacken
	inc hl				;$f810
	ld bc,2048-16
	ld de,-16
burncheckkeyloop:
	call random
	or (hl)
	add hl,de
	and (hl)
	ld (hl),a
	sbc hl,de
	res 3,h
	ld a,(hl)
	set 3,h
	ld (hl),a
	cpi
	jp pe,burncheckkeyloop
	jp keycheck

displayhelp:
	call set_textplane_low
	call set_text_inverse
dhelploop:
	push bc
	inc hl
	ld e,(hl)
	inc hl
	ld d,(hl)
	inc hl
	ld (_penCol),de
	call printwithwrap
	pop bc
	djnz dhelploop
	call set_text_normal
	call set_textplane_high
	call waitrelease
helpwait:
	call burncheckkey
	jr z,helpwait
	ret


curse:
	;response that adds a spell/potion effect
	ld hl,(stdargs)
	;modifier first, then duration
	ld a,l
	ld b,h
	call addspell
	jp rebuildstats

setdesc:
	;sets the text in the save game screen
	ld hl,(stdargs)
	ld (savedesc),hl
	ret

opentable:
	;inputs:	hl->start of table
	;			a=entry #
	;ouputs:	hl=table data
	;preserves bc,de
	push bc
	ld c,a
	ld b,0
	add hl,bc
	add hl,bc
	pop bc
	jp $0033

callhl:
	jp (hl)

chain:
	;** loads multiple responses **
	push de
	call loadargptr
	pop de
	call incptrhl
	ld b,(hl)
	inc hl
chainloop:
		call doresponse
		inc hl
		inc hl
		inc hl
		djnz chainloop
jp_page1:
	jp page1

fcond:
	push de
	ld l,e
	ld h,objlist/256
	inc l
	call $0033
	call loadargptr2
	pop de
	jp flagemup

doresponse:
	call checkpage
	push de
	in a,(6)
	push af
	push hl
	push bc
	bit 6,(hl)
	jr z,noplayercheck
	ld a,d
	or a
	scf
	jr nz,noresponse
noplayercheck:
		ld a,(hl)
		bit 7,a
		jr nz,noresponse
		and %00111111
		push af
		call incptrhl
		ld c,(hl)
		call incptrhl
		ld b,(hl)
		ld (stdargs),bc
		call page1
		pop af
		ld hl,responseailist
		call opentable
		call callhl
noresponse:
	pop bc
	pop hl
	pop de				;must preserve f
	ld a,d
	out (6),a
	pop de
	ret

condition:
	;** executes a response, executes
	;	another if the first returns nc **
	;valid first responses:
	;	rai_opendoor - nc if animation complete
	;	rai_switch
	;	rai_giveloot - c if item was too heavy
	;	rai_givespec
	;	rai_condition - returns result of last response executed
	;	rai_conditionelse
	;	rai_checkitem - nc if item was found in inventory
	;	rai_chain - returns the result of the last response
	;	rai_keydoor - same as opendoor, plus c if you didn't have the key
	;	rai_givehealth - c if health was already full
	;	rai_checkflag - c if object is flagged (on)
	;	rai_checkother
	;	rai_link - returns result of the linked response
	;n.b. bits 6 (player-only) and 7 (no response) are taken into account

	call conditioncommon
dofirstone:
	call nc,doresponse
	jr jp_page1


conditionelse:
	;** similar to condition, but has a third
	;	routine to execute if the first returns
	;	c **

	call conditioncommon
	jr nc,dofirstone
	inc hl
	inc hl
	inc hl
	call doresponse
	jr jp_page1

conditioncommon:
	push de
	call loadargptr
	pop de
	inc hl					;first byte indicates flagged response
	call doresponse
	inc hl
	inc hl
	inc hl
	ret

takeitem:
	;** removes an item from the inventory **
	;you must check if the item exists!
	call checkitem
	ret c
	ld (hl),a				;a=0
	inc hl
	ld (hl),a
	inc hl
	ld (hl),a
	ret

checkitem:
	;** checks for object in inventory **
	;returns hl->item, a=0 if it was found

	call loadargptr
	ld c,(hl)
	call incptrhl
	ld d,(hl)
	call incptrhl
	ld e,(hl)
	call page1
checkcde:
	ld hl,inventory
	ld b,32
conditioncheck:
		push hl
		call checkforitem
		pop hl
		ret z				;z=nc
		inc hl
		inc hl
		inc hl
		djnz conditioncheck
	scf
	ret

checkforitem:
	ld a,(hl)
	cp c
	ret nz
	inc hl
	ld a,(hl)
	cp d
	ret nz
	inc hl
	ld a,(hl)
	sub e
	ret


	;******************************************
	;** this stuff was unused in the game, so
	;	it's commented out... **
	;******************************************
#if 0

firepath:
	;** pathed fireballs **
	call path
	ex de,hl
	or a
	ret z
	cp 2
	push hl
	call z,objattackna
	pop hl
	jp killobject

trackpath:
	;** pathed monsters, attack when close **
	ld a,6
	add a,e
	ld l,a
	ld h,objfreespace/256
	ld a,(hl)
	cp 17
	jp nc,aitrack
	push de
	push hl
	ld hl,(playerx)
	ex de,hl
	call $0033
	sbc hl,de
	ld a,h
	add a,12
	cp 24
	ld a,l
	pop hl
	pop de
	jr nc,turnpath
	add a,24
	cp 48
	jr nc,turnpath
	ld (hl),h
	ret

turnpath:
	;** path ai for rotatable objects **
	ld ix,rsavepathdir
	call pathcommon
	or a
	call z,animate2r
	ret

path:
	ld ix,savepathdir
	call pathcommon
	push af
	or a
	call z,animate2
	pop af
	ret

pathcommon:
	;** follows a pre-set path **
	push de
	ld hl,2+(256*1)
	add hl,de
	push hl
	push de
	ld a,(hl)
	or a
	push hl
	call z,resetpathcounters
	call page1
	pop hl
	inc l
	inc l
	ld a,(hl)
	call loadmove
	inc l
	inc l
	ld a,(hl)
	sbc hl,hl
	or a
	jr z,nopathmove
pathaddloop:
			add hl,bc
			dec a
			jr nz,pathaddloop
nopathmove:
	ld c,l
	ld b,h
	pop hl
	call move
	pop hl
	pop de
	or a
	ret nz
	dec (hl)
	ret

resetpathcounters:
	push hl
	ld de,4-(1*256)
	add hl,de
	ld a,(hl)
	ld de,13
	call loadworlddata
	pop de
	push de
	inc e
	ld a,(de)
	cp (hl)
	inc a
	jr c,keepmajorpath
		ld a,1
keepmajorpath:
	ld (de),a
	dec a
	ld c,a
	ld b,0
	inc hl
	add hl,bc
	add hl,bc
	add hl,bc
	call checkpage
	ld a,(hl)
	inc hl
	inc e
	inc e
	inc e
	ld (de),a
	pop de
	call checkpage
	ld a,(hl)
	ld (de),a
	call incptrhl
	ld a,(hl)
	jp (ix)

savepathdir:
	inc e
	inc e
	ld (de),a
	ret

rsavepathdir:
	dec e
	dec e
	jp savedirection

#endif

	;****************************
	;** end of removed section **
	;****************************

delay:
	;like spawnform, but no animation...
	ld hl,6
	add hl,de
	call $0033
	ld a,(de)			;/real/ sneaky stuff here
	ex de,hl
	inc h
	inc l				;byte 0 is health, non-zero
	inc (hl)
	cp (hl)
	ret nz
	dec h
	dec l
	jr transfigure

spawnform:
	;** for temporary objects ONLY **
	push de
	call animate4
	pop de
	ret nz				;animate4 returns z after one cycle
	ld hl,6				;get ->data for new object
	add hl,de
	call $0033
	ex de,hl
transfigure:
	push de
	call killobject		;remove old object
	pop hl
	call loadargptr2
	ld a,d
	or e
	jp z,page1			;allow for null spawns
	ld b,1
	jp loadobjloop		;create new object

	;for ethereal objects: ai that calls response ai's
	; when objects move underneath
	;!do not use trigger with this!
	;!use nfsolidtrigger instead!
airespond:
	call airespcommon
	jr nz,endairesp
airespexec:
	ld a,(animcount)
	and c
	call z,doresponse		;has a checkpage at the start
endairesp:
	jp page1

airespcondition:
	;similar to above, but calls an alternate response
	;if no object was present
	call airespcommon
	jr z,airespexec
	inc hl
	inc hl
	inc hl
	jr airespexec

airespalways:
	;calls responses continuously
	;a bit hackish...
	ex de,hl
	call airespnocheck
	jr airespexec

airespcommon:
	;returns z if object was present, c=timer value
	ex de,hl
	call checkbymove
airespnocheck:
	push af
	ld de,5
	add hl,de
	ld e,l
	ld d,b
	push de
	inc l
	call $0033
	call loadargptr2
	pop de
	ld c,(hl)
	pop af
	inc hl
	ret

checkbymove:
	;checks for objects underneath other (ethereal) objects
	;z if there was one
	push hl
	ld bc,0
	call move
	pop hl
	cp 2
	ret

cloudkill:
	push de
	call animate4
	inc hl
	inc hl
	inc hl
	rrc (hl)
	pop hl
	ret nc
	call checkbymove
	ret nz
	call cloudloadatt
	jp objattackloaded

attribscreen:
	ld hl,attribpoints
	ld de,createtemp
	ld bc,5
	ldir
createattribs:
	call findpstats
	ld bc,attribstext
	ld de,attribpoints
	ld hl,checkbuffs
	ld a,12
	call createbox
	cp K_SECOND
	jr z,jpss
	cp K_EXIT
	jr z,jpss
	jr createattribs

profscreen:
	ld hl,profpoints
	ld de,createtemp
	ld bc,5
	ldir
createprofs:
	ld bc,proftext
	ld de,profpoints
	ld hl,static
	ld a,26
	call createbox
	cp K_SECOND
	jr z,jpss
	cp K_EXIT
jpss:
	jp z,storestats
	jr createprofs

givexp:
	ld a,(odaddress)
	add a,7
	ld l,a
	ld h,objlist/256
	ld a,(hl)
	add a,5
	add a,a
	ld c,a
	ld b,0
	ld hl,(playerxp)
	sbc hl,bc
	jr nc,nolevelup
		ex de,hl
		ld hl,profpoints
		inc (hl)
		inc (hl)
		ld hl,attribpoints
		inc (hl)
		ld hl,plevel
		ld a,(hl)
		inc (hl)
		ld hl,xptable
		call opentable
		add hl,de
nolevelup:
	ld (playerxp),hl
	ret


reversesword:
	ld hl,swordframes
	ld de,swordnext
	ld a,(hl)
	dec a
	ret nz
	ld a,(de)
	neg
	ld (de),a
	ret p
	ld a,(sframesbase)
	ld (hl),a
	ret

executespecial:
	ld hl,speciallist
	call opentable
	jp (hl)

launchfire:
	ex de,hl
	ld e,(hl)
	inc l
	ld d,(hl)
	call initshot
	call makeobject
	ret c
	inc l
	inc l
	ld a,(sworddir)
	ld c,a
	ld a,(plevel)
	rra
	ld b,a
	jr setshotdata

rtrackandshoot:
	ld hl,7+(256*1)
	add hl,de
	ld a,(hl)
	or a
	jr nz,rshooter
	call random
	dec h
	dec l
	cp (hl)
	jp nc,aitrack

rshooter:
	call shootermain
	ret c
	ld a,c
	rra
	add a,object_gooballright
	ld (hl),a
	inc l
	inc l
	ld (hl),$80+ai_shootr
	jr shooterend

trackandshoot:
	;wanders around, shoots at you
	;with a probability determined by
	;stdargs
	ld hl,7+(256*1)
	add hl,de
	ld a,(hl)
	or a
	jr nz,shooter
	call random
	dec h
	dec l
	cp (hl)
	jp nc,aitrack

shooter:
	call shootermain
	ret c
setshotdata:
	ld (hl),object_fireball
	inc l
	inc l
	ld (hl),$80+ai_shoot
shooterend:
	inc l
	ld (hl),$80
	inc l
	ld (hl),c
	inc l
	ld (hl),b
	ret

shootermain:
	call checkstun
	scf
	ret nz
	push de
	call facer			;outputs e=object+4
	pop hl
	call attackanim
	ret c
	ld e,(hl)
	inc l
	ld d,(hl)
	inc l
	inc l
	inc l
	inc h
	ld c,(hl)
	dec h
	inc l
	inc l
	inc l
	ld b,(hl)				;inherit battle stats from monster
	ld a,c
	ld hl,spawntable
	call opentable
	add hl,de
	ex de,hl
	call initshot
	push bc
	call makeobject
	pop bc
	inc l
	inc l
	ret

initshot:
	ld hl,shotdata
	push hl
	ld (hl),e
	inc l
	ld (hl),d
	inc l
	inc l
	ld (hl),$80				;needs to be marked ethereal before spawning
	pop hl
	ret

facer:
	;* faces towards the player *
	;(this REALLY needs cleaning up)
	ld hl,(playerx)
	ld b,1				;start out as up-right
	ld a,(de)
	sub l
	ld l,a
	jr c,shootright
	ld b,3				;switch to up-left if player is to the left
shootright:
	inc e
	ld a,(de)
	sub h
	ld h,a
	jr nc,shootup
		ld a,8			;switch to down-right or down-left if
		sub b			;appropriate
		ld b,a
shootup:
	bit 7,h				;get absolute values of
	jr z,hplus			;the relative coordinates
		ld a,h
		neg
		ld h,a
hplus:
	bit 7,l
	jr z,lplus
		ld a,l
		neg
		ld l,a
lplus:
hlmagloop:				;see which has more digits...
		srl h
		srl l
		ld a,h
		and l
		jr nz,hlmagloop
	ld a,h
	cp l
	jr z,hlmagdone		;if equal magnitudes, we're done
	jr nc,vdominant
		ld a,b			;if x-coord is much greater...
		inc a			;change to either left or right
		and %00000100
		ld b,a
		jr hlmagdone
vdominant:
		ld a,b			;if y-coord is much greater...
		and %00000100	;change to either up or down
		add a,2
		ld b,a
hlmagdone:
	dec e
	ld a,b
	jp savedirection

reltrigger:
	;** spawn relative to a give object **
	;** this routine is a total hack! **
	;format is:
	;rel coords
	;object data from object_X onwards
	;number*8 of object to spawn near

	call loadargptr
	ld de,spawntemp
	push de
	ld b,7
	call objcopy
	call checkpage
	ld l,(hl)
	ld h,objlist/256
	;* note for later: maybe use a single 16-bit add instead?
	ld a,(hl)
	inc l
	ld b,(hl)
	pop hl
	add a,(hl)
	ld (hl),a
	inc l
	ld a,b
	add a,(hl)
	ld (hl),a
	dec l
	call page1
	ld de,shotdata
	push de
	ld bc,7
	ldir
	pop hl
	ld b,1
	jr loadobjloop

solidtrigger:
	call loadargptr
	jr loadobjects

trigger:
	;* spawns temporary solid objects *
	push de
	call loadargptr
	call loadobjects
	pop de
	jp removetotal

loadobjects:
    ld a,(hl)
	or a
	jr z,endloadobj
	ld b,a
	inc hl
loadobjloop:
		in a,(6)
		ld c,a
		push bc
		push hl
		call makeobject
		pop hl
		ld de,7
		add hl,de
		pop bc
		ld a,c
		out (6),a
		djnz loadobjloop
endloadobj:
	jp page1

loadargptr:
	ld hl,(stdargs)
loadargptr2:
	push hl
	call openfile
	pop de
	add hl,de
	jp checkpage

shoot:
	;* for temporary objects only *
	call shootmain
	ret c
	jp z,animate2
	call shootmain2
	ld (hl),2
shootend:
	inc l
	ld (hl),$80+ai_dying
	inc l
	inc h
	ld (hl),6
	ret

shootr:
	;* for temporary objects only *
	;rotatable version
	call shootmain
	ret c
	jp z,animate2r
	call shootmain2
	ld (hl),2*4
	jr shootend

shootmain:
	ld a,6
	add a,e
	ld l,a
	ld h,objfreespace/256
	inc (hl)
	ld a,(hl)
	cp 2
	ret c
	ld bc,0
	push de
	jr z,shootstill
	ld h,d
	ld a,(hl)
	call loadmove
	rl c
	rl b
shootstill:
	ex de,hl
	call move
	or a
	pop de
	ret

shootmain2:
	ex de,hl
	cp 2
	push hl
	call z,shootattack
	pop hl
	inc l
	inc l
	inc l
	ret

shootattack:
	call shootloadatt
	jp objattackloaded

introtext:
	call openworld
	ld de,11
gettextstring:
	add hl,de
	call checkpage
	ld a,(hl)
	cp $ff
	jp z,page1
	jp showstring

extrotext:
	call openworld
	ld de,12
	jr gettextstring

pushblock:
	ld a,d
	add a,5
	ld l,a
	ld h,objlist/256
	ld d,h
	ld a,(hl)
	cp rai_pushblock
	ret z					;blocks shouldn't push other blocks
	dec l
	bit 7,(hl)
	ret nz					;ethereal objects shouldn't push either

	inc d					;set up a counter so they don't react instantly
	ex de,hl
	ld b,(hl)
	ld a,(animcount)
	ld (hl),a
	inc l
	dec a
	cp b
	ld a,(hl)
	ld (hl),0
	ret nz
	inc a
	ld (hl),a
	cp 3
	ret c

	inc d
	dec l
	dec l
	ld a,(de)
	ld (hl),a
	dec h
	ld (hl),ai_pushblock
	ret

blockai:
	ld hl,256+4
	add hl,de
	ld a,(hl)
	push af
	call loadmove
	ex de,hl
	push hl
	call move
	pop hl
	pop bc
	ld e,(hl)
	inc l
	ld d,(hl)
	ld a,b
	and %11111011
	jr z,noyalign
	ld a,d
	and %00000111
	jr z,alignblock
	ld a,b
	and %11111001
	ret z
noyalign:
	ld a,e
	and %00000111
	ret nz
alignblock:
	inc l
	inc l
	inc l
	ld (hl),ai_static
	ret

setlowplane:
	ld a,(page+1)
setlowplane2:
	ld h,a
	xor %00001000
	ld d,a
	ret po
	ld (page+1),a
	ld bc,2048
	ld l,c
	ld e,c
	ldir
	ret

findweight:
	ld hl,inventory
	ld b,35				;includes swordtype, shieldtype, armortype
	xor a
	ld d,a
findweightloop:
		push hl
		ld e,(hl)
		ld hl,itemweights
		add hl,de
		add a,(hl)
		pop hl
		inc hl
		inc hl
		inc hl
		djnz findweightloop
	ret

storestats:
	ld hl,createtemp
	ld bc,5
	ldir
	ret

checkbuffs:
	ld a,b
	cp 5
	ret nc
	ld a,(hl)
	ld de,pstr-createtemp-1
	add hl,de
	cp (hl)
	ret nc
	ld a,69
	ld (_penCol),a
	ld a,(hl)
	push af
	ld hl,brackets
	call printwithwrap
	ld a,76
	ld (_penCol),a
	pop af
	call displaya
	ret

brackets:
	.db "(        )",0

createbox:
	ld (createcustom),hl
	ld (crmax),a
	push de
	push bc
	call waitrelease
	call drawbox
	pop hl
	ld de,creationcoords
	ld b,5
createscreen:
		push bc
		push de
		ld a,18
		ld (_penCol),a
		ld a,(de)
		ld (_penRow),a
		call printwithwrap
		pop de
		inc de
		inc hl
		pop bc
		djnz createscreen
	ld hl,createtemp
	ld de,creationcoords
	ld b,5
createscreen2:
		push bc
		push de
		push hl
		ld a,(de)
		ld (_penRow),a
		push hl
createcustom equ $+1
		call 0
		pop hl
		ld a,88
		ld (_penCol),a
		ld a,(hl)
		call displaya
		pop hl
		pop de
		pop bc
		inc de
		inc hl
		djnz createscreen2
	ld bc,pointleftD
crcurpos:
	ld de,0
	ld hl,creationcoords+1
	add hl,de
	ld d,(hl)
	inc d
	ld e,92
	call basicsprite
	call boxcopy
	pop de

createcontrol:
	push de
	call keycheck
	pop de
	ld hl,crcurpos+1
	ld bc,createtemp
	cp K_SECOND
	ret z
	cp K_EXIT
	ret z
	dec a
	jr z,crkeydown
	dec a
	jr z,crkeyleft
	dec a
	jr z,crkeyright
	dec a
	jr z,crkeyup
	jr createcontrol

crkeyright:
	ld a,(bc)
	dec a
	ret m
	ld l,(hl)
	ld h,0
	add hl,bc
	inc hl
	ld a,(hl)
crmax equ $+1
	cp 12
	ret nc
	inc a
	ld (hl),a
	ld a,(bc)
	dec a
	ld (bc),a
	ret

crkeyleft:
	ld l,(hl)
	ld h,0
	add hl,de
	inc hl
	ld a,(hl)
	sbc hl,de
	add hl,bc
	cp (hl)
	ret nc
	dec (hl)
	ld a,(bc)
	inc a
	ld (bc),a
	ret

crkeyup:
	ld a,(hl)
	dec a
	ret m
	ld (hl),a
	ret

crkeydown:
	ld a,(hl)
	inc a
	cp 4
	ret nc
	ld (hl),a
	ret

dupeall:
	ld hl,$fc00
	ld bc,16+(256*64)
	jp dupegfx

	;** handle contrast on the title screen **
titleconkeys:
	sub K_PLUS
	jr z,contrastup
	dec a
	jr z,contrastdown
	dec a
	ret nz

	;** switch mixing ratio - 1:2 or 2:3 **
graymix:
	ld hl,grayratio
	ld a,(hl)
	xor %00011100
	ld (hl),a
	ld hl,grayratiosave
	jr jpwaitrelease

	;** contrast-related routines **
contrastup:
	ld a,1
	jr contrastmain
contrastdown:
	ld a,-1
contrastmain:
	ld hl,$c008
	add a,(hl)
	ret m
	cp $20
	ret nc
jpwaitrelease:
	ld (hl),a
	jp waitrelease


restore2health:
	ld de,db2
	jr givehealthend

	;** restore player health **
givehealth:
	ld de,stdargs
givehealthend:
	ld hl,playerhealth
	ld a,(de)
	add a,(hl)
	ld e,a
	ld a,(maxhealth)
	cp (hl)
	scf
	ret z
	ld (hl),a
	cp e
	jr c,healthhitmax
	ld (hl),e
healthhitmax:
	jp updatehealth

	;** clear potion-related effects **
potionoff:
	call findpstats
	jp drawsidebar

	;** initialize world-related gameplay items **
initworld:
	call randomizeloot

    ;** get start postition (etc) from file **
	call openworld
	ld b,4
    ld de,savelist
fileloop:
      call incptrhl
	  ld c,(hl)
	  push de
      ex de,hl
      call $0033
	  ld (hl),c
	  ex de,hl
      pop de
      inc de
	  inc de
      djnz fileloop

	;** load enemy graphics **
	call initenemies

	;** set all objects to 'on' **
	ld hl,objflags
	ld bc,1023
	jp blacken

initenemies:
	;** load enemy graphics **
	call openworld
	ld de,4
	add hl,de
	ld b,e
enemload:								;put each enemy type on the stack...
		call incptrhl
		ld e,(hl)
		push de
		djnz enemload

	ld de,enemy4
	ld a,4
doenemies:
		ex af,af'
		push de
		call openloader
		ld de,enemytable-_asm_exec_ram+4
		add hl,de						;go to the table of gfx pointers...
		pop de
		pop bc							;get which graphic to use
		push de
		add hl,bc
		add hl,bc
		call loadptrde					;get it's address from the table and go there
		ld de,blackfield				;decompress into unused (for now) space
		push de
		call d86i
		pop hl
		pop de

		call page1
		ld b,6
enemgen:
			push bc
			push hl
			call genspritegfx24
			ex de,hl
			pop hl
			ld bc,24
			add hl,bc
			pop bc
			djnz enemgen
		ld hl,-96*6*2
		add hl,de
		ex de,hl
		ex af,af'
		dec a
		jr  nz,doenemies
	ret

	;** randomize loot **
randomizeloot:
	ld a,(lootseeds)
	ld (randoseed1),a
	ld hl,(lootseeds+1)
	ld (randoseed2),hl
	ld hl,lootlist
	ld b,l
randoloot:
	call random
	ld (hl),a
	inc l
	djnz randoloot
	ret

	;* create new random seeds for loot list *
reseedloot:
	ld b,3
	ld hl,lootseeds
reseedlootloop:
	call random
	ld (hl),a
	inc hl
	djnz reseedlootloop
	ret

	;** advance to next level **
advance:
	call reseedloot
	call extrotext
	ld a,(stdargs)
	ld (world),a
	call initworld
	call setup
	jp introtext

	;** display text once only **
onetext:
	push de
	call text
	pop de
	jp removetotal

	;** code for when player hits an F-key **
fkeyhit:
	ld hl,skill5+1
fkeyloop:
	dec hl
	rra
	jr nc,fkeyloop
	ld a,(hl)
	or a
	ret z
	ld (skilltype),a
	jp findpstats

	;** gives a specific item as loot **
givespec:
	push de
	call loadargptr
	ld a,(hl)
	ld (typesave+1),a
	call incptrhl
	ld a,(hl)
	ld (mod1save+1),a
	call incptrhl
	ld a,(hl)
	ld (mod2save+1),a
	call page1
	jr lootset


	;** really complex loot generator **
giveloot:
	push de

	;* load loot index *
	;each chest is constant but unique...
	ld hl,(stdargs)
	ld c,h				;loot level
	ld h,lootlist/256

	;* load item type *
	ld a,(hl)
pickitemtype:
	sub itemtypes
	jr nc,pickitemtype
	add a,itemtypes+1
	ld (typesave+1),a

	;* load modifiers *
	inc l
	ld b,(hl)			;randomly generated mods...
	ld e,a
	xor a
	ld d,a
	ld hl,itemoffsets1-1
	add hl,de
	bit 5,b
	jr z,nofirstmod
	cp (hl)				;see if (hl) is 0
	jr z,nofirstmod
	ld a,b
	and %00000011
	add a,c
	add a,(hl)
nofirstmod:
	ld (mod1save+1),a
	ld hl,itemoffsets2-1
	add hl,de
	ld a,e
	cp gumodobj
	ld a,d
	jr nc,guaranteemod
	bit 4,b
	jr z,nosecondmod
guaranteemod:
	cp (hl)
	jr z,nosecondmod
	ld a,b
	rrca
	rrca
	and %00000011
	add a,c
	add a,(hl)
nosecondmod:
	ld (mod2save+1),a

	;* print "you found:" *
lootset:
	call drawbox
	ld hl,getloottext
	call printwithwrap
	call glnewline

	;* print prefix modifier *
mod1save:
	ld a,0
	call printmod

	;* print item type *
typesave:
	ld a,0
	call printmod

	;* print suffix modifier *
mod2save:
	ld a,0
	call printsuffmod

	call glnewline

	;* check if item is too heavy *
	call findweight
	ld b,a
	ld a,(maxburden)
	ld c,a
	ld hl,(typesave+1)
	ld h,0
	ld de,itemweights
	add hl,de
	ld a,(hl)
	add a,b
	inc c
	cp c
	jr nc,itemtooheavy

	;* search for free pack space *
	call searchpack
	jr nc,foundfreeinv
		ld hl,packfulltext
		call printwithwrap
		pop de
		jr endgiveloot

	;* store new item in pack *
foundfreeinv:
	ld a,(typesave+1)
	ld (hl),a
	inc hl
	ld a,(mod1save+1)
	ld (hl),a
	inc hl
	ld a,(mod2save+1)
	ld (hl),a

	;* mark chest as opened *
	pop hl
	call markopened
	jp boxcopyandwait					;nc

endgiveloot:
	call boxcopyandwait
	scf
	ret

markopened:
	ld h,objlist/256
	ld (hl),$80
	ld e,l
	jp unflagobject

itemtooheavy:
	ld hl,tooheavytext
	call printwithwrap
	pop de
	jr endgiveloot

tooheavytext:
	.db "...but it's too heavy",0

searchpack:
	xor a
searchpacka:
	ld hl,inventory-3
	ld b,32
findfreeinv:
		inc hl
		inc hl
		inc hl
		cp (hl)
		ret z
		djnz findfreeinv
	scf
	ret

printsuffmod:
	or a
	push af
	ld hl,oftext
	call nz,printwithwrap
	pop af
	jp printmod

printwithwrap:
	call checkwrap
printwwloop:
	call checkpage
	ld a,(hl)
	cp $20
	call z,checkwrap
	ld a,(hl)
	or a
	ret z
	cp $fe
	ret nc
	call rputmap
	inc hl
	jr printwwloop

checkwrap:
	push hl
	ld a,(_penCol)
	ld b,a
checkwraploop:
	push bc
	push hl
	ld a,(hl)
	call romcall
	.dw _get_vchar
	ld a,(_charmap)
	pop hl
	pop bc
	add a,b
	ld b,a
	inc hl
	ld a,(hl)
	cp $20
	jr z,completeword
	cp $fe
	jr nc,completeword
	or a
	jr nz,checkwraploop
completeword:
	pop hl
	ld a,b
wrapcol equ $+1
	cp 0
	ret c
	call glnewline
skipspaces:
	ld a,(hl)
	cp $20
	ret nz
	inc hl
	jr skipspaces

glnewline:
	push hl
	ld a,(_penRow)
	add a,6
	ld h,a
startcol equ $+1
	ld l,18
	ld (_penCol),hl
	pop hl
	ret

extmodtext:
	sub (modtexts-modifiertab)/2
	ld c,a
	ld b,0
	push bc
	call openfile
	ld de,8
	add hl,de
	call loadptrde
	inc hl
	pop bc
	add hl,bc
	add hl,bc
	call loadptrde
	jr modtextloaded

printmodhl:
	ld a,(hl)
printmod:
	or a
	ret z
	push hl
	cp ((modtexts-modifiertab)/2)+1
	jr nc,extmodtext
	ld hl,modtexts-2
	call opentable
modtextloaded:
	call printwithwrap
	ld hl,spacetext
	call printwithwrap
	pop hl
	jp page1

packfulltext:
	.db "...but your pack is full",0
getloottext:
	.db "You found:",0
oftext:
	.db "of"
spacetext:
	.db " ",0

pause:
	call skillmenu
	call checkjump
pauseinv:
	call invmenu
	call checkjump
pausestat:
	call statmenu
	call checkjump
pausealtstat:
	call altstatmenu
	call checkjump
pausesave:
	call savemenu
	call checkjump


endmenu:
	jp waitrelease

checkjump:
	call rebuildstats
	;note for later -- consider a table here if more menus are added
	pop hl					;I hate using pops just to alter the stack :(
	cp K_1
	jr z,pause
	cp K_2
	jr z,pauseinv
	cp K_3
	jr z,pausestat
	cp K_4
	jr z,pausealtstat
	cp K_5
	jr z,pausesave
	cp K_exit
	jr z,endmenu
	jp (hl)

rebuildstats:
	push af
	ld a,5
	ld (titleoptions),a
		call findpstats
		ld a,(skilltype)
		ld bc,5
		ld hl,skill1
		ld d,(hl)
		or a
		jr z,mustsetskill
		cpir
		jr z,skillisok
mustsetskill:
		ld a,d
		ld (skilltype),a
		call findpstats
skillisok:
	call drawsidebar
	pop af
	ret

savemenu:
	call thinbox

	ld hl,saveprompt
	call printwithwrap
	call glnewline
	ld hl,loadprompt
	call printwithwrap
	call glnewline

	call glnewline
	ld hl,(savedesc)
	call loadargptr2
	call printwithwrap
	call page1
	ld a,$f8
	call setlowplane2
	call waitrelease
savekeyloop:
	call keycheck
	jr z,savekeyloop
	call check123
	ret z
	call checkfkeys
	call page1
	call dographics
	call drawsidebar
	jr savemenu

checkfkeys:
	cp K_F1
	jp z,savestate
	cp K_F2
	jr z,loadstate
	ret

loadstate:
	ld hl,stringa
	rst 20h

	call drawbox			;don't take this out :P
	call searchsaveup
	ld hl,nossfiles
	call c,printwithwrap
	call boxcopy

lskeyloop:
	call keycheck
	cp K_EXIT
	scf
	ret z
	cp K_ENTER
	jr z,loademup
	cp K_SECOND
	jr z,loademup
	push af
	cp K_DOWN
	call z,searchsaveup
	pop af
	cp K_UP
	call z,searchsavedown
	jr lskeyloop

loademup:
	rst 10h
	ret c
	call loadahl
	inc hl
	inc hl
	inc hl
	inc hl
	ld de,$f800				;objflags first
	ld bc,1024
	push de
	push bc
	call derle
	ld bc,512				;then objlist (to $fc00)
	call derle
	ld c,116				;then inventory (to $fe00)
	push de
	push bc
	call derle
	ld de,gamevars			;and the gamevars
	ld c,65
	call derle
	call page1
	pop bc
	pop hl
	ld de,inventory
	ldir
	pop bc
	pop hl
	ld de,objflags
	ldir

	ld hl,levelfile-1
	rst 20h
	rst 10h
	ret c

	ld a,(numobj)
	push af

	call initenemies
	call randomizeloot
	call precalculate			;reloads (numobj)

	ld hl,$fc00
	ld de,playerx
	ld bc,512
	ldir

	pop af
	ld (numobj),a

	call docolmap
	;this replaces gencolmap
	ld a,(numobj)
	inc a
	ld b,a
	ld hl,playerx
loadcolmap:
		push hl
		ld c,l
		ld e,(hl)
		inc l
		ld d,(hl)
		inc l
		inc l
		inc l
		bit 7,(hl)
		jr nz,lcmeth
		call lookuptile
		ld (hl),c
lcmeth:
		pop hl
		ld de,8
		add hl,de
		djnz loadcolmap

	call drawbox
	ld hl,loadconfirm
	call printwithwrap
	call boxcopyandwait
	call dographics
	call transition
	or a
	ret

searchsaveup:
	ld hl,_findAlphaUp
	jr searchsavemain

searchsavedown:
	ld hl,_findAlphaDn

searchsavemain:
	ld (sscall),hl
	call waitrelease
	call romcall
	.dw _op1toop6
ssloop:
	xor a
	call romcall
sscall:
	.dw _findAlphaDn
	jr nc,ssfound
		call romcall
		.dw _op6toop1
		ret
ssfound:
	call rstloadahl
	inc hl
	call incptrhl
	ld a,(hl)
	cp $fe
	jr nz,ssloop
	call incptrhl
	ld a,(hl)
	cp 's'
	jr nz,ssloop

	call ssbox

	ld hl,_OP1+1
	ld b,(hl)
rputsn:
		inc hl
		ld a,(hl)
		call rputmap
		djnz rputsn

	call boxcopy
	or a
	ret

ssbox:
	call drawbox
	ld hl,loadrequest
	call printwithwrap
	jp glnewline

nossfiles:
	.db "no saved games found",0
loadrequest:
	.db "File?  [",6,7,"]",0	;6 and 7 are the up and down arrows...
loadconfirm:
	.db "game loaded",0
quickfile:
	.db 7,"qiksave"

fastsave:
	call setlowplane
	call savequickly
	call page1
	call drawsidebar
	jr savemessage

quicksave:
	call savequickly
	jp quitpop

savequickly:
	ld hl,quickfile-1
	rst 20h
	rst 10h
	jr c,qsnotexist
		call romcall		;overwrite without asking
		.dw _delvar
qsnotexist:
	jr savestatemain		;if it failed, tough

savestate:
	call drawbox
	ld hl,saverequest
	call printwithwrap
	call glnewline
	ld a,8
	call inputtext			;has a boxcopy in it
	ret c
	call texttoop1
	rst 10h
	jr c,filenotexist
		call glnewline
		ld hl,overwriteconf
		call printwithwrap
		call boxcopy
overwriteloop:
		call keycheck
		cp K_9				;N
		ret z
		cp K_0				;Y
		jr nz,overwriteloop
		rst 10h
		call romcall
		.dw _delvar
filenotexist:
	call savestatemain
savemessage:
	ld hl,nomemory
	jr c,insuffmem
		ld hl,saveconfirm
insuffmem:
	push hl
	call drawbox
	pop hl
	call printwithwrap
	jp boxcopyandwait


savestatemain:
	;returns nc if save succeeded
	call page1
	ld de,$f800				;compress crap onto hidden video mem
	push de
	ld hl,objflags
	ld bc,1024
	call rle
	ld hl,playerx			;objlist
	ld bc,512
	call rle
	ld hl,inventory
	ld c,116
	call rle
	ld hl,gamevars
	ld c,65
	call rle

	ex de,hl				;find length of compressed data
	pop de
	or a
	sbc hl,de
	push hl
	call romcall			;_createstrng crashes if not enough mem
	.dw _memchk
	pop de
	or a
	jr nz,plentyomem
		ld bc,-16
		add hl,bc			;account for VAT data
		sbc hl,de			;will subtract one extra, just so you know...
		ret c
plentyomem:
	ex de,hl
	push hl
	inc hl					;2 bytes extra for the marker
	inc hl
	call romcall
	.dw _createstrng
	call loadahl
	inc hl
	call incptrhl			;mark file as a saved game
	ld (hl),$fe
	call incptrhl
	ld (hl),'s'
	inc hl
	ld de,$f800
	pop bc
savecompdata:
	call checkpage
	ex de,hl
	ldi
	ex de,hl
	jp pe,savecompdata
	or a
	ret

nomemory:
	.db "out of memory",0
saveconfirm:
	.db "game saved",0
overwriteconf:
	.db "file exists, overwrite?  [Y/N]",0
saverequest:
	.db "file name?",0
saveprompt:
	.db "F1 - save",0
loadprompt:
	.db "F2 - load",0

texttoop1:
	;** copies a file name from textspace to op1 **
	ld hl,textspace
	ld de,_OP1+2
	ld bc,8
	ldir
nchars equ $+1
	ld a,0
	ld (_OP1+1),a						;and make it length-preceeded
	ret

inputtext:
	;** inputs text to (textspace) **
	;(adapted from FD2)
	;inputs: a=maximum characters
	;outputs: c to discard inputs (exit pressed or no data)

	ld (maxchars),a
	call set_text_inverse
	xor a
	ld (nchars),a
	ld hl,textspace
	call putcursor
	call inputupdate
	jp set_text_normal

inputupdate:
	push hl
	call boxcopy
	call waitrelease
	pop hl
inputwait:
	push hl
	call keycheck
	pop hl
	or a
	jr z,inputwait
	cp K_EXIT
	scf
	ret z
	cp K_ENTER
	jr z,doneinput
	call inputcheck
	jr inputupdate

putcursor:
	ld a,'_'
	call rputmap
	ld a,'_'
	jr backupchar_a

doneinput:
	ld (hl),0
	ld a,(nchars)
	or a
	ret nz
	scf
	ret

backspace:
	ld de,nchars
	ld a,(de)
	dec a
	ret m
	ld (de),a
	call putcursor
	dec hl
	call backupchar
	ld a,(hl)
	call rputmap
	call backupchar
	jr putcursor

backupchar:
	ld a,(hl)
backupchar_a:
	push hl
	call romcall
	.dw _get_vchar
	ld a,(_charmap)
	ld hl,_penCol
	neg
	add a,(hl)
	ld (hl),a
	pop hl
	ret

putspace:
	ld a,'_'
	jr storechar

togglecap:
	ld de,transchar
	ld a,(de)
	xor %00100000						;A<->a  convenient, huh?
	ld (de),a
	ret

inputcheck:
	cp K_ALPHA
	jr z,togglecap
    cp K_DEL                            ;if del, go back a space
    jr z,backspace
	cp K_GRAPH
	ret nc
	cp 5
	ret c
    cp K_CLEAR							;this was actually smaller than using a table...
	ret z
	cp K_CUSTOM
	ret z
	cp K_PRGM
	ret z
	cp K_TABLE
	ret z
	cp K_XVAR
	ret z
	cp K_STO
	ret z

	ld b,a
	ld de,nchars
	ld a,(de)
maxchars equ $+1
	cp 0
	ret nc
	inc a
	ld (de),a
	ld a,b

	cp K_SIGN
	jr z,putspace

	push hl
    ld e,a                              ;save keypress in e
    ld a,$2e                            ;$2e = keypress for A
    ld d,0                              ;d is a counter...
letterloop:
    cp e
    jr z,gotletter                      ;if keypress = keypress for a certain letter
    inc d                               ;go to next letter in alphabet
    sub 8                               ;go to corresponding keypress for the next letter
    cp $0a                              ;check the include file...  there is a pattern for the letters
    jr nc,letterloop
    add a,$27
    jr letterloop                       ;keep going until the key codes match
gotletter:
    ld a,d                              ;put the number of the letter in a
    cp 20                               ;decrement if over 20 (equal sign)
    adc a,-1
    cp 24                               ;decrement if over 24 (pattern is disrupted for some reason...)
    adc a,-1
transchar equ $+1
    add a,La                         	;translate to ascii codes
	pop hl
storechar:
	push af
	call putcursor
	pop af
	ld (hl),a
	inc hl
	call rputmap
	jp putcursor




statmenu:
	call stattitle
	ld hl,xpneededtext
	call printwithplus
	ld hl,(playerxp)
	call displayhl
	call glnewline

	ld hl,healthtext
	ld de,maxhealth
	call statdonumber
	ld a,(playerhealth)
	call displaya
	call glnewline
	ld hl,burdentext
	ld de,maxburden
	call statdonumber
	call findweight
	call displaya
	call glnewline
	ld a,7
	call printtabstat
	ld hl,deftext
	call printwithplus
	ld a,(pshield)
	call displaya
	ld a,6
	call printtabstat
	call extstatscreens
	jr nc,statmenu
	ret


extstatscreens:
	ld hl,_penRow
	ld (hl),48
	ld hl,morestatstext
	call printwithplus
	ld a,(profpoints)
	ld hl,attribpoints
	or (hl)
	ld hl,exclamtext
	or a
	call nz,printwithwrap
	ld a,$f8
	call setlowplane2
	call waitrelease
statmenukeys:
	call keycheck
	jr z,statmenukeys
	cp K_F2
	jr z,smcheckprofs
	cp K_F1
	scf
	ret nz
	call attribscreen
	jr smreloop
smcheckprofs:
	call profscreen
smreloop:
	call dographics
	or a
	jp rebuildstats				;preserves a


altstatmenu:
	call stattitle
	ld a,5
altstatloop:
		push af
		call printtabstat
		pop af
		dec a
		jr nz,altstatloop
	call extstatscreens
	jr nc,altstatmenu
	ret


stattable1 equ $-2
	.dw ascrmul
	.dw ascrdef
	.dw ascratt
	.dw asreducttext
	.dw asdamtext
	.dw plustext
	.dw atttext

stattable2 equ $-2
	.dw pcritmod
	.dw pcritreduct
	.dw pcritrate
	.dw pdamreduct
	.dw pdamage
	.dw pdef
	.dw patt

printtabstat:
	push af
	ld hl,stattable1
	call opentable
	call printwithplus
	pop af
	ld hl,stattable2
	call opentable
	ld a,(hl)
	call displaya
	jp glnewline

asdamtext:
	.db 12,"damage:",0
asreducttext:
	.db 15,"reduct:",0
ascratt:
	.db 18,"cr  att:",0
ascrdef:
	.db 17,"cr  def:",0
ascrmul:
	.db 15,"cr  mul:",0

stattitle:
	call thinbox
	ld a,(plevel)
	ld hl,ranktitles
	call opentable
	call printwithwrap
	jp glnewline

check123:
	;checks for "escape" keys, returns z if found
	ld hl,keylist
	ld bc,7
	cpir
	ret

keylist:
	.db K_1
	.db K_2
	.db K_3
	.db K_4
	.db K_5
	.db K_EXIT
	.db K_MORE

plustext:
	.db -8,"+",0
exclamtext:
	.db "(!)",0
morestatstext:
	.db 10,"[F1/F2]",0
atttext:
	.db 16,"attack:",0
deftext:
	.db 12,"defense:",0

xpneededtext:
	.db 30,"xp:",0

statdonumber:
	push de
	call printwithplus
	pop de
	push hl
	ld a,(de)
	call displaya
	ld a,'/'
	call rputmap
	pop hl
	ld a,(hl)
	sub 8
	ld (hl),a
	ret

printwithplus:
	ld a,(hl)
	inc hl
	push af
	call printwithwrap
	pop af
	ld hl,_penCol
	add a,(hl)
	ld (hl),a
	ret

healthtext:
	.db 30,"hp:",0
burdentext:
	.db 30,"bu:",0

invmenu:
	;* draw box *
	call thinbox

	;* draw items in use *
	call drawsidebar

	;* draw icons for pack items *
	ld de,inventory
	ld a,(invbase)
	ld b,a
	add a,b
	add a,b
	add a,e
	ld e,a
	ld hl,invcoords
	ld b,8
invmenudraw:
		push bc
		ld a,(de)
		push de
		ld e,(hl)
		inc hl
		ld d,(hl)
		inc hl
		push hl
		call drawinvitem
		pop hl
		pop de
		inc de
		inc de
		inc de
		pop bc
		djnz invmenudraw

	;* draw selector *
	ld a,(invselectpos)
	push af
	ld hl,invcoords
	call opentable
	ld de,(_penCol)
	add hl,de
	ex de,hl
	pop af
	sub 32
	jr c,invrelcoords

	push af
	call set_text_inverse	;easier to see w/ the sidebar
							;applies to sprites and text both
	pop af
	ld de,(256*17)+116
	jr z,invrelcoords
	ld d,28
	dec a
	jr z,invrelcoords
	ld d,39

invrelcoords:
	dec e
	dec e
	dec e
	push de
	ld bc,pointrightD
	call basicsprite
	pop de
	ld a,11
	add a,e
	ld e,a
	ld bc,pointleftD
	call basicsprite
	call set_text_normal

	;* print text for selected item *
	ld a,22
	ld (_penRow),a
	call glnewline
	call findinvitem
	inc hl
	call printmodhl
	dec hl
	call printmodhl
	inc hl
	inc hl
	ld a,(hl)
	call printsuffmod

	;* put it all on the screen *
	call dupemenu
	call dupesidebar
	ld a,$f8
	call setlowplane2
	call waitrelease

	;* check keys *
invselloop:
	call keycheck
	jr z,invselloop
	call check123
	ret z
	call invkeycode
	jp invmenu

invkeycode:
	cp K_DEL
	jp z,dropitem
	cp K_SECOND
	jp z,selectitem
	ld hl,invselectpos
	ld de,invbase
	dec a
	jr z,invseldown
	dec a
	jr z,invselleft
	dec a
	jr z,invselright
	dec a
	ret nz

invselup:
	ld a,(hl)
	cp 32
	jr nc,rightsideup
	sub 4
	jr c,seluptop
	ld (hl),a
	ret
seluptop:
	ld a,(de)
	sub 4
	ret c
	ld (de),a
	ret
rightsideup:
	dec a
	cp 32
	ret c
	ld (hl),a
	ret

invseldown:
	ld a,(hl)
	cp 32
	jr nc,rightsidedown
	add a,4
	cp 8
	jr nc,seldownbottom
	ld (hl),a
	ret
seldownbottom:
	ld a,(de)
	add a,4
	cp 28
	ret nc
	ld (de),a
	ret
rightsidedown:
	inc a
	cp 35
	ret nc
	ld (hl),a
	ret

invselleft:
	ld a,(hl)
	cp 32
	jr nc,selgoleft
	and %00000011
	ret z
	dec (hl)
	ret
selgoleft:
	sub 34
	adc a,1
	add a,a
	add a,a
	add a,3
	ld (hl),a
	ret

invselright:
	ld a,(hl)
	cp 32
	ret nc
	inc a
	and %00000011
	jr z,selgoright
	inc (hl)
	ret
selgoright:
	ld a,(hl)
	rra
	add a,64
	rra
	ld (hl),a
	ret

equipshield:
	ld a,(swordtype)
	cp item_two
	ret z
	ld hl,shieldtype
	jr equipitem

equiparmor:
	ld hl,armortype
	jr equipitem

equipsword:
	ld hl,swordtype
	ld a,(de)
	cp item_two
	jr nz,equipitem
	ld a,(shieldtype)		;can't use two-handed swords with shields
	or a
	ret nz

equipitem:
	ld b,3
equiploop:
	ld a,(de)
	push af
	ld a,(hl)
	ld (de),a
	pop af
	ld (hl),a
	inc hl
	inc de
	djnz equiploop
	ret

dropitem:
	call findinvitem
	ld (hl),b
	inc hl
	ld (hl),b
	inc hl
	ld (hl),b
	ret

dequipitem:
	call searchpack
	ret c
	ex de,hl
	call findinvitem
	jr equipitem

selectitem:
	ld a,(invselectpos)
	cp 32
	jr nc,dequipitem
	call findinvitem
	ld a,(hl)
	ex de,hl
	ld hl,invtable
	call opentable
	jp (hl)

drinkpotion250:
	ld b,250
	jr drinkpotion

drinkpotion150:
	ld b,150

drinkpotion:
	inc de
	inc de
	ld a,(de)
	call addspell
	jr dropitem

addspell:
	;adds a spell (potion) effect
	;inputs:	a=modifier
	;			b=duration
	push bc
	push af
	;find lowest timer value...
	ld hl,pottimers
	ld a,(hl)
	ld b,9
	ld c,10
findlowpt:
		inc hl
		cp (hl)
		jr c,ptnotsmall
		ld a,(hl)
		ld c,b
ptnotsmall:
		djnz findlowpt
	ld hl,potmods+10
	or a
	sbc hl,bc
	pop af
	ld (hl),a
	ld bc,pottimers-potmods
	add hl,bc
	pop af
	ld (hl),a
	ret

useherb:
	ld de,maxhealth
	ld a,(de)
	srl a
	ld hl,playerhealth
	add a,(hl)
	ex de,hl
	cp (hl)
	jr c,healthnottoomuch
	ld a,(hl)
healthnottoomuch:
	ld (de),a
	jr dropitem

findinvitem:
	ld a,(invselectpos)
	cp 32
	jr nc,noaddbase
	ld hl,invbase
	add a,(hl)
noaddbase:
	ld b,a
	add a,b
	add a,b
	ld c,a
	ld b,0
	ld hl,inventory
	add hl,bc
	ret

	;code to execute when selected
invtable:
	.dw static
	.dw equipsword
	.dw equipsword
	.dw equipsword
	.dw equipsword
	.dw equiparmor
	.dw equiparmor
	.dw equiparmor
	.dw equiparmor
	.dw equiparmor
	.dw equipshield
	.dw equipshield
	.dw drinkpotion150
	.dw drinkpotion250
	.dw useherb
	.dw static
	.dw readstuff
	.dw static
	.dw static
	.dw readstuff

readstuff:
	ex de,hl
	inc hl
	ld c,(hl)
	push bc
	inc hl
	ld c,(hl)
	call lookupbook
	pop bc
	call z,lookupbook
	call nz,textbegin
	call page1
	jp dographics

lookupbook:
	;returns nz if a match was found
	;	with hl->text string
	;input:		c=modifier

	push bc
	call openfile
	ld de,10
	add hl,de
	call loadptrde
	pop bc
	ld b,(hl)
	inc b
	dec b
	ret z
	call incptrhl
bookloop:
		ld a,c
		cp (hl)
		inc hl
		jp z,loadptrde		;retuns nz (from checkpage)
		inc hl
		call incptrhl
		djnz bookloop
	xor a
	ret

drawinvitem:
	ld hl,(_penCol)
	add hl,de
	ex de,hl
drawinvitem2:
	or a
	ret z
	add a,a
	add a,a
	add a,a
	ld c,a
	ld b,0
	ld hl,swordicons-16
	add hl,bc
	add hl,bc
	ld c,l
	ld b,h
	jp basicsprite

invcoords:
	.db 2,1
	.db 13,1
	.db 24,1
	.db 35,1
	.db 2,10
	.db 13,10
	.db 24,10
	.db 35,10

skillmenu:
	call thinbox
	ld hl,skill1
	ld bc,$31+(5*256)
showskills:
	push bc
	push hl
	ld a,'F'
	call rputmap
	ld a,c
	call rputmap
	ld a,' '
	call rputmap
	pop hl
	ld a,(hl)
	or a
	jr z,noskill
	push hl
	ld hl,skilltype
	cp (hl)
	ld b,0
	jr nz,lowercase
	ld b,'A'-'a'
lowercase:
	ld hl,modtexts-2
	call opentable

dotext:
	ld a,(hl)
	or a
	jr z,doneskilltext
	cp $20
	jr z,notextadd
	add a,b
notextadd:
	call rputmap
	inc hl
	jr dotext
doneskilltext:

	pop hl
noskill:
	call glnewline
	pop bc
	inc hl
	inc c
	djnz showskills
	call dupemenu
	call waitrelease
skillcheckkey:
	call keycheck
	call check123
	ret z
	cp K_F5
	jr c,skillcheckkey
	cp K_F1+1
	jr nc,skillcheckkey
	neg
	add a,$35
	ld l,a
	ld h,0
	ld bc,skill1
	add hl,bc
	ld a,(hl)
	or a
	jr z,skillcheckkey
	ld (skilltype),a
	jp skillmenu

dupemenu:
	ld hl,(menubyte)
	ld h,$fc
	ld bc,6+(256*48)
	jp dupegfx

thinbox:
	call setlowplane
	ld bc,5+(256*46)
	ld de,10+(9*256)
	ld hl,(16*8)+$fc01
	ld a,(playerx)
	cp 61
	jr nc,thinboxleft
	ld e,58
	ld l,(16*8)+7
thinboxleft:
	ld a,e
	ld (startcol),a
	add a,45
	ld (wrapcol),a
	ld a,l
	ld (menubyte),a
	jp boxemup

openworld:
    call openfile
	ld a,(world)
	add a,a
	add a,26
	ld e,a
	ld d,0
	add hl,de
	jp loadptrde

playerdead:
	ld hl,pdeadtext
	call textpageloop
	jp afterdeath

preallydead:
	ld a,(playerhealth)
	or a
	jr z,deadjim
	ld hl,ai_player*256
	ld (playerx+3),hl
	ret

	;** determines whether to use removetotal or
	;	killobject for rai_remove **
rairemove:
	ld a,e
	sub 5
	ld e,a
	jr deadjim

dying:
	ld hl,5+256
	add hl,de
	dec (hl)
	ret nz
	ld a,e
	or a
	jr z,preallydead
deadjim:
	ld a,(origobjs)
	add a,a
	add a,a
	add a,a
	cp e
	jp nc,removetotal
	ld l,e
	jp killobject

extmod:
	sub (modtexts-modifiertab)/2
	ld c,a
	ld b,0
	push bc
	call openfile
	ld de,6
	add hl,de
	call loadptrde
	inc hl
	pop bc
	add hl,bc
	add hl,bc
	call loadptrde
	jr modloaded

findpstats:
	;calculates player stats based on
	;swordtype, skilltype, swordmod1, swordmod2
	;armortype, armormod1, armormod2, potmods
	;shieldtype, shieldmod1, shieldmod2
	;attributes and proficiencies
	ld hl,stats
	ld bc,30
	call zerofill
	ld hl,attribs		;copy base attribs to in-use attribs
	ld de,pstr
	ld c,4
	ldir

	ld hl,(swordtype)	;calculate attack rating (total skill points + skill in use)/4
	ld h,c
	dec l
	ld de,proficiencies
	add hl,de
	ld a,(hl)
	ld (curprof),a
	ex de,hl
	ld b,4
findpattloop:
		add a,(hl)
		djnz findpattloop
	rra
	srl a
	ld (patt),a

	ld de,swordtype
	ld b,20
applymods:
		ld a,(de)
		or a
		jr z,nomod
		push bc
		push de
		cp ((modtexts-modifiertab)/2)+1
		jr nc,extmod
		ld hl,modifiertab-2
		call opentable
modloaded:
		ld b,(hl)
		inc hl
alterstats:
			call checkpage
			ld e,(hl)
			ld a,e
			and %01111111
			cp 5				;first 5 stats have proficiency requirements
			jr nc,noskillcheck
			call incptrhl
			ld d,(hl)
			ld a,(curprof)
			cp d
noskillcheck:
			ld d,0
			push af
			call incptrhl
			pop af
			ld a,(hl)
			inc hl
			jr c,ursuck
			push hl
			ld hl,stats
			bit 7,e				;if bit 7 set, stat is abosolute instead of relative
			res 7,e
			add hl,de
			jr nz,nonadditive
			add a,(hl)
nonadditive:
			ld (hl),a
			pop hl
ursuck:
			djnz alterstats
		pop de
		pop bc
nomod:
		inc de
		call page1
		djnz applymods

	;assign values based on attributes...
	ld a,(pcon)
	add a,a					;max health = con*10
	ld b,a
	add a,a
	add a,a
	add a,b
	ld hl,maxhealth
	ld b,(hl)
	ld (hl),a
	sub b					;find difference between old and new max
	ld hl,playerhealth
	jr c,nolosehealth		;if new max is lower, do other stuff...
	add a,(hl)				;else increase current health by
	ld (hl),a				;	the difference
	jr calchealthdone
nolosehealth:
	add a,b					;get new max again
	cp (hl)					;cap current health at new max
	jr nc,calchealthdone
	ld (hl),a
calchealthdone:

	ld de,pstr				;max bu=30+str*10
	ld a,(de)
	add a,a
	ld b,a
	add a,a
	add a,a
	add a,b
	add a,30
	ld (maxburden),a

	ld hl,pdamage
	call give4bonus

	dec hl			;patt
	ld de,pper
	call give3bonus

	inc hl
	inc hl			;pcritrate
	call give4bonus

	ld hl,pdef
	dec de
	dec de			;pdex
	call give3bonus

	ld hl,precoverytime
	ld a,(de)
	srl a
	srl a
	dec a
	add a,(hl)
	ld (hl),a

	ret

give3bonus:
	ld a,(de)
	ld b,-2
give3loop:
		inc b
		sub 3
		jr nc,give3loop
	ld a,(hl)
	add a,b
	ld (hl),a
	ret

give4bonus:
	ld a,(de)
	srl a
	srl a
	dec a
	add a,(hl)
	ld (hl),a
	ret

drawswordicon:
	ld a,17
	call clearside8
	ld a,(swordtype)
	ld d,17
	ld hl,$fd1e
enddrawicon:
	push hl
	ld e,116
	call drawinvitem2
	ld bc,2+(256*8)
	pop hl
	jp dupegfx

drawshieldicon:
	ld a,28
	call clearside8
	ld a,(swordtype)
	cp item_two
	ld a,(shieldtype)
	jr nz,okdrawshield
	ld a,item_sceptre+1
okdrawshield:
	ld d,28
	ld hl,$fdce
	jr enddrawicon

drawarmoricon:
	ld a,39
	call clearside8
	ld a,(armortype)
	ld d,39
	ld hl,$fe7e
	jr enddrawicon

clearside8:
	ld b,8
	jp clearside

battle:
	;compares stats for attacking and defending objects
	;and calculates how much damage should be done
	;returns c if attack was deflected
	;if attack succeeded, b=stun time, c=damage
	;a=0 if object was killed

	ld hl,odbattlestats
	ld de,oabattlestats

	;* calculate shield bonus *
	ld a,(de)
	sub (hl)			;compare directions
	and %00000111		;looking for 3, 4, or 5 (difference between 2 directions)
	sub 3				;now 0, 1, or 2
	cp 3
	inc hl
	ld c,0				;no shield bonus by default
	jr nc,noshieldbonus
	ld c,(hl)			;get sheild bonus if directions were about opposite
noshieldbonus:

	;* determine if the attack hit *
	call battle_roll
	sub c				;adding the shield bonus to defense...
	cp b
	ret c				;miss if attack roll was too high

	;* calculate damage done *
	call battle_calc
	ld c,a

	;* see if attacker got a critical hit *
	call battle_roll
	sub 6				;automatic +6 critical defense
	inc de
	cp b
	jr c,nocrit

	;* find critical multiplier *
	ld a,(de)
	ld b,a
	xor a
critloop:
	add a,c
	djnz critloop
	ld c,a

	;* determine stun time *
nocrit:
	call battle_calc
	ld b,a

	;* store results *
	inc hl
	ld l,(hl)
	ld h,objfreespace/256
	ld a,(hl)
	sub c
	ld (hl),0
	jr c,battledie
	jr z,battledie
	push bc
	push hl
	ld (hl),a
	inc l
	ld (hl),b

	;* push defender back *
	ld a,(oadir)
	call loadmove
	ld a,(oapushback)
	sbc hl,hl
	or a
	jr z,nopushback
calcpush:
		add hl,bc
		dec a
		jr nz,calcpush
nopushback:
	ld b,h
	ld c,l
	pop hl
	dec h
	call move
	or h					;need to set nc, a/=0
	pop bc
	ret

battledie:
	ld a,5
	add a,l
	ld l,a
	ld (hl),12
	dec h		;to objlist
	dec l
	ld (hl),ai_dying
	dec l
	ld (hl),4*3
	xor a
	ret

battle_roll:
	;gets attack roll in b, ceiling value in a
	inc hl
	inc de
	call random
	and %00001111
	add a,120			;random number between 120 and 135
	ld b,a				;	"attack roll"
	ld a,(de)
	sub (hl)			;find difference between attack and defense
	add a,127			;	=max value for a successful hit
	ret

battle_calc:
	;determines damage/stun time, returns a
	inc de
	inc hl
	ld a,(de)
	sub (hl)
	jp p,damover0
	xor a
damover0:
	ld b,a
	inc b
	call random
	and %01111111
	add a,b
finddamageloop:
	rra
	cp b
	jr nc,finddamageloop
	ret


setdef:
	;loads an object's defensive stats
	;returns c if object is not attackable
	;inputs: b=object

	ld a,b
	ld d,objlist/256
	add a,4
	ld e,a
	ld a,(de)
	ld hl,fightlist
	ld bc,fightlength
	cpir
	scf
	ret nz
	ld a,c
	ld hl,setdefcodes
	call opentable
	ld a,e
	jp (hl)

ploaddef:
	ld hl,pdbattlestats
	ld de,odbattlestats
	ld a,(playerdir)
	ld (de),a
	inc de
	ld bc,5
	ldir
	xor a
	ld (de),a
	ret

wanderloaddef:
	push af
	xor a
	ld e,a
	jr setdefstats

trackloaddef:
	;input: a=object+4
	ld l,a
	ld h,objfreespace/256
	ld e,(hl)			;get direction
	inc l
	inc l
	inc l
	dec h				;to objlist
	push af
	ld a,(hl)
setdefstats:
	call findstats
	ld e,a
	inc hl
	ld de,odbattlestats
	ld (de),a
	inc de
	ld bc,5
	ldir
	pop af
	sub 4
	ld (de),a
	ret

attackanim:
	;* animates an object for attacks *
	;inputs:	hl=object
	;outputs:	nc if time to attack
	;			preserves hl if nc

	push hl
	ld c,4*4
	call setobjframe
	ld a,l
	add a,7
	ld l,a
	push hl
		ld a,(hl)
		call findstats
		ld bc,12
		add hl,bc
		ld b,(hl)
		inc hl
		ld c,(hl)
	pop hl
	inc h				;to objfreespace
	inc (hl)
	ld a,(hl)
	cp c
	pop hl
	ret c

	push af
	push hl
	ld c,4*5
	call setobjframe	;preserves b
	pop hl
	pop af
	ret z				;nc

	cp b
	ret c
	jp resetatttimer7

objattack:
	;inputs: hl=attacking object
	;		 b=defending object

	push bc
	call attackanim
	pop bc
	ret c

objattackna:
	;same inputs, routine for non-animated objects

	call trackloadatt
objattackloaded:
	push bc
	call setdef
	jr c,objattdone
	call battle
	jr c,objattdone
	pop af
	or a
	ret nz
	push bc
	call updatehealth
	pop bc
	ld hl,redrawarmorflag
	ld de,(39*256)+120
	jp displaydamage

objattdone:
	pop bc
	ret

setobjframe:
	;preserves l
	ld h,objlist/256
	push hl
	inc l
	inc l
	inc l
	ld (hl),c
	pop hl
	ret

cloudloadatt:
	ld de,6
	add hl,de
	ld a,(playerdir)
	jr loadattgen

shootloadatt:
	ld de,6
	add hl,de
	ld a,(hl)
	jr loadattgen

trackloadatt:
	;inputs: hl=object
	ld de,4+(1*256)
	add hl,de
	ld a,(hl)
	dec h
	inc l
	inc l
loadattgen:
	push bc
	ld (oadir),a
	inc l
	ld a,(hl)
	call findstats
	ld bc,6
	add hl,bc
	ld de,oabattlestats+1
	ldir
	pop bc
	ret

findstats:
	;loads stats for a given level of monster
	;input:		a=monster level
	;output:	hl->14 bytes of stats
	add a,a
	ld c,a
	ld b,0
	ld l,a
	ld h,b
	add hl,hl
	add hl,hl
	add hl,hl
	sbc hl,bc
	ld bc,statslist
	add hl,bc
	ret

pdodamage:
	;player does damage to an object
	;inputs: b=object

	call setdef
	ret c
	ld hl,pabattlestats
	ld de,oabattlestats
	ld a,(sworddir)
	ld (de),a
	inc de
	ld bc,6
	ldir
	call battle
	ret c
	push bc
	or a
	call z,givexp
	ld a,(special2)
	call executespecial
	pop bc
	ld hl,redrawswordflag
	ld de,(17*256)+120

displaydamage:
	ld (hl),4
	ld (_penCol),de
	dec de
	dec de
	dec de
	dec de
	push de
	push de
	ld a,c
	push af
	ld a,d
	ld b,8
	call clearside
	pop af
	call displaya
	pop de
	ld bc,damagepicD
	call basicsprite
	pop de
	ld h,$fc/4
	call findpixel
	ld bc,(8*256)+2
	jp dupegfx

floot:
	ld l,e
	ld h,objlist/256
	ld (hl),$80
	ret

fswitch:
	ld c,4
	jp setdoorframe

aiswitch:
	;does the switch animation and flags other objects...
	ld h,objfreespace/256
	ld d,h
	ld l,e
	ld b,(hl)
	dec l
	dec l
	dec h					;make hl->animation frame
	ld a,(hl)
	or a
	jr z,aiswstart
	cp 4
aiswstart:
		ld a,(animcount)
		set 7,a
		ld (de),a
		jr nz,aiswmid
		dec a
		or %10000000
		cp b
		scf
		ret z
aiswmid:
	push de
	call checkflag
	ld c,1
	jr c,aiswforward
	ld c,-1
aiswforward:
	call setdoorframe
	or a
	jr z,aiswcontinue
	cp 4
aiswcontinue:
	pop de
	scf
	ret nz
	call xorflag

xorothers:
	;call this to flag other objects, without the
	;animation
	ld hl,(stdargs)
	ld a,h
	or l
	jr z,nullswitch
	call loadargptr
	ld b,(hl)
switchloop:
		call incptrhl
		ld e,(hl)
		call incptrhl
		push hl
		ld l,(hl)
		in a,(6)
		push af
		call page1
		call findflagl
		cpl
		xor (hl)
		ld (hl),a
		pop af
		out (6),a
		pop hl
		djnz switchloop
nullswitch:
	call page1
	or a
	ret

dooropen:
	ld c,4*3
	call setdoorframe
	jp removeobject

setdoorframe:
	;returns de->animation frame, a=animation frame
	ld d,objlist/256
	dec e
	dec e
	ld a,(de)
	add a,c
	ld (de),a
	ret

keydoor:
	ld h,objlist/256
	ld l,e
	dec l
	dec l
	ld a,(hl)
	or a
	jr nz,opendoor

	push de
	call drawbox
	ld e,0
	ld c,item_key
	ld a,(stdargs)
	ld d,a
	push af
	call checkcde
	jr nc,yougotkey

	ld hl,thisdoortext
	call printwithwrap
	pop af
	call printmod
	ld hl,locktext
	call printwithwrap
	call boxcopyandwait
	pop de
	scf
	ret

yougotkey:
	ld hl,yourtext
	call printwithwrap
	pop af
	call printmod
	ld hl,keyfitstext
	call printwithwrap
	call boxcopyandwait
	pop de


opendoor:
	ld c,4
	call setdoorframe
	cp 3*4
	scf
	ret nz
	jp removeobject

boxcopyandwait:
	call boxcopy
	jp waitkey

removeother:
	ld a,(stdargs)
	ld e,a
	;removeother is only usable on the original object set...

removetotal:
	ld c,1
	jr removestuff

removeobject:
	ld c,e			;/= 1

removestuff:
	;unflags an object, removes it from colmap
	;and removes its ai bytes
	;input:		e=object (lower 3 bits ignored)
	;			c=1 to remove graphic, else don't
	ld a,e
	and %11111000
	ld e,a
	call unflagobject
	ld l,e
	ld h,objlist/256
	ld e,(hl)
	inc l
	ld d,(hl)
	inc l
	dec c
	jr nz,preservegraphic
	ld (hl),object_invis
preservegraphic:
	inc l
	inc l
	bit 7,(hl)
	ld (hl),$80+ai_static
	inc hl					;don't want to affect flags
	ld (hl),$80				;must erase rai in the case of linked objects
	ret nz
	call lookuptile
	ld (hl),$ff
	ret

thisdoortext:
	.db "This door has a ",0
locktext:
	.db "lock",0
yourtext:
	.db "Your ",0
keyfitstext:
	.db "key fits this lock",0


checkstun:
	;inputs: e=object
	;returns nz if stunned
	;preserves de
	ld h,objfreespace/256
	ld l,e
	inc l
	ld a,(hl)
	or a
	ret z
	dec (hl)
	push de
	dec l
	ld c,4*2
	call setobjframe
	pop de
	or d				;nz
	ret

slowtrack:
	ld a,(animcount)
	rra
	ret c

passivetrack:
	ld a,$b7			;op code for 'or a'
	jr trackmain

aitrack:
	xor a
trackmain:
	ld (trackcheck1),a
	ld (trackcheck2),a
	call checkstun
	ret nz
	push de
	call facer
	pop hl
	ld a,(playerx)
	cp (hl)
	ld bc,1
	ld a,c
	jr z,notrackx
	jr nc,trackright
	dec bc
	dec bc
trackright:
	push hl
	call move
	pop hl
	cp 2
	jr nz,notrackx
	ld a,b
trackcheck1:
	or a
	jp z,objattack
notrackx:
	ld (trackanimcheck+1),a
	inc l
	ld a,(playery)
	cp (hl)
	dec hl
	ld bc,256
	ld a,b
	jr z,notracky
	jr nc,trackdown
	ld b,-1
trackdown:
	push hl
	call move
	pop hl
	cp 2
	jr nz,notracky
	ld a,b
trackcheck2:
	or a
	jp z,objattack
notracky:
trackanimcheck:
	and 0
	push hl
	ex de,hl
	call z,animate2r
	pop hl

resetatttimer7:
	ld a,l
	add a,7
	ld e,a
resetatttimer:
	;inputs: e=object+7
	;preserves e
	ld d,objfreespace/256
	xor a
	ld (de),a
	scf
	ret

barup:
	ld a,(de)
	dec a
	ret m
	ld (de),a
	call invertbar
	ld hl,selector
	ld a,(hl)
	dec a
	ret m
	ld (hl),a
	jr invertbar

bardown:
	ld a,(de)
	inc a
	ld hl,(numstrings)
	cp l
	ret z
	ld (de),a
	call invertbar
	ld hl,selector
	ld a,(hl)
	cp 7
	ret z
	inc a
	ld (hl),a

invertbar:
selector equ $+1
	ld a,0
	add a,a
	ld b,a
	add a,b
	add a,b
	add a,7
invert:
	ld d,a
	ld e,0
	ld bc,16*7
	ld h,$fc/4
	call findpixel

invertemup:
	;inputs:	hl->start byte in video mem
	;			b=number of bytes
invertinner:
		ld a,(hl)
		cpl
		ld (hl),a
		inc hl
		djnz invertinner
	ret

selecttext:
	.db "Select an Episode"	,0
selecttext2:
	.db $1e,$1f," move  2ND select  EXIT to quit",0
endselecttext:

ststele:
	;site-to-site teleporter (no screen change)
	ld l,d
	ld h,objlist/256
	push hl
	ld c,(hl)
	inc l
	ld b,(hl)
	ld hl,(stdargs)
	or a
	sbc hl,bc
	ld c,l
	ld b,h
	pop hl
	jp move

teleport:
	call loadargptr
	ld e,(hl)
	call incptrhl
	ld d,(hl)
	call incptrhl
	ld a,(hl)
	ex de,hl
	ld (playerx),hl
	ld (screen),a
	call page1
	jp setup

transition:
	;copies working page into visible one
	ld b,8
outtransloop:
	halt
	halt
	halt
	halt
	push bc
	  ld a,(page+1)
	  ld d,a
	  xor %00001000
	  ld h,a
	  ld l,0
	  ld e,l

	  ld c,64
looptrans:
	  	ld b,7
transloop:
		  rr (hl)
		  ld a,(de)
		  rra
		  ld (de),a
		  inc hl
		  inc de
	  	  rl (hl)
	  	  ld a,(de)
		  rla
		  ld (de),a
		  inc hl
		  inc de
		  djnz transloop
		inc hl
		inc hl
		inc de
		inc de
		ld b,7
transloop2:
		  rl (hl)
		  ld a,(de)
		  rla
		  ld (de),a
		  inc hl
		  inc de
		  rr (hl)
		  ld a,(de)
		  rra
		  ld (de),a
		  inc hl
		  inc de
		  djnz transloop2
		inc hl
		inc hl
	 	inc de
		inc de
	  dec c
	  jr nz,looptrans
	pop bc
	djnz outtransloop
	ret

loadmove:		;returns nc
	push hl
	ld hl,movetable
	call opentable
	ld b,h
	ld c,l
	pop hl
	ret

aiwander:
	;moves around the screen randomly
	push de
	inc e
	inc e
	inc e
	inc e
	ld d,objfreespace/256
	ld a,(animcount)
	and %00000111
	call z,newdirection
	ld a,(de)
	call loadmove
	pop hl
	rra
	ret c
	push hl
	call move
	pop de
	or a
	ret nz
	jp animate2r

newdirection:
	call random
	and %00000111
	jr savedirection2

savedirection:
	;inputs: e->object
	;a=new direction
	;outputs e+4
	;destroys hl,bc,af

	inc e
	inc e
	inc e
	inc e
savedirection2:
	ld h,objfreespace/256
	ld l,e
	srl (hl)
	ld c,(hl)
	ld (hl),a
	srl a
	ld h,objlist/256
	dec l
	dec l
	add a,(hl)
	sub c
	ld (hl),a
	ret

rairandom:
	;randomly sets c flag for use in scripts
	;probability of c in stdargs
	call random
	ld hl,stdargs
	cp (hl)
	ret

random:
	;** 24 bit random number generator **
	push hl
	push bc
	push de
randoseed1 equ $+1
	ld a,137
randoseed2 equ $+1
randoseed3 equ $+2
	ld hl,19351
	ld d,a				;ahl = seed*257+107
	ld b,h
	ld c,l
	ld a,h
	ld h,l
	ld l,107
	add hl,bc
	adc a,d
	ld (randoseed2),a	;rearrange byte order in the seed
	ld a,l
	ld (randoseed3),a
	ld a,h
	ld (randoseed1),a
	pop de
	pop bc
	pop hl
	ret

rendermode:
	ld a,1				;0=slow 1=fast
	xor 1
	ld (rendermode+1),a
	call z,slowrendering
	call nz,fastrendering
	jp textpageloop

slowrendering:
	ld hl,tantable32
	ld de,alitantable
	ld bc,33
	ldir
	ld hl,costable32
	ld de,alicostable
	ld c,33
	ldir
	ld hl,slowtext
	ld a,32
rendercommon:
	ld (angles+1),a
	ret

fastrendering:
	ld hl,tantable16
	ld de,alitantable
	ld bc,17
	ldir
	ld hl,costable16
	ld de,alicostable
	ld c,17
	ldir
	ld hl,fasttext
	ld a,16
	jr rendercommon

fasttext:
	.db "fast rendering",0
slowtext:
	.db "slow rendering",0

drawbox:
	call setlowplane
	ld a,18
	ld (startcol),a
	ld a,94
boxextend equ $+1
	add a,0
	ld (wrapcol),a
	ld de,18+(256*18)
	ld hl,$fc02+(16*8*2)
	ld b,32
	ld a,(boxextend)
	add a,9
	ld c,a

boxemup:
	ld (_penCol),de
	push hl
	push de
	push bc
	call boxtify
	pop bc
	pop de
	pop hl
	res 2,h
boxtify:
	push bc
	ld b,0
	call blacken
	ld d,c
	pop bc
	dec c
	dec c
	ld a,14
	sub c
	ld e,a
boxloop:
	push de
	push bc
	add hl,de
	ld b,d
	ld (hl),%10000000
	inc hl
	call zerofill
	pop bc
	pop de
	inc hl
	ld (hl),%00000001
	djnz boxloop
	add hl,de
	inc c
	inc c
	jp blacken

boxcopy:
	ld hl,$fc02+(16*8*2)
	ld b,34
	ld a,(boxextend)
	add a,10
	ld c,a
	jp dupegfx

loadworlddata:
	push af
	push de
	call openworld
	pop de
	add hl,de
	call loadptrde
	inc hl
	pop af
	add a,a
	ld e,a
	ld d,0
	add hl,de
	call checkpage

loadptrde:
	call checkpage
	ld e,(hl)
	call incptrhl
	ld d,(hl)
	add hl,de
	jp checkpage

decomptorayfield:
	push de
	call d86i
	call page1
	pop hl
	jp copytorayfield


text:
	ld a,(stdargs)
showstring:
	ld de,9
	call loadworlddata
textbegin:
	ld a,(hl)
	cp $fd
	jr nz,textpageloop
	call incptrhl
	push hl
	call setlowplane
	pop hl
	ld de,$f800
	call decomptorayfield
	call drawsidebar				;decompression can erase it
	ld hl,rayfield
textpageloop:
  		push hl
		call drawbox
		pop hl
textloop:
			call printwithwrap
			inc hl
			cp $ff
			jr c,newtextpage
			call glnewline
			jr textloop
newtextpage:
		push af
		push hl
		call boxcopyandwait
		pop hl
		pop af
		or a
		jr nz,textpageloop
	jp page1

waitkey:
	;waits until a key is pressed (and released)
	;returns nc
	call waitrelease
	ld a,($c002)
	inc a
	jr z,waitkey
waitkeyloop:
	call keycheck
	jr z,waitkeyloop
waitrelease:
	call keycheck
	jr nz,waitrelease
	ret

keycheck:
	halt
	call romcall
	.dw _scan_code
	ld a,($c000)
	or a
	ret

xorpage:
	ld a,(page+1)
	xor %00001000
	ret

clearside:
	ld hl,sidepic
	add a,a
	ld e,a
	ld d,0
	add hl,de
	ex de,hl
	ld h,$f8/8
	add hl,hl
	add hl,hl
	add hl,hl
	ld a,14
	add a,l
	ld l,a
	push bc
	push hl
	push de
	call clearsidesub
	pop de
	ld hl,128
	add hl,de
	ex de,hl
	pop hl
	set 2,h
	pop bc

clearsidesub:
	push bc
	ld a,(de)
	ld (hl),a
	inc l
	inc de
	ld a,(de)
	ld (hl),a
	inc de
	ld bc,15
	add hl,bc
	pop bc
	djnz clearsidesub
	ret

drawsidebar:
	xor a
	ld b,64
	call clearside
	call drawswordicon
	call drawshieldicon
	call drawarmoricon
	call updatehealth

	ld hl,potmods
	ld b,10
potcheckloop:
	ld a,(hl)
	or a
	jr nz,drawpoticon
	inc hl
	djnz potcheckloop
	jr dupesidebar
drawpoticon:
		ld bc,affectionD
		ld de,116+(256*53)
		call basicsprite
dupesidebar:
	ld bc,2+(256*64)
	ld hl,$fc0e

dupegfx:
	;copies stuff from $f8++ to $f0++
	;inputs: hl->light video mem, c=width (bytes), b=lines
	push hl
	push bc
	call dupegfxloop
	pop bc
	pop hl
	res 2,h
dupegfxloop:
	ld d,h
	ld e,l
	res 3,d
	push bc
	push hl
	ld b,0
	ldir
	pop hl
	ld c,16
	add hl,bc
	pop bc
	djnz dupegfxloop
	ret

basicsprite:
	;unaligned grayscale sprite, no masking, no clipping
	;inputs: bc->graphic, de=coordinates

	ld h,$f8/4
basicspriteh:
	call findpixel
	add a,a
	add a,spritedata/256
	ld d,a
	call drawbsprite
	ld a,d
	ld de,$380
	add hl,de
	ld d,a
drawbsprite:
	ld a,8
bspriteloop:
		ex af,af'
		ld a,(bc)
		ld e,a
		ld a,(de)
blogic1:
		or (hl)
		ld (hl),a
		inc d
		inc hl
		ld a,(de)
blogic2:
		or (hl)
		ld (hl),a
		dec d
		push bc
		ld bc,15
		add hl,bc
		pop bc
		inc bc
		ex af,af'
		dec a
		jr nz,bspriteloop
	ret

updatehealth:
	ld a,4
	ld b,8
	call clearside
	ld a,(playerhealth)
	ld c,a
	ld a,(maxhealth)
	rra
	rra
	rra
	and %00011111
	ld b,a
	xor a
	ld hl,$fcbf
	ld de,choohondis
	inc c
healthloop:
		add a,b
		cp c
		jr nc,endhealthloop
		ex af,af'
		ld a,(de)
		or (hl)
		ld (hl),a
		res 2,h
		ld a,(de)
		or (hl)
		ld (hl),a
		dec de
		dec l
		ld a,(de)
		or (hl)
		ld (hl),a
		set 2,h
		ld a,(de)
		or (hl)
		ld (hl),a
		dec de
		ld a,l
		sub 15
		ld l,a
		ex af,af'
		jr healthloop
endhealthloop:
	ld hl,$fc4e
	ld bc,2+(256*8)
	jp dupegfx

	;takes more than 8 bytes to write the code
	;to use this thing non-aligned
	.db %00000111, %11000000
	.db %00000111, %11100000
	.db %00000001, %10010000
	.db %00000001, %10000000
	.db %00000001, %10000000
	.db %00001001, %10000000
	.db %00000111, %11100000
	.db %00000011, %11100000
choohondis equ $-1


displayhl:
	ld bc,-1
	ld de,-10
divhl10:
	inc bc
	add hl,de
	jr c,divhl10
	ld a,l
	push hl
	call dispnocommon
	pop hl
	ld l,c
	ld h,b
	or c
	jr nz,displayhl
	ret

displaya:
	ld b,-1
diva10:
	inc b
	sub 10
	jr nc,diva10
	call dispnocommon
	or a
	jr nz,displaya
	ret

dispnocommon:
	add a,$3a
	push bc
	call rputmap
	pop bc
	ld a,(_penCol)
	sub 8
	ld (_penCol),a
	ld a,b
	ret

page1:
	ld a,$41
	out (6),a
	ret

callrom:
    ex (sp),hl
    push de
    ld e,(hl)
    inc hl
    ld d,(hl)
    inc hl
    ld (romcall+callcall+1-callrom),de
    pop de
    ex (sp),hl
	push af
	ld a,$0d
	out (5),a
	pop af
callcall:
    call 0
	push af
	ld a,$42
	out (5),a
	pop af
	ret
endcallrom:

genspritegfx48:
	;inputs:	hl->48 bytes of sprite data
	;			de->192 bytes of free space
	ld bc,48
	ld a,18

spritegen:
	push de
	ldir
	ex de,hl
	pop de
	ld b,a
gengfxloop:
	push bc
	call rotate90
	ex de,hl
	ld bc,8
	add hl,bc
	ex de,hl
	pop bc
	djnz gengfxloop
	ret

genspritegfx24:
	;24 byte version of genspritegfx
	ld bc,24
	ld a,9
	jr spritegen

rotate90:
	;rotates an 8x8 sprite 90 degrees counter-clockwise
	;inputs:	de->source
	;			hl->destination
	;outputs:	de preserved
	;			hl->destination+8

	ld c,%00000001
rotout:
	ld b,8
	push de
rotin:
	  ld a,(de)
	  and c
	  add a,$ff
	  rl (hl)
	  inc de
	  djnz rotin
	pop de
	inc hl
	rlc c
	jr nc,rotout
	ret

doweapon:
	ld a,(skilltype)
	or a
	ret z
	ld a,(windframe)
	ld c,a
	call setobjframe
	ld hl,playerwindtime
	dec (hl)
	ret nz
	ld l,(hl)
	ld c,5*4
	call setobjframe		;super-kludged
	ld a,(sframesbase)
	ld (swordframes),a
	ld a,(stimerbase)
	inc a
	ld (swordtimer),a
	ld hl,(swordbase)
	ld a,(playerdir)
	add a,l
	and %00000111
	ld (sworddir),a
	call getswordcoords
	ld hl,sworddata
	ld (hl),e
	inc hl
	ld (hl),d
	dec hl
    call makeobject
	ret c
	inc l
	inc l
	inc l
	cp 2
	ld a,(sworddir)
	ld (hl),a
	ld a,1
	ld (swordstate),a
	jp z,pdodamage
	ret

sworddata:
	.db 0,0
	.db object_sword
	.db $83
	.db $80

swingweapon:
	ld hl,swordtimer
	ld a,(hl)
	dec a
	jr nz,stimernot0
	ld a,(stimerbase)
stimernot0:
	ld (hl),a
	ret nz
	push de
	ld a,(special1)
	call executespecial
	pop de
	ld hl,swordframes
	ld a,(hl)
	dec a
	ld (hl),a
	jr z,sworddone
	ld hl,(swordnext)
	ld a,(sworddir)
	add a,l
	and %00000111
	ld (sworddir),a
	push de
	ld a,e
	ex af,af'
	call getswordcoords
	push de
	call movecheck
	cp 2
	call z,pdodamage
	pop de
	pop hl
	ld (hl),e
	inc l
	ld (hl),d
	inc l
	inc l
	ld a,(sworddir)
	ld (hl),a
	ret
sworddone:
	dec a				;$ff
	ld (swordstate),a
	ld l,e
	jp killobject

getswordcoords:
	ld a,(sworddir)
	ld hl,spawntable
	call opentable
    ld bc,(playerx)
	add hl,bc
	ex de,hl
	ret

checkother:
	;checks another object's flag (c if flagged)
	ld hl,(stdargs)
	ld e,h
	call findflagl
	jr checkcommon

checkflag:
    ;returns c if flagged
    call findflag
checkcommon:
    cpl
    and (hl)
    ret z
	scf
	ret

xorflag:
	call findflag
	cpl
	xor (hl)
	ld (hl),a
	ret

flagother:
	ld hl,(stdargs)
	ld e,h
	call findflagl
	jr flagcommon

flagobject:
	call findflag
flagcommon:
    cpl
    or (hl)
    ld (hl),a
    ret

unflagobject:
    call findflag
    and (hl)
    ld (hl),a
    ret

findflag:
    ;finds an object in the flag table...
    ;ex/ monster flagged as dead, chest flagged as opened, etc
    ;inputs: e=object (lower 3 bits ignored)
    ;ouputs: hl->flag byte, a=inverse mask
	;bc,de preserved

    ld hl,(screen)
findflagl:
	push de
    ld h,(objflags/256)/4
    ld a,e
    rlca
    rlca
    and %00000011
    add hl,hl
    add hl,hl
    add a,l
    ld l,a
    ld a,e
    and %00111000
    rrca
    rrca
    rrca
    ld e,a
    ld d,alimasktable/256
    ld a,(de)
	pop de
    ret

objcopy:
   	call checkpage
    ld a,(hl)
	ld (de),a
	inc hl
	inc e
  	djnz objcopy
	ret

	;** zeros out objfreespace and sets health values **
	;input: a=enemy stat value, hl=object in objlist
	;preserves de
initfreespace:
	push hl
	call findstats			;input is in a
	ld c,(hl)
	pop hl
	inc h					;to objfreespace
	ld (hl),c				;set initial health
	ld e,l
	ld b,7
	xor a					;zero out the rest of the free space
initwith0s:
		inc l
		ld (hl),a
		djnz initwith0s
	ret

makeobject:
	;creates a new object with data (hl)
	;returns c if there are too many objects
	;if solid, failure (c set) on all collisions
	;	colmap updated
	;else returns a,b as the result of a move
	;hl=new object

	;find space for new object
	ld a,(numobj)
	inc a
	add a,a
	add a,a
	add a,a
	ret c
	ld e,a
	ld d,objlist/256
		;load data for object
		ld b,3
		push de
		call objcopy
		xor a
		ld (de),a
		inc e
		ld b,4
		call objcopy
		pop hl

		call initfreespace

origobjs equ $+1
			ld a,0
			add a,a
			add a,a
			add a,a
			cp e
			;check if flagged
			call page1
			call nc,checkflag
			ld l,e
			ld h,objlist/256
			jr c,moflagged		;skip code if object was flagged
								;	or was not an original
				push hl
				ld a,l
				add a,5
				ld l,a
				ld e,l
				call flagemup
				pop hl
moflagged:
	;check position
	ld a,l
	ld c,l
	ex af,af'
	ld e,(hl)
	inc l
	ld d,(hl)
	inc l
	inc l
	inc l
	ld b,(hl)
	ld hl,numobj
	inc (hl)			;needed here because movecheck
	push bc				;	might spawn more objects
	call movecheck
	pop de
	bit 7,d
	jr nz,makeeth
		or a
		jr nz,solidfail
		ld (hl),e
makeeth:
	;finish up
	ld l,e
	ld h,objlist/256
	or a
	ret

solidfail:
	ld hl,numobj
	dec (hl)
	scf
	ret

flagemup:
	;input:	hl->rai byte, e=object+5
	;passes e=object+5 to flag routine
	ld a,(hl)
	and %00111111
	ld hl,flaglist
	call opentable
	call page1
	jp callhl


killobject:
    ;removes an object...
    ;inputs: l=lsb of object address (assumed valid)
	;** for dumb reasons, an object can only kill itself
    ld h,objlist/256
    push hl
    ld e,(hl)
    inc l
    ld d,(hl)
    inc l
    inc l
    inc l
    bit 7,(hl)
    jr nz,killobjeth
    call lookuptile
    ld (hl),$ff
killobjeth:
    pop de
    ld hl,numobj
    ld a,(hl)
    dec (hl)
    add a,a
    add a,a
    add a,a
    sub e
    ret z
	push de
    ld c,a
    ld b,0
    ld hl,8
    ld d,objlist/256
    add hl,de
	push bc
	push hl
	push de
    ldir
	pop de
	pop hl
	pop bc
	inc h				;must correct objfreespace too
	inc d
	ldir
	pop bc

	;lastly correct colmap...
	ld hl,colmap
	ld b,160
fixcolloop:
		ld a,(hl)
		inc a
		cp c
		jr c,colnofix
			sub 9
			ld (hl),a
colnofix:
		inc l
		djnz fixcolloop
    ret

    ;** controls and stuff **
playerstuff:
	call checkstun
	ret nz
	ld c,4*5
	ld l,e
	ld a,(swordstate)
	inc a
	jr z,pno2ndcheck
	dec a
	jp nz,setobjframe
	ld a,(keydata+6)
	bit 5,a
	jp z,doweapon
pno2ndcheck:
	xor a
	ld (swordstate),a
	ld a,(pwindup)
	ld (playerwindtime),a
	ld a,(keydata+5)
    ld b,a
	ld a,(keydata+0)
	and %00001111
	cp 15
	jr z,showplayerframe
	ld c,a
	bit 7,b			;check alpha
	jr z,noupdate
	  push bc
  	  ld b,e
	  ld hl,directiontable
	  add hl,bc
	  ld a,(hl)
	  push de
	  call savedirection
	  pop de
	  pop bc
	  bit 6,b		;check graph
      jr z,showplayerframe
noupdate:
	ex de,hl
	ld e,(hl)
	inc l
	ld d,(hl)
	push de
	push hl
	bit 0,c
	call z,playermovedown
	bit 1,c
	call z,playermoveleft
	bit 2,c
	call z,playermoveright
	bit 3,c
	call z,playermoveup
	pop hl
	ld d,(hl)
	dec l
	ld e,(hl)
	pop hl
	xor a
	sbc hl,de
	ld e,a
	jp nz,animate2r
showplayerframe:
	ld b,e
	jp animatecommon

    ;** behemoth movement routine **
move:
    ;inputs: hl = address of object to move
    ;        bc = amount to move

    ;outputs: a=0 if move succeeded
    ;         a=1 if move failed due to tile
    ;         a=2, b=object if move failed due to object
    ;         a=other if move failed due to edge of screen
    ;         response code executed upon collisions (one only)
    ;         coordinates updated if move succeeded
    ;         colmap updated if move succeeded and object was solid
    ;         hl,bc,de,af,af' destroyed

	push hl
	ld a,l
	ex af,af'
	ld e,(hl)
	inc l
	ld d,(hl)
	inc l
	inc l
	inc l
	bit 7,(hl)
	jr nz,moveeth

		call lookuptile
		ld (hl),$ff
		call movecheckextra
		cp 1
		jr c,solmovok
		pop hl
		push hl
		ld e,(hl)
		inc l
		ld d,(hl)
solmovok:
		push af
		call lookuptile
		ld a,(curmover)
		ld (hl),a
		pop af

movefinish:
	pop hl
	ret nc
	ld (hl),e
	inc l
	ld (hl),d
	ret

moveeth:
		call movecheckextra
		cp 3
		jr movefinish


movecheckextra:
	;movecheck, but with inputs
	;		de=original position
	;		bc=amount to move

	ex de,hl
	add hl,bc
	ex de,hl


movecheck:
	;check coordinates for collisions...
	;inputs: de=coordinates
	;		 a'=object
	;outputs: hl->tile if no collisions
	;	      response code executed
	;		  de preserved
	;	      failure conditions as above

	ex af,af'
	ld (curmover),a

    ld a,d      ;check if past edge of screen
	sub 8
    cp 57
    ret nc
    ld a,e
    sub 8
    cp 105
    ret nc

    call lookuptile
    call checktile
    ret po
    ld bc,16
    add hl,bc
    ld a,d
    and %00000111
    call nz,checktile
    ret po

    ld c,9
checkobjloop:
      ld a,(hl)
      rrca
      jr c,noobj
      rlca
curmover equ $+1
	  cp 0
	  jr z,noobj
	  push hl
      ld l,a
      ld h,objlist/256
      ld b,a
      push bc
      ld c,(hl)
      inc l
      ld b,(hl)
      call checkcoords
      pop bc
      pop hl
      ld a,2
      ret c
noobj:
      push hl
      ld hl,tiletable-1
      ld b,0
      add hl,bc
      ld a,(hl)
      pop hl
      add a,l
      ld l,a
      dec c
      jr nz,checkobjloop
    xor a
    ret

checktile:
    ;returns po, a=1 if you hit a wall
    ld a,(hl)
    and %00000011
    ret po              ;now how did I ever come up with this...
    ld a,e
    and %00000111
    ret z   ;pe
	inc l
    ld a,(hl)
	dec l
    and %00000011
    ret

tiletable:
    .db 0
    .db -17
    .db 16
    .db 16
    .db 1
    .db 1
    .db -16
    .db -16
	.db -1

playermoveright:
    ld de,1
    call pmove
    or a
    ret z
    dec a
    jr z,hitwallh
    dec a
    ret z
    jp scrollright

playermovedown:
    ld de,1*256
    call pmove
    or a
    ret z
    dec a
    jr z,hitwallv
    dec a
    ret z
    jp scrolldown

hitwallv:
    ld a,c
    and %00001111
    ret pe              ;don't adjust if more than one key is pressed
    ld a,e
    and %00000111
    ret z
    cp 4
    jr nc,playermoveright

playermoveleft:
    ld de,-1
    call pmove
    or a
    ret z
    dec a
    jr z,hitwallh
    dec a
    ret z
    jp scrollleft

hitwallh:
    ld a,c
    and %00001111
    ret pe
    ld a,d
    and %00000111
    ret z
    cp 4
    jr nc,playermovedown

playermoveup:
    ld de,-1*256
    call pmove
    or a
    ret z
    dec a
    jr z,hitwallv
    dec a
    ret z
    jp scrollup

pmove:
	push bc
	ld c,e
	ld b,d
	ld hl,playerx
	call move
	pop bc
	ret

checkcoords:
    ;inputs: de=object1 coordinates
    ;        bc=object2 coordinates
	;		 hl=object2+1
    ;outputs: c if objects overlap
    ld a,d
    sub b
    add a,7
    cp 15
    ret nc
    ld a,e
    sub c
    add a,7
    cp 15
    ret nc

    ;execute response routine with d=current object, e=responding object (+5)

	push de
	ld bc,4
	add hl,bc
	ld a,(curmover)
	push af
	ld d,a
	call normresponse
	pop af
	ld (curmover),a
	pop de
	scf
	ret

linkresponse:
	;executes another object's response...
	ld hl,(stdargs)
	ld h,objlist/256
	ld a,5
	add a,l
	ld l,a

normresponse:
	;executes a response
	;inputs:	d=moving object
	;			hl=responding object+5

	ld e,l
	bit 7,(hl)
	ret nz
	bit 6,(hl)
	jr z,allrespond
		inc d
		dec d
		ret nz
allrespond:
	ld a,(hl)
	and %00111111
	inc l
	ld c,(hl)
	inc l
	ld b,(hl)
	ld (stdargs),bc
	ld hl,responseailist
	call opentable
	jp (hl)

lookuptile:
    ;inputs: de=coordinates
    ;outputs: hl->tile in colmap
	;destroys a
    ld h,(colmap/256)/2
    ld a,d
    and %01111000
    ld l,a
    ld a,e
    rra
    add hl,hl
    rra
    add a,$a0       ;$50*2
    rra
    add a,l
    ld l,a
    ret

zerofill:
	ld (hl),0
	jr fill

blacken:
    ld (hl),$ff
fill:
    ld d,h
    ld e,l
    inc de
    ldir
    ret

	;** main graphics routine **
dographics:
	;** initialize rayfield **
	ld hl,bdelay
	dec (hl)
	jr nz,gotbframe
	dec hl
	ld a,(hl)
	inc hl
	ld (hl),a
	ld hl,bframesbase
	ld a,(hl)
	inc hl
	inc (hl)
	cp (hl)
	jr nz,gotbframe
	xor a
	ld (hl),a
gotbframe:
    ld hl,blackfield
	ld a,(bframes)
	add a,a
	add a,a
	add a,h
	ld h,a
	call copytorayfield

    ;** cast some rays **

	ld a,(playerx)
	add a,3
	cp 8
	jr nc,xover8
	ld a,8
xover8:
	cp 120
	jr c,xunder120
	ld a,119
xunder120:
	ld e,a
	ld a,(playery)
	sub 6
	jr nc,ynocarry
	xor a
ynocarry:
	cp 64
	jr c,yunder64
	ld a,63
yunder64:
	ld d,a

    call raycast

    ;** generate screen **
    ld de,litmapdark+1
    ld hl,rayfield+1
	call xorpage
	ld b,a
	ld c,0
    ld a,8
    push hl
    call giantunrolledmess
    pop hl
    ;outputs de = litmaplight+1
    ;        bc = $fc00
    ld a,8
    call giantunrolledmess

    ;** draw sprites **
    ld hl,playerx
    ld a,(numobj)
    inc a
	ld b,a
drawspriteloop:
    	push bc
    	ld e,(hl)
    	inc l
    	ld d,(hl)
    	inc l
	   	ld c,(hl)				;main graphic
		inc l
		xor a
		ld b,a
		or c
		jr z,nographic			;0 is object_invis
		ld a,(hl)				;animation frame
		push hl
			ld hl,objectptrs-2
			add hl,bc
			add hl,bc
			ld c,(hl)
			inc hl
			ld b,(hl)
				add a,a
				ld l,a
				add a,a
				add a,l
				ld l,a
				ld h,0
				add hl,hl
				add hl,hl
				add hl,bc
		push hl
		pop ix
    	call spriteemup
    	pop hl
nographic:
		ld a,l
		add a,5
		ld l,a
    	pop bc
    	djnz drawspriteloop
	ld iy,$c3e5
	ret

copytorayfield:
    ld de,rayfield
    ld bc,1024
    jp unrolledldir

scrollcommon:
	xor a					;in case you got knocked through a portal in a fight
	ld (swordstate),a
	ld (playerx+3),a
    call precalculate
    jp dographics

finishscroll:
	ld b,8
finishscrollloop:
	push bc
	push de
	ld hl,(playerx)
	add hl,de
	ld (playerx),hl
	ld e,0
	call animate2r
	call dographics
	call xorpage
	ld (page+1),a
	pop de
	pop bc
	djnz finishscrollloop
	jp gencolmap

scrollleft:
    ld a,120
    ld (playerx),a
    ld hl,screen
    dec (hl)
    call scrollcommon
	call xorpage
	dec a
	ld d,a
	ld e,-3
    ld b,14
scrollleftscreen:
      push bc
      ld b,8
scrollleftbyte:
        push bc
        push de
        ld hl,(page)
	    ld l,0
        ld a,128
scrollleftloop:
          ex de,hl
          ld bc,16
          add hl,bc
          rr (hl)
          ex de,hl
          ld b,7
scrolllineleft:
            rr (hl)
            inc l
            rr (hl)
            inc l
            djnz scrolllineleft
          inc l
          inc hl
          dec a
          jr nz,scrollleftloop
        pop de
        pop bc
        djnz scrollleftbyte
      pop bc
      dec e
      djnz scrollleftscreen
	ld de,-1
	jp finishscroll

scrollright:
   	xor a
    ld (playerx),a
    ld hl,screen
    inc (hl)
    call scrollcommon
	call xorpage
	add a,8
	ld d,a
    ld e,0
    ld b,14
scrollrightscreen:
      push bc
      ld b,8
scrollrightbyte:
        push bc
        push de
        ld a,(page+1)
		add a,7
	 	ld h,a
		ld l,$fe
        ld a,128
scrollrightloop:
          ex de,hl
          ld bc,-16
          add hl,bc
          rl (hl)
          ex de,hl
          ld b,7
scrolllineright:
            dec l
            rl (hl)
            dec l
            rl (hl)
            djnz scrolllineright
          dec hl
          dec l
          dec a
          jr nz,scrollrightloop
        pop de
        pop bc
        djnz scrollrightbyte
      pop bc
      inc e
      djnz scrollrightscreen
	ld de,1
	jp finishscroll

scrolldown:
    xor a
    ld (playery),a
    ld a,(mapwidth)
    ld hl,screen
    add a,(hl)
    ld (hl),a
    call scrollcommon
	call xorpage
	ld h,a
	ld l,0
    ld b,64
scrolldownloop:
      push bc
      push hl
      ld hl,(page)
	  ld l,$10
      ld d,h
	  ld e,0
      ld a,128
scrolllinedown:
        ld bc,14
        ldir
        inc hl
        inc hl
        inc de
        inc de
        dec a
        jr nz,scrolllinedown
      pop hl
      push hl
      ld de,1024
      add hl,de
	  ld a,(page+1)
	  add a,7
	  ld d,a
	  ld e,$f0
      ld c,14
      ldir
      pop hl
      sub 4
	  ld d,a
	  ld e,$f0
      ld c,14
      ldir
      inc hl
      inc hl
      pop bc
      djnz scrolldownloop
	ld de,256
	jp finishscroll


scrollup:
    ld a,72
    ld (playery),a
    ld a,(screen)
    ld hl,(mapwidth)
    sub l
    ld (screen),a
    call scrollcommon
	call xorpage
	add a,3
	ld h,a
	ld l,-3
    ld b,64
scrolluploop:
      push bc
      push hl
	  ld a,(page+1)
	  add a,7
	  ld h,a
	  ld d,a
	  ld l,$ed
	  ld e,$fd
      ld a,128
scrolllineup:
        ld bc,14
        lddr
        dec hl
        dec hl
        dec de
        dec de
        dec a
        jr nz,scrolllineup
      pop hl
      push hl
      ld de,1024
      add hl,de
	  ld a,(page+1)
	  add a,4
	  ld d,a
      ld e,$0d
      ld c,14
      lddr
      pop hl
	  sub 4
	  ld d,a
      ld e,$0d
      ld c,14
      lddr
      dec hl
      dec hl
      pop bc
      djnz scrolluploop
	ld de,-256
	jp finishscroll


openfile:
    ld hl,levelfile-1
openfilehl:
    rst 20h
rstloadahl:
	rst 10h
loadahl:
    ld a,b
    ex de,hl
	call romcall
    .dw _load_ram_ahl
static:
	ret

openloader:
	ld hl,loadername-1
	jr openfilehl
loadername:
	.db 5,"bload"

incptrhl:
	inc hl

checkpage:
	;always returns nz
	;check for addresses below $40 (%00...) or above $c0 (%11...)
    ld a,h
	and %11000000
	ret po
	ld a,h
	sub $40
    ld h,a
    in a,(6)
    inc a
    out (6),a
	jr checkpage			;if h < $40 it gets done twice

animate2:
	ld bc,1+(256*%00000001)
	jr animatecommon

animate2r:
	ld bc,4+(256*%00000100)
	jr animatecommon

animate4r:
	ld bc,4+(256*%00001100)
	jr animatecommon

animate4:
	ld bc,1+(256*%00000011)

animatecommon:
	;outputs	hl->animation frame byte
	;			nc if time to animate
	;			a=counter
	ld h,objfreespace/256
	ld a,e
	add a,5
	ld l,a
	ld a,(hl)
	inc a
	ld (hl),a
	dec h
	dec l
	dec l
	rra
	ret c		;only animate on alternating frames
	ld a,(hl)
	add a,c
	and b
	ld (hl),a
	ret

quitpop:
	pop af

quit:
	call page1
	ld hl,quitcode
	ld de,quitroutine
	ld bc,endquitcode-quitcode
	ldir
	jp quitroutine

quitcode:
    im 1
	ld a,$0d
	out (5),a
    ld a,$fc
    out (0),a

    ;** return the stack **
    ld hl,newstack
    ld de,$fb00
    ld bc,256
    ldir                            ;copy the stack back to it's original spot
    ld h,($fb00-newstack)/256       ;l=0
    add hl,sp
    ld sp,hl                        ;put sp back to what it should be

    call _clrWindow
relocflag:
	ld a,0
	or a
	ret nz
	ld hl,$3fff
	ld (_OPS),hl
	jp _jforcecmdnochar
endquitcode:

combinecode:                        ;note for later --
    ld a,(de)                       ;  you could eliminate bc from this, and
    or (hl)                         ;do ld (de),a instead, if you raycast onto
    ld (bc),a                       ;the video screen directly...  problem is,
    inc e                           ;you'd lose the ability to offset the
    inc l                           ;screen.  so you'd have borders on either
    inc c                           ;side (which sucks).
combinecode2:
    inc c
    inc bc
    inc de
    inc e
    inc hl
    inc l
combinecode3:
    ex af,af'
    dec a
    jp nz,giantunrolledmess
    ret

raycast:
    ;** convert coordinates to format used by engine **
    ld h,(rayfield/256)/4
    call findpixel
    ld e,a
    ld a,(de)
    ld c,a

raycastnofp:
    ;** main part -- cast 256 rays (unless I changed it) **
    ld b,4
    ld de,routtable
	ld (hlsave1+1),hl
	ld (hlsave2+1),hl
drawloopout:
	ld (bcsave1+1),bc		;eats memory, but saves many clocks
	ld (bcsave2+1),bc
    call getix
    push de
angles:
    ld de,alicostable
drawloop1:
      ld a,(de)
      ld b,a
	  push de
      call drawline
bcsave1:
	  ld bc,0
hlsave1:
	  ld hl,0
	  pop de
      dec e
      jp nz,drawloop1
    pop de
    call getix
    push de
    ld de,(angles+1)
	dec e
drawloop2:
      ld a,(de)
      ld b,a
      push de
      call drawline
bcsave2:
	  ld bc,0
hlsave2:
	  ld hl,0
      pop de
      dec e
      jp p,drawloop2
    pop de
    djnz drawloopout
    ret

getix:
    ld a,(de)
    .db $dd
    ld l,a          ;ld ixl,a
    inc de
    ld a,(de)
    inc de
    .db $dd
    ld h,a          ;ld ixh,a
    ret

findpixel:
    ld a,d
    add a,a
    add a,a
    ld l,a
    ld a,e
    rra
    add hl,hl
    rra
    add hl,hl
    rra
    add a,l
    ld l,a
    ld a,e
    ld d,alimasktable/256
    and d                   ;thanks to Code7 for this trick
    ret

drawline:
    ;draws a line in polar coords...
    ;inputs:
    ;hl = start video address
    ;c = start mask
    ;e = angle (0-32, ie/0-45 degrees)
    ;b = line length
    ;ix = address of routine to use
    ;   this specifies what part of the screen you're on

    ;** find tangent of the angle **
    ld d,alitantable/256
    ld a,(de)

    jp (ix)

lowline1:
    ld (llcount1+1),a
    xor a
    ld de,15
lowline1loop:
      ex af,af'
	  ld a,h
      set 4,h
      add a,(hl)
      jr c,lclip1
	  ld h,a
endlclip1:
      ld a,c
      and (hl)
      ld (hl),a
      ex af,af'
llcount1:
      add a,0
      jr nc,llmid1        ;taken ~1/2
      rrc c
      sbc hl,de
      djnz lowline1loop
    ret
llmid1:
      rrc c
      jr nc,llincl1        ;taken 1/8
		ex af,af'
		djnz endlclip1
    ret
llincl1:
	  inc l
	  djnz lowline1loop
	ret

lclip1:
	  add a,$a8
	  ret c
	  ld h,a
	  ld a,b
	  cp 4
	  jp c,endlclip1
	  ld b,4
	  jp endlclip1

lowline2:
    ld (llcount2+1),a
    xor a
    ld de,-17
lowline2loop:
      ex af,af'
	  ld a,h
      set 4,h
      add a,(hl)
      jr c,lclip2
	  ld h,a
endlclip2:
      ld a,c
      and (hl)
      ld (hl),a
      ex af,af'
llcount2:
      add a,0
      jr nc,llmid2        ;taken ~1/2
      rlc c
      adc hl,de
      djnz lowline2loop
    ret
llmid2:
      rlc c
      jr nc,lldecl2        ;taken 1/8
		ex af,af'
		djnz endlclip2
    ret
lldecl2:
	  dec l
	  djnz lowline2loop
	ret

lclip2:
	  add a,$a8
	  ret c
	  ld h,a
	  ld a,b
	  cp 4
	  jp c,endlclip2
	  ld b,4
	  jp endlclip2

lowline3:
    ld (llcount3+1),a
    xor a
    ld de,15
lowline3loop:
      ex af,af'
	  ld a,h
      set 4,h
      add a,(hl)
      jr c,lclip3
	  ld h,a
endlclip3:
      ld a,c
      and (hl)
      ld (hl),a
      ex af,af'
llcount3:
      add a,0
      jr nc,llmid3        ;taken ~1/2
      rlc c
      adc hl,de
      djnz lowline3loop
    ret
llmid3:
      rlc c
      jr nc,lldecl3        ;taken 1/8
		ex af,af'
		djnz endlclip3
    ret
lldecl3:
	  dec l
	  djnz lowline3loop
	ret

lclip3:
	  add a,$a8
	  ret c
	  ld h,a
	  ld a,b
	  cp 4
	  jp c,endlclip3
	  ld b,4
	  jp endlclip3

lowline4:
    ld (llcount4+1),a
    xor a
    ld de,-17
lowline4loop:
      ex af,af'
	  ld a,h
      set 4,h
      add a,(hl)
      jr c,lclip4
	  ld h,a
endlclip4:
      ld a,c
      and (hl)
      ld (hl),a
      ex af,af'
llcount4:
      add a,0
      jr nc,llmid4        ;taken ~1/2
      rrc c
      sbc hl,de
      djnz lowline4loop
    ret
llmid4:
      rrc c
      jr nc,llincl4        ;taken 1/8
		ex af,af'
		djnz endlclip4
    ret
llincl4:
	  inc l
	  djnz lowline4loop
	ret

lclip4:
	  add a,$a8
	  ret c
	  ld h,a
	  ld a,b
	  cp 4
	  jp c,endlclip4
	  ld b,4
	  jp endlclip4

highline1:
    ld (hlcount1+1),a
    ld a,$ff
    ld de,-16+$1000
	set 4,h
highline1loop:
      ex af,af'
      ld a,h
      add a,(hl)
      jr c,hclip1
endhclip1:
	  res 4,h
	  ld a,c
      and (hl)
      ld (hl),a
      ex af,af'
hlcount1:
      add a,0
      jr nc,hlmid1        ;taken ~1/2
      rrc c
	  jr nc,hlincl1			;taken 1/8
hlmid1:
      add hl,de
      djnz highline1loop
    ret
hlincl1:
	  inc l
	  add hl,de
	  djnz highline1loop
	ret

hclip1:
	  add a,$a8
	  ret c
	  ld a,b
	  cp 4
	  jp c,endhclip1
	  ld b,4
	  jp endhclip1

highline2:
    ld (hlcount2+1),a
    ld a,$ff
    ld de,-16+$1000
	set 4,h
highline2loop:
      ex af,af'
      ld a,h
      add a,(hl)
      jr c,hclip2
endhclip2:
	  res 4,h
	  ld a,c
      and (hl)
      ld (hl),a
      ex af,af'
hlcount2:
      add a,0
      jr nc,hlmid2        ;taken ~1/2
      rlc c
      adc hl,de
	  dec l
	  djnz highline2loop
	ret
hlmid2:
      add hl,de
      djnz highline2loop
    ret

hclip2:
	  add a,$a8
	  ret c
	  ld a,b
	  cp 4
	  jp c,endhclip2
	  ld b,4
	  jp endhclip2

highline3:
    ld (hlcount3+1),a
    ld a,$ff
	set 4,h
    ld de,16+$1000
highline3loop:
      ex af,af'
      ld a,h
      add a,(hl)
      jr c,hclip3
endhclip3:
	  res 4,h
	  ld a,c
      and (hl)
      ld (hl),a
      ex af,af'
hlcount3:
      add a,0
      jr nc,hlmid3        ;taken ~1/2
      rlc c
      adc hl,de
	  dec l
	  djnz highline3loop
	ret
hlmid3:
      add hl,de
      djnz highline3loop
    ret

hclip3:
	  add a,$a8
	  ret c
	  ld a,b
	  cp 4
	  jp c,endhclip3
	  ld b,4
	  jp endhclip3

highline4:
    ld (hlcount4+1),a
    ld a,$ff
	set 4,h
    ld de,16+$1000
highline4loop:
      ex af,af'
      ld a,h
      add a,(hl)
      jr c,hclip4
endhclip4:
	  res 4,h
	  ld a,c
      and (hl)
      ld (hl),a
      ex af,af'
hlcount4:
      add a,0
      jr nc,hlmid4       ;taken ~1/2
      rrc c
      jr nc,hlincl4        ;taken 1/8
hlmid4:
      add hl,de
      djnz highline4loop
    ret
hlincl4:
	  inc l
	  add hl,de
	  djnz highline4loop
	ret

hclip4:
	  add a,$a8
	  ret c
	  ld a,b
	  cp 4
	  jp c,endhclip4
	  ld b,4
	  jp endhclip4

spriteemup:
    ;** very fast sprite routine **
    ;draws an unaligned grayscale masked clipped sprite in ~3500 clocks
    ;inputs: d=y-coord e=x-coord ix=pointer to sprite
    ;sprite format...  mask, dark, light, 8x8 only
	ld c,0
	ld h,c
	ld a,d
	sub 8
	jr nc,nocliptop
	neg
	ld c,a
	xor a
	ld b,a
	add ix,bc
nocliptop:
	ld d,a
	sub 57
	jr c,noclipbottom
	inc a
	ld c,a
noclipbottom:
    call findpixel
    ex de,hl
    add a,a
    add a,spritedata/256
    ld h,a
	.db $fd
	ld l,e
	ld a,d
	add a,rayfield/256
	.db $fd
	ld h,a
	call xorpage
	add a,d
	ld d,a
    ld a,8
	sub c
	ret z

spriteloop:
    ex af,af'

	ld c,(ix+0)
	ld a,e
	and %00001111
	cp 14
	jr nc,clipright

	inc h

	ld b,(iy+1)
    ld a,(de)               ;dark layer, right byte
    cpl
	ld l,c
    or (hl)
    cpl
    ld l,(ix+8)
    or (hl)
	or b
    ld (de),a

    set 2,d                 ;$f8->$fc or $f0->f4
    ld a,(de)               ;light layer, right byte
    cpl
    ld l,c
    or (hl)
    cpl
    ld l,(ix+16)
    or (hl)
	or b
    ld (de),a
	res 2,d

	dec h

clipright:
	dec e
	ld a,e
	and %00001111
	cp 14
	jr nc,clipleft

	ld b,(iy+0)
    ld a,(de)               ;dark layer, right byte
    cpl
    ld l,c
    or (hl)
    cpl
    ld l,(ix+8)
    or (hl)
	or b
    ld (de),a

	set 2,d
    ld a,(de)               ;light layer, right byte
    cpl
    ld l,c
    or (hl)
    cpl
    ld l,(ix+16)
    or (hl)
	or b
    ld (de),a
	res 2,d

clipleft:
	inc e
    inc ix
	ex de,hl
	ld bc,16
	add hl,bc
	ex de,hl
	add iy,bc

    ex af,af'
    dec a
    jp nz,spriteloop        ;little faster than using djnz
    ret

intcode:
    push af                 ;not using af'
    exx

    ld a,($c008)            ;save a few bytes by putting this here
    out (2),a               ;use whatever contrast is stored in memory

	ld hl,keydata+6			;check all 7 keymasks and store the results
	ld b,%10111111			;for each...
keyhandler:
		ld a,b
		out (1),a
		nop
		nop
		in a,(1)
		ld (hl),a
		dec hl
		rrc b
		jr c,keyhandler

    ld hl,intcounter
    inc (hl)
    in a,(3)
    bit 1,a
    jr z,norefresh
page equ $ebeb+$-intcode
      ld a,$f8
      srl c
      jr nz,cnotzero
grayratiosave equ $+1		;one address for use in ints, one for storage
grayratio equ $ebeb+$-intcode+1
        ld c,%00000100      ;standard 1:2 mixing
cnotzero:
      jr nc,nocarry
        add a,4
nocarry:
      out (0),a
norefresh:
    ld a,%00001000
    out (3),a
    ld a,%00001011
    out (3),a
    exx
    pop af
    ei
    ret
endintcode:

routtable:
    .dw lowline1
    .dw highline1
    .dw highline2
    .dw lowline2
    .dw lowline3
    .dw highline3
    .dw highline4
    .dw lowline4

directiontable:
	.db 0		;%0000 = up-right-left-down
db2:
	.db 2		;%0001 = up-right-left
	.db	0		;%0010 = up-right-down
	.db	1		;%0011 = up-right
	.db	4		;%0100 = up-left-down
	.db 3		;%0101 = up-left
	.db 0		;%0110 = up-down
	.db	2		;%0111 = up
	.db 6		;%1000 = right-left-down
	.db 0		;%1001 = right-left
	.db 7		;%1010 = right-down
	.db	0		;%1011 = right
	.db	5		;%1100 = left-down
	.db	4		;%1101 = left
	.db 6		;%1110 = down

spawntable:
	;offsets for spawning sub-objects (ex/ the sword)
	.dw 8			;right
	.dw (-8*256)+8	;up-right
	.dw (-8*256)	;up
	.dw (-8*256)-8	;up-left
	.dw -8			;left
	.dw (8*256)-8	;down-left
	.dw (8*256)		;down
	.dw (8*256)+8	;down-right

movetable:
	;hm, remarkably similar to spawntable...
	.dw 1			;right
	.dw (-1*256)+1	;up-right
	.dw (-1*256)	;up
	.dw (-1*256)-1	;up-left
	.dw -1			;left
	.dw (1*256)-1	;down-left
	.dw (1*256)		;down
	.dw (1*256)+1	;down-right

pdeadtext:
	.db "You were killed!",0

stringa:
    .db $0c,1,'A'-1

savelist:
    .dw mapwidth
    .dw screen
    .dw playerx
    .dw playery

tantable16:
	;table for 128 total angles
	.db 0,13,25,38,51,64,78,92,106,121,137,153
	.db 171,190,210,232,255

costable16:
	;table for 128 total angles
	.db 32,32,32,32,31,31,31,30,30,29,28,27,27
	.db 26,25,24,23

tantable32:
    ;256*tan 0-45 degrees in 45/32 degree increments
    .db 0,6,13,19,25,32,38,44,51,57,64,71,78,85,92,99
    .db 106,113,121,129,137,145,153,162,171,180,190,200
    .db 210,221,232,244,255

costable32:
    ;32*cos 0-45 degrees in 45/32 degree increments
    .db 32,32,32,32,32,32,32,32,31,31,31,31,31,30,30,30
    .db 30,29,29,29,28,28,27,27,27,26,26,25,25,24,24,23
    .db 23

attribstext:
	.db "ATTRIBUTES",0
	.db "strength",0
	.db "dexterity",0
	.db "constitution",0
	.db "perception",0

creationcoords:
	;text coordinates (vertical) for character creation screen
	.db 17
	.db 24
	.db 30
	.db 36
	.db 42

xptable:
	;xp needed for each level, starting with 2
	;(level 1 is 100, defined above)
	.dw 220
	.dw 360
	.dw 550
	.dw 800
	.dw 1100
	.dw 1500
	.dw 2000
	.dw 2750
	.dw 5000
	.dw 8000
	.dw 65000

ranktitles:
	.dw unknowntext
	.dw juniortext
	.dw novicetext
	.dw journeymantext
	.dw professtext
	.dw renownedtext
	.dw famedtext
	.dw ascendanttext
	.dw mastertext
	.dw gmastertext
	.dw unrivaledtext
	.dw immortaltext

unknowntext:
	.db "unknown",0
juniortext:
	.db "junior",0
novicetext:
	.db "novice",0
journeymantext:
	.db "journeyman",0
professtext:
	.db "professional",0
renownedtext:
	.db "renowned",0
famedtext:
	.db "famed",0
ascendanttext:
	.db "ascendant",0
mastertext:
	.db "master",0
gmastertext:
	.db "legendary",0
unrivaledtext:
	.db "unrivaled",0
immortaltext:
	.db "immortal",0


gfxgenlist:
	.dw playergfx
	.dw playerright

	.dw playergfx2
	.dw playerright2

	.dw playergfxp
	.dw playerpain

	.dw playergfxd
	.dw playerdie

	.dw playergfxa
	.dw playerattack

	.dw playergfxa2
	.dw playerattack2

	.dw playergfxa3
	.dw playerattackalt

	.dw stairgfx
	.dw stairsright

	.dw doorgfx
	.dw doorright

	.dw doorswinggfx
	.dw doorswingright

	.dw doorswing2gfx
	.dw doorswing2right

	.dw dooropengfx
	.dw dooropenright

	.dw chestgfx
	.dw chest

	.dw lampgfx
	.dw lamp

	.dw lampgfx2
	.dw lamp2

	.dw lampgfx3
	.dw lamp3

	.dw lampgfx4
	.dw lamp4

	.dw gooballgfx1
	.dw gooball1

	.dw gooballgfx2
	.dw gooball2

	.dw gooballgfx3
	.dw gooball3

titletext:
	.db 12,45
	.db "F1 - New Game",0
	.db 68,45
	.db "F2 - Load Game",0
	.db 12,51
	.db "F3 - Exit",0
	.db 68,51
	.db "F4 - Help",0
	.db 40,57
	.db "F5 - Continue",0

#ifndef LEVEL_SELECTOR
blmapname:
	.db 5,"blmap"
#endif

#include raydata.asm
#include raysprites.asm				;non-rotatable only
#include packicons.asm
#include d86i_custom.inc
#include sidebar.asm