modtotal equ 111			;number of entries in modifiertab

    ;table of object graphics...
objectptrs:
object_invis equ 0			;not drawn
object_fire equ 1
    .dw fire
object_stairsright equ 2
	.dw stairgfx
object_stairsup equ 3
	.dw stairgfx+24
object_stairsleft equ 4
	.dw stairgfx+48
object_stairsdown equ 5
	.dw stairgfx+72
object_player equ 6
object_playerright equ 6
	.dw playergfx
object_playerup equ 7
	.dw playergfx+24
object_playerleft equ 8
	.dw playergfx+48
object_playerdown equ 9
	.dw playergfx+72
object_doorright equ 10
	.dw doorgfx
object_doorup equ 11
	.dw doorgfx+24
object_doorleft equ 12
	.dw doorgfx+48
object_doordown equ 13
	.dw doorgfx+72
object_switch equ 14
	.dw switch
object_chestright equ 15
	.dw chestgfx
object_chestup equ 16
	.dw chestgfx+24
object_chestleft equ 17
	.dw chestgfx+48
object_chestdown equ 18
	.dw chestgfx+72
object_fountain equ 19
	.dw fountain
object_block equ 20
	.dw block
object_fireball equ 21
	.dw fireball
object_sword equ 22
	.dw swordgfx
object_cloud equ 23
	.dw newcloud
object_formspawn equ 24
	.dw formspawn1
object_enemy1 equ 25
object_enemy1right equ 25
	.dw enemy1
object_enemy1up equ 26
	.dw enemy1+24
object_enemy1left equ 27
	.dw enemy1+48
object_enemy1down equ 28
	.dw enemy1+72
object_enemy2 equ 29
object_enemy2right equ 29
	.dw enemy2
object_enemy2up equ 30
	.dw enemy2+24
object_enemy2left equ 31
	.dw enemy2+48
object_enemy2down equ 32
	.dw enemy2+72
object_enemy3 equ 33
object_enemy3right equ 33
	.dw enemy3
object_enemy3up equ 34
	.dw enemy3+24
object_enemy3left equ 35
	.dw enemy3+48
object_enemy3down equ 36
	.dw enemy3+72
object_enemy4 equ 37
object_enemy4right equ 37
	.dw enemy4
object_enemy4up equ 38
	.dw enemy4+24
object_enemy4left equ 39
	.dw enemy4+48
object_enemy4down equ 40
	.dw enemy4+72
object_lampright equ 41
	.dw lampgfx
object_lampup equ 42
	.dw lampgfx+24
object_lampleft equ 43
	.dw lampgfx+48
object_lampdown equ 44
	.dw lampgfx+72
object_wallblock equ 45
	.dw wallblock
object_gooballright equ 46
	.dw gooballgfx1
object_gooballup equ 47
	.dw gooballgfx1+24
object_gooballleft equ 48
	.dw gooballgfx1+48
object_gooballdown equ 49
	.dw gooballgfx1+72
object_bubble equ 50
	.dw bubble1

;inputs to ai:
;	de=object in objlist

ai_player equ 0
ai_animate2 equ 1
ai_static equ 2
ai_swingweapon equ 3			;internal use only!
ai_wander equ 4
ai_track equ 5
ai_slowtrack equ 6
ai_dying equ 7					;internal use only!
ai_shoot equ 8
ai_facer equ 9
ai_shooter equ 10
ai_cloudkill equ 11
ai_spawnform equ 12
ai_animate4 equ 13
ai_path equ 14
ai_turnpath equ 15
ai_firepath equ 16
ai_trackpath equ 17
ai_trackandshoot equ 18
ai_respond equ 19
ai_imwander equ 20
ai_respondelse equ 21
ai_respondcon equ 22			;"continuous"
ai_pushblock equ 23				;internal use only!
ai_passivetrack equ 24
ai_animate2r equ 25				;for rotatable objects
ai_animate4r equ 26
ai_delay equ 27
ai_shootr equ 28				;rotatable...
ai_rshooter equ 29
ai_rtrackandshoot equ 30

ailist:
    .dw playerstuff
    .dw animate2
    .dw static
	.dw swingweapon
	.dw aiwander
	.dw aitrack
	.dw slowtrack
	.dw dying
	.dw shoot
	.dw facer
	.dw shooter
	.dw cloudkill
	.dw spawnform
	.dw animate4
	
#if 0
	.dw path
	.dw turnpath
	.dw firepath
	.dw trackpath
#else
	.dw 0,0,0,0
#endif

	.dw trackandshoot
	.dw airespond
	.dw aiwander
	.dw airespcondition
	.dw airespalways
	.dw blockai
	.dw passivetrack
	.dw animate2r
	.dw animate4r
	.dw delay
	.dw shootr
	.dw rshooter
	.dw rtrackandshoot

;inputs to response ai:
;	e=lsb of responding object+5
;	d=lsb of current object

rai_text equ 0
rai_teleport equ 1
rai_ststele equ 2
rai_opendoor equ 3
rai_keydoor equ 4
rai_switch equ 5
rai_sdoor equ 6
rai_giveloot equ 7
rai_givespec equ 8
rai_onetext equ 9
rai_advance equ 10
rai_givehealth equ 11
rai_pushblock equ 12
rai_trigger equ 13
rai_condition equ 14
rai_solidtrigger equ 15
rai_nftrigger equ 16				;alternate trigger routines that are repeatable
rai_nfsolidtrigger equ 17
rai_conditionelse equ 18
rai_chain equ 19
rai_setdesc equ 20
rai_checkitem equ 21
rai_takeitem equ 22
rai_loadlights equ 23
rai_checkflag equ 24				;flag routines for use with chained responses...
rai_flagobject equ 25
rai_unflagobject equ 26
rai_xorflag equ 27
rai_link equ 28
rai_xorothers equ 29
rai_checkother equ 30
rai_curse equ 31
rai_lighttrigger equ 32
rai_remove equ 33
rai_removeother equ 34
rai_random equ 35
rai_reltrigger equ 36
rai_flagother equ 37
rai_endgame equ 38
rai_alterai equ 39
rai_code equ 40

responseailist:
	;*** = player only
    .dw text			;***
	.dw teleport		;***
	.dw ststele
	.dw opendoor
	.dw keydoor			;***
	.dw aiswitch
	.dw text			;*** (for switch doors)
	.dw giveloot		;***
	.dw givespec		;***
	.dw onetext			;***
	.dw advance			;***
	.dw givehealth		;***
	.dw pushblock
	.dw trigger
	.dw condition
	.dw solidtrigger
	.dw trigger
	.dw solidtrigger
	.dw conditionelse
	.dw chain
	.dw setdesc
	.dw checkitem		;*** (kinda)
	.dw takeitem		;***
	.dw loadlightsources
	.dw checkflag
	.dw flagobject
	.dw unflagobject
	.dw xorflag
	.dw linkresponse
	.dw xorothers
	.dw checkother
	.dw curse
	.dw lighttrigger
	.dw rairemove		;removetotal for originals, killobject for temps
	.dw removeother
	.dw rairandom
	.dw reltrigger
	.dw flagother
	.dw endofgame
	.dw alterai
	.dw docode

;routines to execute when flagged
;corresponds to response ai
;inputs: a=object+5
;stuff that's "static" is mainly used in scripts...
flaglist:
	.dw removetotal		;enemies should be removed if flagged
	.dw floot			;teleporters (aren't flagged normally)
	.dw floot			;""
	.dw dooropen		;doors should stay open
	.dw dooropen		;key-opened doors
	.dw fswitch			;switches
	.dw dooropen		;switch-opened doors
	.dw floot			;chests
	.dw floot			;specific chests
	.dw removetotal		;one-time only texts
	.dw static			;level advancment objects
	.dw floot			;fountains (generally not flagged)
	.dw floot			;blocks (generally not flagged)
	.dw removetotal		;triggers
	.dw fcond			;conditional response
	.dw floot			;solid triggers (ie/ you can't walk through them after activation)
	.dw static			;repeatable triggers
	.dw static			;repeatable solid triggers
	.dw fcond			;conditional response (with alternate)
	.dw fcond			;chained responses
	.dw static			;sets save-screen description
	.dw static			;check for item
	.dw static			;take item
	.dw static			;load lightsource data
	.dw static			;flag routines...	check
	.dw static			;flag
	.dw static			;unflag
	.dw static			;xor
	.dw static			;link to other object
	.dw static			;more flag routines...  xor others
	.dw static			;check other
	.dw static			;curse
	.dw static			;load lightsource data and remove object
	.dw removetotal		;unflag, remove from colmap, remove graphic, nuke ai bytes
	.dw static			;as above, but another object
	.dw static			;randomly set c flag
	.dw static			;relative trigger (acts similarly to nfsolid)
	.dw static			;flag (turn on) other
	.dw static			;replace object's ai bytes
	.dw static			;execute special code

	;for use with fcond
flag_die equ 0
flag_makestatic equ rai_giveloot
flag_opendoor equ rai_opendoor
flag_switch equ rai_switch
flag_none equ rai_advance		;(any static works)

fightlength equ 11
fightlist:
	;list of ai types you can attack
	.db ai_player
	.db ai_wander
	.db ai_track
	.db ai_slowtrack
	.db ai_shooter
	.db ai_trackpath
	.db ai_turnpath
	.db ai_trackandshoot
	.db ai_passivetrack
	.db ai_rshooter
	.db ai_rtrackandshoot

setdefcodes:
	;code for each of the above object types
	;to load defensive stats
	;(reverse order)
	.dw trackloaddef
	.dw trackloaddef
	.dw trackloaddef
	.dw trackloaddef
	.dw wanderloaddef
	.dw trackloaddef
	.dw trackloaddef
	.dw trackloaddef
	.dw trackloaddef
	.dw wanderloaddef
	.dw ploaddef

statslist:
	;list of stats for monsters
	;order: hp, shieled bonus, defense rating,
	;	damage reduction, critical defense,
	;	hit recovery, attack rating, damage,
	;	critical attack rating, critical multiplier,
	;	stun time, push-back amount, attack full delay,
	;	attack windup time

	.db 25,0,0,0,0,0,0,6,0,2,5,0,10,5
	.db 32,0,1,1,0,2,1,9,2,2,6,1,9,5
	.db 50,0,4,2,2,3,4,12,3,2,4,2,8,4
	.db 55,0,5,2,4,4,6,13,4,2,6,2,7,3
	.db 58,0,5,2,5,4,7,15,4,2,6,3,7,3
	.db 66,0,6,3,5,4,9,16,5,2,7,4,8,4
	.db 77,1,7,5,7,4,10,18,5,3,9,4,13,7
	.db 76,1,7,2,8,5,10,16,5,2,7,3,7,4
	.db 160,0,12,9,16,6,12,22,6,2,9,4,8,5		;<---- Clavius' stats
	.db 200,0,14,7,16,4,12,15,5,2,6,4,9,5		;<---- Kerric's stats

n_sw equ 4
n_a equ 5
n_sh equ 2
n_o equ 9
n_sk equ 21
n_spm equ 10
n_ssm equ 10
n_apm equ 10
n_asm equ 10
n_pm equ 10
n_shpm equ 10
n_shsm equ 10
n_items equ n_sw+n_a+n_sh+n_o

mods_pswords equ n_sw+n_a+n_sh+n_o+n_sk
mods_sswords equ mods_pswords+n_spm
mods_parmors equ mods_sswords+n_ssm
mods_sarmors equ mods_parmors+n_apm
mods_pots equ mods_sarmors+n_asm
mods_pshields equ mods_pots+n_pm
mods_sshields equ mods_pshields+n_shpm

itemoffsets1:
	;tells where to look for prefix modifiers
	;for each type of object
	;(sword, armor, potion)
	;used in loot generator

	.db n_items+n_sk+1
	.db n_items+n_sk+1
	.db n_items+n_sk+1
	.db n_items+n_sk+1

	.db n_items+n_sk+n_spm+n_ssm+1
	.db n_items+n_sk+n_spm+n_ssm+1
	.db n_items+n_sk+n_spm+n_ssm+1
	.db n_items+n_sk+n_spm+n_ssm+1
	.db n_items+n_sk+n_spm+n_ssm+1

	.db n_items+n_sk+n_spm+n_ssm+n_apm+n_asm+n_pm+1
	.db n_items+n_sk+n_spm+n_ssm+n_apm+n_asm+n_pm+1

	.db 0			;no prefixes for potions
	.db 0			;or elixirs
	.db 0			;no mods on herbs

	;as of demo 10, all mods on "treasure" items are done
	;externally

itemoffsets2:
	;same but for suffix mods

	.db n_items+n_sk+n_spm+1
	.db n_items+n_sk+n_spm+1
	.db n_items+n_sk+n_spm+1
	.db n_items+n_sk+n_spm+1

	.db n_items+n_sk+n_spm+n_ssm+n_apm+1
	.db n_items+n_sk+n_spm+n_ssm+n_apm+1
	.db n_items+n_sk+n_spm+n_ssm+n_apm+1
	.db n_items+n_sk+n_spm+n_ssm+n_apm+1
	.db n_items+n_sk+n_spm+n_ssm+n_apm+1

	.db n_items+n_sk+n_spm+n_ssm+n_apm+n_asm+n_pm+n_shpm+1
	.db n_items+n_sk+n_spm+n_ssm+n_apm+n_asm+n_pm+n_shpm+1

	.db n_items+n_sk+n_spm+n_ssm+n_apm+n_asm+1
	.db n_items+n_sk+n_spm+n_ssm+n_apm+n_asm+1
	.db 0			;no mods on herbs

sk_slash equ n_items+1
sk_stab equ n_items+2
sk_eye equ n_items+3
sk_jab equ n_items+4
sk_berserk equ n_items+5
sk_swing equ n_items+6
sk_thrust equ n_items+7
sk_decap equ n_items+8
sk_shootfire equ n_items+9
sk_slice equ n_items+10
sk_shootmuch equ n_items+11
sk_hamstring equ n_items+12
sk_gut equ n_items+13
sk_mangle equ n_items+14
sk_split equ n_items+15
sk_impale equ n_items+16
sk_rend equ n_items+17
sk_strike equ n_items+18
sk_slay equ n_items+19
sk_sever equ n_items+20
sk_sweep equ n_items+21

item_short equ 1
item_long equ 2
item_two equ 3
item_scim equ 4

item_chain equ n_sw+1
item_plate equ n_sw+2
item_leather equ n_sw+3
item_stleather equ n_sw+4
item_cloak equ n_sw+5

item_kite equ n_sw+n_a+1
item_round equ n_sw+n_a+2

item_potion equ n_sw+n_a+n_sh+1
item_elixir equ n_sw+n_a+n_sh+2
item_herb equ n_sw+n_a+n_sh+3
item_key equ n_sw+n_a+n_sh+4

item_tome equ n_sw+n_a+n_sh+5
item_chalice equ n_sw+n_a+n_sh+6
item_gem equ n_sw+n_a+n_sh+7
item_scroll equ n_sw+n_a+n_sh+8
item_sceptre equ n_sw+n_a+n_sh+9

itemweights:
	.db 0				;empty slot
	.db 12
	.db 20
	.db 35
	.db 20
	.db 28
	.db 50
	.db 14
	.db 18
	.db 8
	.db 25
	.db 25
	.db 4
	.db 5
	.db 2
	.db 0				;keys don't count for burden
	.db 6
	.db 3
	.db 1
	.db 1
	.db 3

gumodobj equ 12		;objects after this always get a second mod

modifiertab:
	;** swords **
	.dw shortmods
	.dw longmods
	.dw twomods
	.dw scimmods

	;** armors **
	.dw chainmod
	.dw platemod
	.dw leathermod
	.dw stleathermod
	.dw trivialmod		;cloaks

	;** shields **
	.dw kitemod
	.dw kitemod

	;** other items **
	.dw trivialmod		;potions
	.dw trivialmod		;elixirs
	.dw trivialmod		;herbs
	.dw trivialmod		;keys

	.dw trivialmod		;tomes
	.dw trivialmod		;chalices
	.dw trivialmod		;gems
	.dw trivialmod		;scrolls
	.dw trivialmod		;sceptres

	;** skills **
skillmods:
	.dw slashmod
	.dw stabmod
	.dw eyemod
	.dw jabmod
	.dw bersmod
	.dw trivialmod
	.dw thrustmod
	.dw decapmod
	.dw shootfiremod
	.dw slicemod
	.dw shootmuchmod
	.dw hammod
	.dw gutmod
	.dw manglemod
	.dw splitmod
	.dw impalemod
	.dw rendmod
	.dw strikemod
	.dw slaymod
	.dw severmod
	.dw sweepmod

	;** prefix mods for swords **
	.dw sharpmod		;+2 critical attack
	.dw finemod			;+1 attack
	.dw blindmod		;+6 stun time
	.dw obsidmod		;+1 crit mod
	.dw lionmod			;+2 damage, +1 pushback
	.dw jaggedmod		;+1 crit mod, +2 damage
	.dw diamod			;+3 crit attack, +2 damage
	.dw overlordmod		;+4 attack, +3 damage
	.dw heromod			;+4 damage, +2 critical attack
	.dw blazemod		;2 fire moves, +3 damage, +2 attack

	;** suffix mods for swords **
	.dw painmod			;+4 stun time
	.dw brilliancemod	;+1 damage, +1 attack
	.dw agilemod		;+2 defense, +2 hit recovery
	.dw vampmod			;+1 attack, restores health
	.dw bansheemod		;+3 pushback, +1 damage
	.dw murdermod		;+4 damage
	.dw firemod			;+1 damage, fireball move
	.dw demonmod		;+3 damage, +3 attack, +1 crit attack
	.dw terrormod		;+4 stun time, +4 damage, +1 strength
	.dw furymod			;+4 damage, +2 attack, +3 pushback

	;** prefix mods for armors **
	.dw radiantmod					;+2 critical defense
	.dw hardmod						;+1 armor
	.dw blackenmod					;-1 damage
	.dw supmod						;+1 recovery, +1 armor
	.dw resilmod					;+3 armor
	.dw knightmod					;-2 damage, +1 armor
	.dw wolfmod						;+3 dex, +2 hit recovery
	.dw heromod2					;-2 damage, +3 armor
	.dw champmod					;+4 armor, +1 dex, +2 hit recovery
	.dw peerlessmod					;+1 con, +4 critical defense, +4 armor

	;** suffix mods for armors **
	.dw hardmod						;+1 armor
	.dw beastmod					;-1 damage, +1 critical defense
	.dw harmomod					;+3 hit recovery
	.dw powermod					;+3 strength
	.dw valormod					;+1 to all stats
	.dw protectmod					;+2 armor, +5 critical defense
	.dw deliverancemod				;-2 damage, +5 critical defense
	.dw gstrmod						;13 str
	.dw heromod2					;-2 damage, +3 armor
	.dw legmod						;+5 armor, -1 damage, +1 hit recovery

	;** mods for potions **
	.dw defensemod
	.dw accumod
	.dw ragemod
	.dw percmod
	.dw defiancemod
	.dw fortmod
	.dw invulnmod
	.dw ironskinmod
	.dw titanmod
	.dw malevmod

	;** prefix mods for shields **
	.dw radiantmod					;+2 critical defense
	.dw shhardmod					;+1 armor
	.dw blackenmod					;-1 damage
	.dw lightmod					;faster windup time
	.dw shsupmod					;-1 recovery, +1 armor
	.dw falconmod					;faster windup, +2 armor
	.dw shknightmod					;-2 damage, +1 armor
	.dw shheromod2					;-2 damage, +3 armor
	.dw shchampmod					;+4 armor, +1 dex, +2 hit recovery
	.dw shpeerlessmod				;+1 con, +4 critical defense, +4 armor

	;** suffix mods for shields **
	.dw shhardmod					;+1 armor
	.dw beastmod					;-1 damage, +1 critical defense
	.dw harmomod					;+3 hit recovery
	.dw powermod					;+3 strength
	.dw shprotectmod				;+2 armor, +5 critical defense
	.dw deliverancemod				;-2 damage, +5 critical defense
	.dw gstrmod						;13 str
	.dw starsmod					;+4 armor
	.dw endurmod					;13 con
	.dw shlegmod					;+5 armor, -1 damage, +1 hit recovery

modtexts:
	;** swords **
	.dw shortswordtext
	.dw longswordtext
	.dw twoswordtext
	.dw scimitartext

	;** armors **
	.dw chainmailtext
	.dw platemailtext
	.dw leathertext
	.dw stleathertext
	.dw cloaktext

	;** shields **
	.dw kitetext
	.dw roundtext

	;** other items **
	.dw potiontext
	.dw elixirtext
	.dw herbtext
	.dw keytext
	
	.dw tometext
	.dw chalicetext
	.dw gemtext
	.dw scrolltext
	.dw sceptretext

	;** skills **
	.dw slashtext
	.dw stabtext
	.dw eyetext
	.dw jabtext
	.dw berstext	
	.dw swingtext
	.dw thrusttext
	.dw decaptext
	.dw shootfiretext
	.dw slicetext
	.dw shootmuchtext
	.dw hamtext
	.dw guttext
	.dw mangletext
	.dw splittext
	.dw impaletext
	.dw rendtext
	.dw striketext
	.dw slaytext
	.dw severtext
	.dw sweeptext

	;** prefix mods for swords **
	.dw sharptext
	.dw finetext
	.dw blindtext
	.dw obsidtext
	.dw liontext
	.dw jaggedtext
	.dw diatext
	.dw overlordtext
	.dw herotext
	.dw blazetext

	;** suffix mods for swords **
	.dw paintext
	.dw brilliancetext
	.dw agiletext
	.dw vamptext
	.dw bansheetext
	.dw murdertext
	.dw firetext
	.dw demontext
	.dw terrortext
	.dw furytext

	;** prefix mods for armors **
	.dw radianttext
	.dw hardtext
	.dw blackentext
	.dw suptext
	.dw resiltext
	.dw knighttext
	.dw wolftext
	.dw herotext
	.dw champtext
	.dw peerlesstext
	
	;** suffix mods for armors **
	.dw heavenstext
	.dw beasttext
	.dw harmotext
	.dw powertext
	.dw valortext
	.dw protecttext
	.dw deliverancetext
	.dw gstrtext
	.dw agestext
	.dw legtext

	;** mods for potions **
	.dw defensetext				;+2 defense
	.dw accutext				;+2 attack
	.dw ragetext				;+3 damage
	.dw perctext				;+6 perception
	.dw defiancetext			;+3 defense, -1 damage
	.dw forttext				;15 constitution
	.dw invulntext				;+5 defense
	.dw ironskintext			;-7 damage
	.dw titantext				;18 strength
	.dw malevtext				;+5 crit rate, +1 crit mod

	;** prefix mods for shields **
	.dw radianttext
	.dw hardtext
	.dw blackentext
	.dw lighttext
	.dw suptext
	.dw falcontext
	.dw knighttext
	.dw herotext
	.dw champtext
	.dw peerlesstext
	
	;** suffix mods for shields **
	.dw heavenstext
	.dw beasttext
	.dw harmotext
	.dw powertext
	.dw protecttext
	.dw deliverancetext
	.dw gstrtext
	.dw starstext
	.dw endurtext
	.dw legtext

sceptretext:
	.db "scepter",0

falcontext:
	.db "falcon's",0
falconmod:
	.db 2
	.db v_pwindup
	.db -1
	.db v_pshield
	.db 2

jaggedtext:
	.db "jagged",0
jaggedmod:
	.db 2
	.db v_pdamage
	.db 2
	.db v_pcritmod
	.db 1

knighttext:
	.db "knight's",0
knightmod:
	.db 2
	.db v_pdamreduct
	.db 2
	.db v_pdef
	.db 1
shknightmod:
	.db 2
	.db v_pdamreduct
	.db 2
	.db v_pshield
	.db 1

wolftext:
	.db "wolf's",0
wolfmod:
	.db 2
	.db v_pdex
	.db 3
	.db v_precoverytime
	.db 2

starstext:
	.db "the stars",0
starsmod:
	.db 1
	.db v_pdef
	.db 4

endurtext:
	.db "endurance",0
endurmod:
	.db 1
	.db $80+v_pcon
	.db 13
	
resiltext:
	.db "resilient",0
resilmod:
	.db 1
	.db v_pdef
	.db 3

peerlesstext:
	.db "peerless",0
peerlessmod:
	.db 3
	.db v_pdef
	.db 4
	.db v_pcritreduct
	.db 4
	.db v_pcon
	.db 1
shpeerlessmod:
	.db 3
	.db v_pshield
	.db 4
	.db v_pcritreduct
	.db 4
	.db v_pcon
	.db 1

agestext:
	.db "the ages",0

valortext:
	.db "valor",0
valormod:
	.db 4
	.db v_pstr
	.db 1
	.db v_pcon
	.db 1
	.db v_pdex
	.db 1
	.db v_pper
	.db 1

bansheetext:
	.db "the banshee",0
bansheemod:
	.db 2
	.db v_ppushback
	.db 3
	.db v_pdamage
	.db 1

obsidtext:
	.db "obsidian",0
obsidmod:
	.db 1
	.db v_pcritmod
	.db 1

sweeptext:
	.db "sweep",0
sweepmod:
	.db 4
	.db $80+v_sframesbase
	.db 5
	.db v_pcritrate
	.db -3
	.db v_pstuntime
	.db 12
	.db v_ppushback
	.db 1

malevtext:
	.db "malevolence",0
malevmod:
	.db 2
	.db v_pcritrate
	.db 5
	.db v_pcritmod
	.db 1

titantext:
	.db "titan's strength",0
titanmod:
	.db 1
	.db $80+v_pstr
	.db 18

ironskintext:
	.db "iron skin",0
ironskinmod:
	.db 1
	.db v_pdamreduct
	.db 7

lighttext:
	.db "light",0
lightmod:
	.db 1
	.db v_pwindup
	.db -1

severtext:
	.db "sever",0
severmod:
	.db 7
	.db v_pwindup
	.db 1
	.db $80+v_sframesbase
	.db 4
	.db $80+v_swordbase
	.db -2
	.db v_pstuntime
	.db 8
	.db v_pdamage
	.db 3
	.db v_pcritrate
	.db 3
	.db v_ppushback
	.db 1

slaytext:
	.db "slay",0
slaymod:
	.db 7
	.db v_pwindup
	.db 3
	.db v_stimerbase
	.db 3
	.db v_pstuntime
	.db 6
	.db v_pdamage
	.db 4
	.db v_pcritrate
	.db 5
	.db v_pcritmod
	.db 2
	.db $80+v_windframe
	.db 4*4

impaletext:
	.db "impale",0
impalemod:
	.db 6
	.db v_stimerbase
	.db 3
	.db $80+v_sframesbase
	.db 1
	.db v_pstuntime
	.db 2
	.db v_pdamage
	.db 1
	.db v_pcritrate
	.db 7
	.db $80+v_windframe
	.db 4*6

scrolltext:
	.db "scroll",0

shhardmod:							;+1 shield
	.db 1
	.db v_pshield
	.db 1
shsupmod:							;+1 recovery, +1 shield
	.db 2
	.db v_pshield
	.db 1
	.db v_precoverytime
	.db 1
shheromod2:							;-2 damage, +3 shield
	.db 2
	.db v_pdamreduct
	.db 2
	.db v_pshield
	.db 3
shchampmod:							;+4 shield, +1 dex, +2 hit recovery
	.db 3
	.db v_pshield
	.db 4
	.db v_pdex
	.db 1
	.db v_precoverytime
	.db 2
shlegmod:							;+5 shield, -1 damage, +1 hit recovery
	.db 3
	.db v_pshield
	.db 5
	.db v_pdamreduct
	.db 1
	.db v_precoverytime
	.db 1

shprotectmod:						;+2 shield, -50 criticals
	.db 2
	.db v_pshield
	.db 2
	.db v_pcritreduct
	.db 5

splittext:
	.db "cleave",0
splitmod:
	.db 7
	.db v_pwindup
	.db 1
	.db v_stimerbase
	.db 2
	.db $80+v_sframesbase
	.db 1
	.db v_pstuntime
	.db 7
	.db v_pdamage
	.db 3
	.db v_pcritrate
	.db 7
	.db v_pcritmod
	.db 1

mangletext:
	.db "mangle",0
manglemod:
	.db 4
	.db v_swordbase
	.db -2
	.db $80+v_sframesbase
	.db 4
	.db $80+v_special1
	.db spec_reverse
	.db v_pstuntime
	.db 2

kitetext:
	.db "kite shield",0
kitemod:
	.db 2
	.db v_pshield
	.db 2
	.db v_pwindup
	.db 1
roundtext:
	.db "round shield",0
	;same mods as kite shield

elixirtext:
	.db "elixir",0
hamtext:
	.db "gash",0
guttext:
	.db "gut",0
hammod:
	.db 6
	.db $80+v_swordnext
	.db 1
	.db $80+v_sframesbase
	.db 3
	.db v_pwindup
	.db 1
	.db v_pdamage
	.db 3
	.db v_pstuntime
	.db 13
	.db v_pcritmod
	.db 1
gutmod:
	.db 6
	.db $80+v_swordbase
	.db -1
	.db $80+v_sframesbase
	.db 2
	.db v_pwindup
	.db 2
	.db v_pcritrate
	.db 2
	.db v_patt
	.db 2
	.db $80+v_windframe
	.db 4*6
shootmuchtext:
	.db "scorch",0
shootmuchmod:
	.db 5
	.db v_pwindup
	.db 4
	.db $80+v_special1
	.db spec_fire
	.db $80+v_swordnext
	.db -1
	.db $80+v_swordbase
	.db 1
	.db $80+v_sframesbase
	.db 3
	.db v_pcritrate
	.db -5
blazetext:
	.db "blazing",0
blazemod:
	.db 3
	.db $80+v_skill1
	.db 0
	.db sk_shootfire
	.db $80+v_skill2
	.db 4
	.db sk_shootmuch
	.db v_pdamage
	.db 3
furytext:
	.db "fury",0
furymod:
	.db 3
	.db v_ppushback
	.db 3
	.db v_pdamage
	.db 4
	.db v_patt
	.db 2
diatext:
	.db "diamond edged",0
diamod:
	.db 2
	.db v_pdamage
	.db 2
	.db v_pcritrate
	.db 3
tometext:
	.db "tome",0
chalicetext:
	.db "chalice",0
gemtext:
	.db "gem",0

trivialmod:
	.db 1				;system doesn't understand 0's here
	.db v_patt
	.db 0

shootfiretext:
	.db "fireball",0
shootfiremod:
	.db 4
	.db v_pwindup
	.db 3
	.db $80+v_special1	
	.db spec_fire
	.db v_stimerbase
	.db 1
	.db $80+v_sframesbase
	.db 1

invulntext:
	.db "immunity",0
invulnmod:
	.db 1
	.db v_pdef
	.db 5
firetext:
	.db "fire",0
firemod:
	.db 2
	.db v_pdamage
	.db 1
	.db $80+v_skill1
	.db 0
	.db sk_shootfire
legtext:
	.db "legend",0
legmod:
	.db 3
	.db v_pdef
	.db 5
	.db v_pdamreduct
	.db 1
	.db v_precoverytime
	.db 1
gstrtext:
	.db "great strength",0
gstrmod:
	.db 1
	.db $80+v_pstr
	.db 13
vamptext:
	.db "vampires",0
vampmod:
	.db 2
	.db v_patt
	.db 1
	.db $80+v_special2
	.db spec_heal
	
suptext:
	.db "superior",0
supmod:
	.db 2
	.db v_pdef
	.db 1
	.db v_precoverytime
	.db 1
champtext:
	.db "champion's",0
champmod:
	.db 3
	.db v_pdef
	.db 4
	.db v_precoverytime
	.db 2
	.db v_pdex
	.db 1
powertext:
	.db "power",0
powermod:
	.db 1
	.db v_pstr
	.db 3
terrortext:
	.db "terror",0
terrormod:
	.db 3
	.db v_pstuntime
	.db 4
	.db v_pdamage
	.db 4
	.db v_pstr
	.db 1
agiletext:
	.db "agility",0
agilemod:
	.db 2
	.db v_pdef
	.db 2
	.db v_precoverytime
	.db 2
liontext:
	.db "lion's",0
lionmod:
	.db 2
	.db v_pdamage
	.db 2
	.db v_ppushback
	.db 1
harmotext:
	.db "harmony",0
harmomod:
	.db 1
	.db v_precoverytime
	.db 3

perctext:
	.db "clarity",0
percmod:
	.db 1
	.db v_pper
	.db 6

herbtext:
	.db "healing herbs",0

forttext:
	.db "fortitude",0
fortmod:
	.db 1
	.db $80+v_pcon
	.db 15

defensetext:
	.db "defense",0
accutext:	
	.db "accuracy",0
ragetext:
	.db "rage",0
defiancetext:
	.db "defiance",0

defensemod:
	.db 1
	.db v_pdef
	.db 2
accumod:
	.db 1
	.db v_patt
	.db 2
ragemod:
	.db 1
	.db v_pdamage
	.db 3
defiancemod:
	.db 2
	.db v_pdef
	.db 3
	.db v_pdamreduct
	.db 1

potiontext:
	.db "potion",0
keytext:
	.db "key",0

decaptext:
	.db "behead",0

decapmod:
	.db 5
	.db v_pwindup
	.db 2
	.db v_pstuntime
	.db 7
	.db v_pcritmod
	.db 2
	.db v_pcritrate
	.db 5
	.db v_patt
	.db -2

thrusttext:
	.db "thrust",0

thrustmod:
	.db 5
	.db v_pwindup
	.db 1
	.db v_stimerbase
	.db 2
	.db $80+v_sframesbase
	.db 1
	.db v_pcritmod
	.db 1
	.db $80+v_windframe
	.db 4*6

swingtext:
	.db "swing",0
jabtext:
	.db "jab",0
berstext:
	.db "berserk",0

jabmod:
	.db 1
	.db v_pstuntime
	.db 2

bersmod:
	.db 2
	.db $80+v_sframesbase
	.db 8
	.db v_pcritrate
	.db -1

beastmod:
	.db 2
	.db v_pdamreduct
	.db 1
	.db v_pcritreduct
	.db 1
protectmod:
	.db 2
	.db v_pdef
	.db 2
	.db v_pcritreduct
	.db 5
deliverancemod:
	.db 2
	.db v_pdamreduct
	.db 2
	.db v_pcritreduct
	.db 5

radianttext:
	.db "radiant",0
hardtext:
	.db "hardened",0
blackentext:
	.db "blackened",0
heavenstext:
	.db "the heavens",0
beasttext:
	.db "the beast",0
protecttext:
	.db "protection",0
deliverancetext:
	.db "deliverance",0

radiantmod:
	.db 1
	.db v_pcritreduct
	.db 2
hardmod:
	.db 1
	.db v_pdef
	.db 1
blackenmod:
	.db 1
	.db v_pdamreduct
	.db 1
heromod2:
	.db 2
	.db v_pdamreduct
	.db 2
	.db v_pdef
	.db 3

finemod:
	.db 1
	.db v_patt
	.db 1
sharpmod:
	.db 1
	.db v_pcritrate
	.db 2
blindmod:
	.db 1
	.db v_pstuntime
	.db 6
overlordmod:
	.db 2
	.db v_patt
	.db 4
	.db v_pdamage
	.db 3
heromod:
	.db 2
	.db v_pdamage
	.db 4
	.db v_pcritrate
	.db 2

paintext:
	.db "pain",0
brilliancetext:
	.db "brilliance",0
murdertext:
	.db "murder",0
demontext:
	.db "the demon",0

painmod:
	.db 1
	.db v_pstuntime
	.db 4
brilliancemod:
	.db 2
	.db v_patt
	.db 1
	.db v_pdamage
	.db 1
murdermod:
	.db 1
	.db v_pdamage
	.db 4
demonmod:
	.db 3
	.db v_pdamage
	.db 3
	.db v_patt
	.db 3
	.db v_pcritrate
	.db 1

slashmod:
	.db 1
	.db $80+v_swordbase
	.db -1

striketext:
	.db "strike",0
strikemod:
	.db 4
	.db $80+v_swordbase
	.db -2
	.db v_pstuntime
	.db 2
	.db v_pdamage
	.db 1
	.db v_pcritrate
	.db 2

rendtext:
	.db "rend",0
rendmod:
	.db 5
	.db v_pwindup
	.db 1
	.db v_swordbase
	.db -1
	.db v_sframesbase
	.db 1
	.db $80+v_special1
	.db spec_reverse
	.db v_pcritrate
	.db 2

slicetext:
	.db "slice",0
slicemod:
	.db 4
	.db v_pwindup
	.db 1
	.db v_pstuntime
	.db -2
	.db v_swordbase
	.db -1
	.db $80+v_special1
	.db spec_reverse

stabmod:
	.db 3
	.db v_pstuntime
	.db 2
	.db v_pdamage
	.db 2
	.db v_stimerbase
	.db 2

eyemod:
	.db 7
	.db v_pwindup
	.db 3
	.db v_stimerbase
	.db 2
	.db v_pstuntime
	.db 6
	.db v_pdamage
	.db 3
	.db v_pcritrate
	.db 7
	.db v_patt
	.db -1
	.db v_ppushback
	.db 1

shortmods:
	.db 13				;number of stats to modify
	.db v_pdamage		;first stat to modify
	.db 6				;amount to change
	.db v_pwindup
	.db 2
	.db v_pstuntime
	.db 2
	.db v_sframesbase
	.db 1
	.db v_stimerbase
	.db 1
	.db v_pcritrate
	.db 2
	.db v_pcritmod
	.db 2
	.db $80+v_skill1
	.db 0				;skills have proficiency requirements
	.db sk_jab
	.db $80+v_skill2
	.db 2
	.db sk_stab
	.db $80+v_skill3
	.db 5
	.db sk_eye
	.db $80+v_skill4
	.db 9
	.db sk_hamstring
	.db $80+v_skill5
	.db 11
	.db sk_slay
	.db $80+v_windframe
	.db 4*6

longmods:
	.db 15
	.db v_ppushback
	.db 1
	.db $80+v_sframesbase
	.db 3
	.db $80+v_swordnext
	.db 1
	.db v_pwindup
	.db 3
	.db v_pdamage
	.db 8
	.db v_pstuntime
	.db 4
	.db $80+v_stimerbase
	.db 1
	.db v_pcritrate
	.db 2
	.db v_pcritmod
	.db 2
	.db $80+v_skill1
	.db 0
	.db sk_slash
	.db $80+v_skill2
	.db 2
	.db sk_thrust
	.db $80+v_windframe
	.db 4*4
	.db $80+v_skill3
	.db 6
	.db sk_strike
	.db $80+v_skill4
	.db 10
	.db sk_rend
	.db $80+v_skill5
	.db 14
	.db sk_sever


twomods:
	.db 16
	.db v_ppushback
	.db 3
	.db v_pstuntime
	.db 1
	.db $80+v_sframesbase
	.db 4
	.db $80+v_swordnext
	.db 1
	.db $80+v_swordbase
	.db -2
	.db v_pwindup
	.db 3
	.db v_pdamage
	.db 11
	.db $80+v_stimerbase
	.db 1
	.db v_pcritrate
	.db 1
	.db v_pcritmod
	.db 2
	.db $80+v_skill2
	.db 3
	.db sk_berserk
	.db $80+v_skill1
	.db 0
	.db sk_swing
	.db $80+v_skill3
	.db 6
	.db sk_decap
	.db $80+v_skill4
	.db 9
	.db sk_sweep
	.db $80+v_skill5
	.db 11
	.db sk_split
	.db $80+v_windframe
	.db 4*4

scimmods:
	.db 15
	.db v_pwindup
	.db 3
	.db v_pdamage
	.db 8
	.db v_swordnext
	.db 1
	.db v_pstuntime
	.db 4
	.db v_ppushback
	.db 1
	.db $80+v_sframesbase
	.db 3
	.db $80+v_stimerbase
	.db 1
	.db v_pcritrate
	.db 2
	.db v_pcritmod
	.db 2
	.db $80+v_skill1
	.db 0
	.db sk_slash
	.db $80+v_skill2
	.db 5
	.db sk_slice
	.db $80+v_skill3
	.db 7
	.db sk_gut
	.db $80+v_windframe
	.db 4*4
	.db $80+v_skill4
	.db 10
	.db sk_impale
	.db $80+v_skill5
	.db 13
	.db sk_mangle

chainmod:
	.db 2
	.db v_pdef
	.db 2
	.db v_pdamreduct
	.db 1
	.db v_precoverytime
	.db -3

platemod:
	.db 3
	.db v_pdef
	.db 3
	.db v_pdamreduct
	.db 2
	.db v_precoverytime
	.db -4

leathermod:
	.db 2
	.db v_pdef
	.db 1
	.db v_precoverytime
	.db -1

stleathermod:
	.db 2
	.db v_pdef
	.db 2
	.db v_precoverytime
	.db -2

finetext:
	.db "fine",0
sharptext:
	.db "sharp",0
blindtext:
	.db "blinding",0
overlordtext:
	.db "overlord's",0
herotext:
	.db "hero's",0

slashtext:
	.db "slash",0
stabtext:
	.db "stab",0
eyetext:
	.db "eye gouge",0
proftext:
	.db "PROFICIENCIES",0
shortswordtext:
	.db "short sword",0
longswordtext:
	.db "long sword",0
twoswordtext:
	.db "two-handed sword",0
scimitartext:
	.db "scimitar",0
chainmailtext:
	.db "chain mail",0
platemailtext:
	.db "plate mail",0
leathertext:
	.db "leather armor",0
stleathertext:
	.db "studded leather",0
cloaktext:
	.db "cloak",0


.end
