.plugin string86

#define rel(x) x-$-1
#define reltab(x) x-$-3
#include mapdefs.inc

.org 2

	;************
	;** header **
	;************

    .db $fe       				;identify this as a level...
    .db 'r'

	.dw rel(title_string)
	.dw reltab(custom_mods)
	.dw reltab(custom_texts)
	.dw rel(readable_items)
	.dw default_description
	.dw rel(custom_code)

	.db 0,0,0,0,0,0,0,0,0,0		;as yet unused

	.dw rel(world1)
	.dw rel(world2)
	.dw rel(world3)
	.dw rel(world4)
	.dw rel(world5)
	.dw rel(world6)

	;********************
	;** universal data **
	;********************

title_string:
	.db "Blinded by the Dark",0

custom_mods:
	.db 34
	.dw rel(cm_defenselessness)
	.dw rel(cm_hurtin)
	.dw rel(cm_taint)
	.dw rel(cm_libtrap)
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw rel(cm_eternity)
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw rel(cm_zedsword)
	.dw rel(cm_zedshield)
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw rel(cm_demonbile)
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw rel(cm_palemoon2)
	.dw 0
	.dw 0
	.dw 0
	.dw 0
	.dw 0

custom_texts:
	.db 34
	.dw rel(ct_silver)
	.dw rel(ct_gold)
	.dw rel(ct_heavyiron)
	.dw rel(ct_stone)
	.dw rel(ct_tattered)
	.dw rel(ct_warding)
	.dw rel(ct_historical)
	.dw rel(ct_glowing)
	.dw rel(ct_weird)
	.dw rel(ct_strange)
	.dw rel(ct_eternity)
	.dw rel(ct_hastily)
	.dw rel(ct_tarnished)
	.dw rel(ct_focusing)
	.dw rel(ct_triangular)
	.dw rel(ct_zedsword)
	.dw rel(ct_zedshield)
	.dw rel(ct_airgem)
	.dw rel(ct_firegem)
	.dw rel(ct_earthgem)
	.dw rel(ct_watergem)
	.dw rel(ct_clerical)
	.dw rel(ct_demonbile)
	.dw rel(ct_crescent)	
	.dw rel(ct_foreman)
	.dw rel(ct_foreman)
	.dw rel(ct_ancient)
	.dw rel(ct_damascened)
	.dw rel(ct_zedshield)
	.dw rel(ct_gilded)
	.dw rel(ct_singletooth)
	.dw rel(ct_doubletooth)
	.dw rel(ct_tripletooth)
	.dw rel(ct_finalbook)

ct_silver:
	.db "silver",0
ct_gold:
	.db "gold",0
ct_heavyiron:
	.db "heavy iron",0
ct_stone:
	.db "stone",0
ct_tattered:
	.db "tattered",0
ct_warding:
	.db "warding",0
ct_historical:
	.db "historical",0
ct_glowing:
	.db "glowing",0
ct_weird:
	.db "weird",0
ct_strange:
	.db "strange",0
ct_eternity:
	.db "eternity",0
ct_hastily:
	.db "hastily written",0
ct_tarnished:
	.db "tarnished",0
ct_focusing:
	.db "focusing",0
ct_triangular:
	.db "triangular",0
ct_zedsword:
	.db "Zed's",0
ct_zedshield:
	.db "the pale moonlight",0
ct_airgem:
	.db "air",0
ct_firegem:
	.db "fire",0
ct_earthgem:
	.db "earth",0
ct_watergem:
	.db "water",0
ct_clerical:
	.db "clerical",0
ct_demonbile:
	.db "demonic bile",0
ct_crescent:
	.db "crescent shaped",0
ct_foreman:
	.db "foreman's",0
ct_ancient:
	.db "ancient",0
ct_damascened:
	.db "damascened",0
ct_gilded:
	.db "gilded",0
ct_singletooth:
	.db "single toothed",0
ct_doubletooth:
	.db "double toothed",0
ct_tripletooth:
	.db "triple toothed",0
ct_finalbook:
	.db "madman's",0

cm_eternity:
	.db 4
	.db v_precoverytime
	.db 3
	.db v_pdef
	.db 2
	.db v_pstuntime
	.db 2
	.db v_pcon
	.db 1

cm_defenselessness:
	.db 3
	.db $80+v_pdef
	.db 0
	.db v_pdamreduct
	.db -3
	.db $80+v_pshield
	.db 0

cm_hurtin:
	.db 1
	.db v_pdamreduct
	.db -8

cm_taint:
	.db 1
	.db $80+v_pper
	.db 18

cm_libtrap:
	.db 3
	.db v_pstr
	.db -4
	.db v_pdamage
	.db -4
	.db v_pstuntime
	.db -5

cm_zedsword:
	.db 4
	.db v_pdamage
	.db 5
	.db v_patt
	.db 1
	.db v_ppushback
	.db 2
	.db v_pstuntime
	.db 4

cm_zedshield:
	.db 6
	.db v_pstr
	.db 2
	.db v_pdex
	.db 2
	.db v_pcon
	.db 2
	.db v_pper
	.db 2
	.db v_pshield
	.db 2
	.db v_pwindup
	.db -1

cm_demonbile:
	.db 3
	.db v_ppushback
	.db 1
	.db v_pdamage
	.db 8
	.db v_patt
	.db 3

cm_palemoon2:
	.db 4
	.db v_pdef
	.db 5
	.db v_pdamreduct
	.db 5
	.db v_pcon
	.db 2
	.db v_pdex
	.db 2

readable_items:
	.db 9
	.db pmod_tattered
	.dw rel(upperjournal)
	.db pmod_historical
	.dw rel(historybook)
	.db pmod_hastily
	.dw rel(lowerjournal)
	.db pmod_clerical
	.dw rel(worklog)
	.db pmod_foreman1
	.dw rel(foreman1)
	.db pmod_foreman2
	.dw rel(foreman2)
	.db pmod_ancient
	.dw rel(untext)
	.db pmod_gilded
	.dw rel(gildedtext)
	.db pmod_finalbook
	.dw rel(finalbook)

upperjournal:
	.db $fd
#include texts\upperjournal.lzi

historybook:
	.db $fd
#include texts\historybook.lzi

lowerjournal:
	.db $fd
#include texts\lowerjournal.lzi

worklog:
	.db $fd
#include texts\worklog.lzi

foreman1:
	.db "Warning:",$ff
	.db "Please note that the disarming mechanism in the east "
	.db "passage...",$fe
	.db "is not yet functional.",$ff
	.db "-Hagrimm",0

foreman2:
	.db "Warning:",$ff
	.db "Please note that the disarming mechanism in the west "
	.db "passage...",$fe
	.db "is not yet functional.",$ff
	.db "-Hagrimm",0

untext:
	.db "[This text is filled with arcane symbols.  Translating it seems "
	.db "impossible.]",0

gildedtext:
	.db "[Although unreadable like the other texts, this one looks like "
	.db "it was very important to someone...]",0

finalbook:
	.db $fd
#include texts/finalbook.lzi


custom_code:
	.db 1
	.dw rel(extrocode)

extrocode:
#include end1.lzi


default_description:
	.db "His Majesty's Castle",0

loot_herb:
	.db item_herb
	.db 0
	.db 0

loot_wardscepter:
	.db item_sceptre
	.db 0
	.db pmod_warding

loot_glowgem:
	.db item_gem
	.db pmod_glowing
	.db 0

loot_focusing:
	.db item_sceptre
	.db 0
	.db pmod_focusing

loot_zedsword:
	.db item_two
	.db pmod_zedsword
	.db 0

loot_airgem:
	.db item_gem
	.db 0
	.db pmod_airgem

loot_firegem:
	.db item_gem
	.db 0
	.db pmod_firegem

loot_earthgem:
	.db item_gem
	.db 0
	.db pmod_earthgem

loot_watergem:
	.db item_gem
	.db 0
	.db pmod_watergem

loot_untext:
	.db item_tome
	.db pmod_ancient
	.db 0

loot_damscepter:
	.db item_sceptre
	.db pmod_damascened
	.db 0

loot_gildedtome:
	.db item_tome
	.db pmod_gilded
	.db 0

loot_oldchalice:
	.db item_chalice
	.db pmod_ancient
	.db 0

	;**********************
	;** first world data **
	;**********************
world1:
	.db 3
	.db 1
	.db 1
	.db 2*8
	.db 5*8
	.db enemy_snake			;4 enemies used in this world
	.db enemy_scorp
	.db enemy_aspidah
	.db enemy_bspidah
	.dw rel(world1_texts)
	.db $ff
	.db 6
	.dw rel(world1_paths)

	.dw rel(world1_map2),rel(world1_obj2)
	.dw rel(world1_map1),rel(world1_obj1)
	.dw rel(world1_map3),rel(world1_obj3)

world1_texts:
	.db 7
	.dw rel(w1_doortext)
	.dw rel(w1_greet)
	.dw rel(w1_guard)
	.dw rel(w1_altgreet)
	.dw rel(w1_king1)
	.dw rel(w1_king2)
	.dw rel(w1_gatekeeper)

w1_doortext:
	.db "This door is locked",0
w1_greet:
	.db "You are expected in the north room.  His majesty does not "
	.db "like to be kept waiting.",0
w1_guard:
	.db "[The guard stares at you intently]",0
w1_altgreet:
	.db "Whatever task his majesty has given you, I suggest you carry it "
	.db "out quickly.",0
w1_king1:
	.db "What are you waiting for, someone to kiss you goodbye?",0
w1_king2:
	.db $fd
#include texts\kingspeech.lzi
w1_gatekeeper:
	.db "So, you're the guy they're sending to the south lands, eh?",$fe
	.db "Well, let's get you on your way...",0


world1_paths:

world1_map1:
#include maps\intro1.lzi
	.db 1						;animation delay
	.db 8*8,(2*8)+4
	.db 8*8,(5*8)+4
	.db $fe
world1_obj1:
	.db 3

	.db 1*8
	.db 5*8
	.db object_doorright
	.db ai_static
	.db $40+rai_text
	.db 0
	.db 0

	.db 7*8
	.db 4*8
	.db object_player
	.db ai_imwander
	.db $40+rai_conditionelse
	.dw w1_m1_script2

	.db 11*8
	.db 8*8
	.db object_doorup
	.db ai_static
	.db $40+rai_conditionelse
	.dw w1_m1_script1

w1_m1_script1:
	.db flag_opendoor
	.db rai_checkother
	.db 0,1*8
	.db rai_opendoor
	.db 0,0
	.db rai_text
	.db 0,0

w1_m1_script2:
	.db flag_none
	.db rai_checkother
	.db 0,1*8
	.db rai_text
	.db 3,0
	.db rai_text
	.db 1,0

world1_map2:
#include maps\intro2.lzi
	.db 1
	.db 8*8,4*8
	.db $fe
world1_obj2:
	.db 7

	.db (7*8)+4
	.db 3*8
	.db object_player
	.db ai_facer
	.db $40+rai_conditionelse
	.dw w1_m2_script1

	.db 6*8
	.db 6*8
	.db object_playerright
	.db ai_static
	.db $40+rai_text
	.db 2
	.db 0

	.db 9*8
	.db 6*8
	.db object_playerleft
	.db ai_static
	.db $40+rai_text
	.db 2
	.db 0

	.db 6*8
	.db 4*8
	.db object_invis
	.db ai_static
	.db $40+rai_link
	.db 1*8,0

	.db 7*8
	.db 4*8
	.db object_invis
	.db ai_static
	.db $40+rai_link
	.db 1*8,0

	.db 8*8
	.db 4*8
	.db object_invis
	.db ai_static
	.db $40+rai_link
	.db 1*8,0

	.db 9*8
	.db 4*8
	.db object_invis
	.db ai_static
	.db $40+rai_link
	.db 1*8,0

w1_m2_script1:
	.db flag_none
	.db rai_checkflag
	.db 0,0
	.db rai_text
	.db 4,0
	.db rai_chain
	.dw w1_m2_script2

w1_m2_script2 equ $-1
	.db 2
	.db rai_text
	.db 5,0
	.db rai_unflagobject

world1_map3:
#include maps\intro3.lzi
	.db $fe
world1_obj3:
	.db 2

	.db 11*8
	.db 5*8
	.db object_doordown
	.db ai_static
	.db $40+rai_text
	.db 0
	.db 0

	.db 11*8
	.db 4*8
	.db object_player
	.db ai_imwander
	.db $40+rai_chain
	.dw w1_m3_script1

w1_m3_script1:
	.db flag_none
	.db 2
	.db rai_setdesc
	.dw world2desc
	.db rai_advance
	.db 1,0

world2desc:
	.db "Cavern Entrance",0



	;***********************
	;** second world data **
	;***********************

world2:
	.db 6					;height
	.db 3					;width
	.db 14					;starting map
	.db 13*8				;starting x-coord
	.db 2*8					;starting y-coord
	.db enemy_snake			;4 enemies used in this world
	.db enemy_badguy
	.db enemy_aspidah
	.db enemy_bspidah
	.dw rel(world2_texts)
	.db 0					;intro text ($ff for none)
	.db $ff					;extro text
	.dw rel(world2_paths)

	.dw rel(world2_map13),rel(world2_obj13)
	.dw rel(world2_map10),rel(world2_obj10)
	.dw rel(world2_map9),rel(world2_obj9)

	.dw rel(world2_map12),rel(world2_obj12)
	.dw rel(world2_map11),rel(world2_obj11)
	.dw rel(world2_map7),rel(world2_obj7)

	.dw rel(world2_map14),rel(world2_obj14)
	.dw rel(world2_map15),rel(world2_obj15)
	.dw rel(world2_map8),rel(world2_obj8)

	.dw rel(world2_map16),rel(world2_obj16)
	.dw rel(world2_map6),rel(world2_obj6)
	.dw rel(world2_map3),rel(world2_obj3)

	.dw 0,0
	.dw rel(world2_map4),rel(world2_obj4)
	.dw rel(world2_map1),rel(world2_obj1)

	.dw 0,0
	.dw rel(world2_map5),rel(world2_obj5)
	.dw rel(world2_map2),rel(world2_obj2)

world2_texts:
	.db 10					;number of texts
	.dw rel(w2_introtext)
	.dw rel(sdoortext)
	.dw rel(w2_goldkeychest)
	.dw rel(w2_passage)
	.dw rel(mechanism)
	.dw rel(w2_wardchest)
	.dw rel(lastdoor)
	.dw rel(w2_ultar2)
	.dw rel(w2_ultar1)

w2_introtext:
	.db $fd
#include texts\w2intro.lzi

w2_goldkeychest:
	.db "As the chest closes, a horrible stench fills"
	.db " the room...",0
w2_passage:
	.db "The walls in this passage are charred black",0
w2_wardchest:
	.db "The chest is held shut by a switch",0
w2_ultar2:
	.db "I'd help you, but I don't have the strength to walk out "
	.db "of here, much less fight.",0
w2_ultar1:
	.db $fd
#include texts\ultarspeech.lzi

world2_paths:

world2_map1:
#include maps/dungeon1.lzi
	.db $fe
world2_obj1:
	.db 6

	.db 7*8
	.db 2*8
	.db object_doordown
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_silver
	.db 0

	.db 7*8
	.db 6*8
	.db object_doorup
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 13*8
	.db 6*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_givespec
	.dw loot_herb

	snake(9, 6)

	.db 14*8
	.db 2*8
	.db object_stairsright
	.db ai_static
	.db $80
	.db 0,0

	.db 9*8
	.db 2*8
	.db object_chestup
	.db ai_static
	.db rai_givespec
	.dw w2_m1_loot1

w2_m1_loot1:
	.db item_leather
	.db 0,0

world2_map2:
#include maps/dungeon2.lzi
	.db $fe
world2_obj2:
	.db 3

	snake(7, 7)

	snake(9, 5)

	snake(13, 6)

world2_map3:
#include maps/dungeon3.lzi
	.db $fe
world2_obj3:
	.db 8

	.db 2*8
	.db 7*8
	.db object_chestright
	.db ai_static
	.db $40+rai_givespec
	.dw loot_herb

	block(12, 6)

	bigsnake(10, 6)

	.db 7*8
	.db 5*8
	.db object_doordown
	.db ai_static
	.db $40+rai_condition
	.dw w2_m3_script1

	.db 7*8
	.db 4*8
	.db object_invis
	.db $80+ai_respond
	.db flag_none
	.dw w2_m3_respond1

	.db 2*8
	.db 5*8
	.db object_stairsdown
	.db ai_static
	.db $40+rai_chain
	.dw w2_m3_script2

	.db 9*8
	.db 4*8
	.db object_fountain
	.db ai_animate2
	.db rai_givehealth
	.db 3
	.db 0

	.db 13*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w2_m3_loot1

w2_m3_loot1:
	.db item_round
	.db 0
	.db 0

w2_m3_script1:
	.db flag_opendoor
	.db rai_keydoor
	.db pmod_gold
	.db 0
	.db rai_text
	.db 3
	.db 0

w2_m3_script2:
	.db flag_none
	.db 2
	.db rai_teleport
	.dw w2_m3_teleport1
	.db rai_setdesc
	.dw upperruins

upperruins:
	.db "Upper Ruins",0

w2_m3_respond1:
	.db %00000111
	.db rai_nfsolidtrigger
	.dw w2_m3_trigger1

w2_m3_trigger1:
	.db 1
	.db 7*8
	.db 1*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6,4

w2_m3_teleport1:
	.db 7*8,3*8				;new coordinates
	.db 5					;new map

world2_map4:
#include maps/dungeon4.lzi
	.db $fe
world2_obj4:
	.db 3

	.db 2*8
	.db 7*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.dw w2_m4_switch1

	bigsnake(4, 5)

	.db 92
	.db 36
	.db object_invis
	.db ai_static
	.db rai_nftrigger
	.dw w2_m4_trigger1

w2_m4_switch1:
	.db 1			;1 object
	.db 4*8,16		;object 4, map 16

w2_m4_trigger1:
	.db 2
	spawn(12, 8, w2_m4_trigger2)
	spawn(10, 2, w2_m4_trigger3)

w2_m4_trigger2:
	.db 12*8
	.db 8*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 2
	.db 0

w2_m4_trigger3:
	.db 10*8
	.db 2*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 7
	.db 0


world2_map5:
#include maps/dungeon5.lzi
	.db $fe
world2_obj5:
	.db 9

	block(11, 6)

	.db 7*8
	.db 2*8
	.db object_doordown
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_silver
	.db 0

	snake(5, 2)

	.db 5*8
	.db 5*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_sdoor
	.db 1
	.db 0

	.db 2*8
	.db 4*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w2_m5_loot1

	lootup(2, 7, 0, 0)

	snake(4, 6)

	lootup(6, 7, 2, 0)

	snake(10, 3)

w2_m5_loot1:
	.db item_key
	.db pmod_silver
	.db 0



world2_map6:
#include maps/dungeon6.lzi
	.db $fe
world2_obj6:
	.db 9

	block(7, 6)

	block(8, 5)

	.db 9*8
	.db 2*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 5*8
	.db 2*8
	.db object_chestright
	.db ai_static
	.db $40+rai_chain
	.dw w2_m6_script1

	.db 3*8
	.db 5*8
	.db object_doordown
	.db ai_static
	.db $40+rai_condition
	.dw w2_m6_script2

	lootright(2, 2, 4, 0)

	lootdown(13, 5, 6, 0)

	bigsnake(13, 6)

	bigsnake(10, 7)

w2_m6_script1:
	.db flag_makestatic
	.db 3
	.db rai_givespec
	.dw w2_m6_loot1
	.db rai_text
	.db 2,0
	.db rai_nfsolidtrigger
	.dw w2_m6_trigger1

w2_m6_loot1:
	.db item_key
	.db pmod_gold
	.db 0

w2_m6_trigger1:
	.db 2
	aspidah(12, 2)
	snake(6, 8)

w2_m6_script2:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_trigger
	.dw w2_m6_trigger2

w2_m6_trigger2:
	.db 3
	spawn(2, 6, w2_m6_trigger3)
	spawn(4, 6, w2_m6_trigger4)
	spawn(3, 2, w2_m6_trigger5)

w2_m6_trigger3:
	snake(2, 6)

w2_m6_trigger4:
	snake(4, 6)

w2_m6_trigger5:
	snake(3, 2)

world2_map7:
#include maps\dungeon7.lzi
	.db $fe
world2_obj7:
	.db 10

	.db 9*8
	.db 5*8
	.db object_doordown
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_heavyiron
	.db 0

	.db 11*8
	.db 5*8
	.db object_doordown
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_heavyiron
	.db 0

	.db 7*8
	.db 5*8
	.db object_doordown
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 7*8
	.db 2*8
	.db object_stairsup
	.db ai_static
	.db $40+rai_teleport
	.dw w2_m7_teleport1

	.db 7*8
	.db 8*8
	.db object_doorup
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_stone
	.db 0

	.db 9*8
	.db 4*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w2_m7_loot1

	.db 11*8
	.db 4*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w2_m7_loot2

	bspidah(2, 4)

	.db 9*8,2*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_chain
	.dw w2_m7_script2

	.db 13*8,5*8
	.db object_doordown
	.db ai_static
	.db $40+rai_conditionelse
	.dw w2_m7_script1

w2_m7_script2:
	.db flag_none
	.db 2
	.db rai_advance
	.db 2,0
	.db rai_setdesc
	.dw w2_deepbeneath

w2_deepbeneath:
	.db "Deep Beneath the Earth",0

w2_m7_script1:
	.db flag_opendoor
	.db rai_checkother
	.db 8,1*8
	.db rai_opendoor
	.db 0,0
	.db rai_text
	.db 6

w2_m7_loot1:
	.db item_elixir
	.db 0
	.db mods_pots+7			;immunity

w2_m7_loot2:
	.db item_scroll
	.db pmod_tattered
	.db 0

w2_m7_teleport1:
	.db 2*8
	.db 4*8
	.db 11

world2_map8:
#include maps\dungeon8.lzi
	.db $fe
world2_obj8:
	.db 5

	.db 6*8,6*8
	.db object_enemy2
	.db ai_trackandshoot
	.db $80
	.db 40,3

	.db 8*8,5*8
	.db object_enemy4
	.db ai_passivetrack
	.db $80
	.db 0,2

	lootup(13, 6, 22, 2)

	.db 13*8,4*8
	.db object_chestdown
	.db ai_static
	.db rai_givespec
	.dw w2_m8_loot1

	.db 7*8,2*8
	.db object_invis
	.db ai_static
	.db rai_lighttrigger
	.dw w2_m8_light1

w2_m8_light1:
	.db 1
	.db (6*8)+4,(5*8)+4
	.db (8*8)+4,(5*8)+4
	.db $fe

w2_m8_loot1:
	.db item_tome
	.db pmod_historical
	.db 0

world2_map9:
#include maps\dungeon9.lzi
	.db $fe
world2_obj9:
	.db 12

	block(12, 4)
	block(11, 4)
	block(10, 4)
	block(10, 5)
	block(9, 6)

	.db 10*8
	.db 6*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 11*8
	.db 6*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 12*8
	.db 6*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 11*8
	.db 5*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 12*8
	.db 5*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 8*8
	.db 4*8
	.db object_doordown
	.db ai_static
	.db $40+rai_conditionelse
	.dw w2_m9_script1

	.db 6*8
	.db 2*8
	.db object_chestright
	.db ai_static
	.db $40+rai_givespec
	.dw w2_m9_loot1

w2_m9_loot1:
	.db item_key
	.db pmod_heavyiron
	.db 0

w2_m9_script1:
	.db flag_opendoor
	.db rai_condition
	.dw w2_m9_script2
	.db rai_opendoor
	.db 0,0
	.db rai_text
	.db 4

w2_m9_script2 equ $-1
	.db rai_checkother
	.db 2,6*8
	.db rai_condition
	.dw w2_m9_script3

w2_m9_script3 equ $-1
	.db rai_checkother
	.db 2,7*8
	.db rai_condition
	.dw w2_m9_script4

w2_m9_script4 equ $-1
	.db rai_checkother
	.db 2,8*8
	.db rai_condition
	.dw w2_m9_script5

w2_m9_script5 equ $-1
	.db rai_checkother
	.db 2,9*8
	.db rai_checkother
	.db 2,10*8

sokobanscript:
	.db %00000111
	.db rai_unflagobject			;response if object is present
	.db 0,0
	.db rai_flagobject				;and if not
	.db 0,0

world2_map10:
#include maps\dungeon10.lzi
	.db $fe
world2_obj10:
	.db 4

	lootleft(4, 2, 8, 0)

	lootright(6, 2, 10, 1)

	bigsnake(7, 5)

	bigsnake(2, 2)

world2_map11:
#include maps\dungeon11.lzi
	.db 10
	.db (3*8)+4,(7*8)+4
	.db $ff
	.db (5*8)+4,(7*8)+4
	.db $ff
	.db (7*8)+4,(7*8)+4
	.db $fe
world2_obj11:
	.db 10

	.db 13*8
	.db 6*8
	.db object_doorright
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 8*8
	.db 6*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 12*8
	.db 3*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_herb

	smartsnake(9, 7)
	smartsnake(4, 3)
	smartsnake(7, 4)
	smartsnake(2, 7)

	.db 3*8
	.db 8*8
	.db object_lampup
	.db ai_animate4r
	.db $80
	.db 0,0

	.db 5*8
	.db 8*8
	.db object_lampup
	.db ai_animate4r
	.db $80
	.db 0,0

	.db 7*8
	.db 8*8
	.db object_lampup
	.db ai_animate4r
	.db $80
	.db 0,0

world2_map12:
#include maps\dungeon12.lzi
	.db $fe
world2_obj12:
	.db 6

	block(9, 2)

	snake(2, 2)

	herbright(2, 7)

	.db 10*8,8*8
	.db object_doorup
	.db ai_static
	.db rai_condition
	.dw w2_m12_script1

	.db 4*8,8*8
	.db object_doorup
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 12*8,4*8
	.db object_player
	.db ai_facer
	.db $40+rai_conditionelse
	.dw w2_m12_script2

w2_m12_script1:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w2_m12_trigger1

w2_m12_script2:
	.db flag_none
	.db rai_checkflag
	.db 0,0
	.db rai_text
	.db 7,0
	.db rai_chain
	.dw w2_m12_script3

w2_m12_script3 equ $-1
	.db 2
	.db rai_text
	.db 8,0
	.db rai_unflagobject

w2_m12_trigger1:
	.db 1
	.db 5*8,7*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 0
	.db 1

world2_map13:
#include maps\dungeon13.lzi
	.db $fe
world2_obj13:
	.db 7

	.db (4*8)+4
	.db 6*8
	.db object_invis
	.db $80+ai_respond
	.db flag_none
	.dw w2_m13_respond1

	.db (4*8)+4
	.db 5*8
	.db object_invis
	.db $80+ai_respond
	.db flag_none
	.dw w2_m13_respond1

	.db 3*8,2*8
	.db object_doorright
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 6*8,2*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

	lootup(2, 4, 12, 1)

	.db 7*8,4*8
	.db object_chestup
	.db ai_static
	.db rai_givespec
	.dw loot_herb

	.db 9*8,3*8
	.db object_chestleft
	.db ai_static
	.db rai_givespec
	.dw w2_m13_loot1

w2_m13_loot1:
	.db item_key
	.db pmod_stone
	.db 0

w2_m13_respond1:
	.db %00000011
	.db rai_conditionelse
	.dw w2_m13_script1

w2_m13_script1 equ $-1
	.db rai_checkitem
	.dw loot_wardscepter
	.db $80
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w2_m13_trigger1

w2_m13_trigger1:
	.db 2
	spawn(4, 2, w2_m13_trigger2)
	spawn(5, 2, w2_m13_trigger3)

w2_m13_trigger2:
	.db 4*8
	.db 2*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6
	.db 4

w2_m13_trigger3:
	.db 5*8
	.db 2*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6
	.db 4

world2_map14:
#include maps\dungeon14.lzi
	.db $fe
world2_obj14:
	.db 10

	.db 3*8,3*8
	.db object_doorright
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 5*8,3*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	bspidah(2, 3)
	snake(6, 3)

	.db 4*8,6*8
	.db object_doorup
	.db ai_static
	.db rai_chain
	.dw w2_m14_script1

	lootup(4, 7, 14, 1)

	.db 7*8,6*8
	.db object_doorup
	.db ai_static
	.db $40+rai_sdoor
	.db 1
	.db 0

	.db 13*8,4*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.dw w2_m14_switch1

	bigsnake(10, 5)

	lootdown(9, 4, 16, 0)

w2_m14_switch1:
	.db 1
	.db 7*8,6

w2_m14_script1:
	.db flag_opendoor
	.db 3
	.db rai_link
	.db 1*8,0
	.db rai_link
	.db 2*8,0
	.db rai_opendoor

world2_map15:
#include maps\dungeon15.lzi
	.db $fe
world2_obj15:
	.db 11

	.db 4*8
	.db 2*8
	.db object_doorright
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	aspidah(2, 2)
	aspidah(3, 2)

	ststeleport(6, 7, 9, 6)
	ststeleport(8, 6, 5, 7)
	ststeleport(7, 3, 9, 3)
	ststeleport(9, 2, 6, 3)

	block(3, 6)

	smartsnake(5, 6)

	.db 11*8,2*8
	.db object_switch
	.db ai_static
	.db $40+rai_chain
	.dw w2_m15_script1

	.db 12*8,4*8
	.db object_chestup
	.db ai_static
	.db $40+rai_conditionelse
	.dw w2_m15_script2

w2_m15_script1:
	.db flag_switch
	.db 2
	.db rai_switch
	.dw 0						;null switch
	.db rai_link
	.db 1*8

w2_m15_script2:
	.db flag_makestatic
	.db rai_checkother
	.db 7,10*8
	.db rai_givespec
	.dw loot_wardscepter
	.db rai_text
	.db 5

world2_map16:
#include maps\dungeon16.lzi
	.db $fe
world2_obj16:
	.db 8

	bspidah(7, 7)
	lootup(13, 3, 18, 0)
	bigsnake(11, 2)
	lootdown(13, 5, 20, 1)
	bigsnake(4, 7)
	bspidah(9, 7)

	.db 6*8,2*8
	.db object_doorup
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 3*8,2*8
	.db object_chestleft
	.db ai_static
	.db rai_givespec
	.dw loot_herb


;**********************
;** Third World Data **
;**********************

world3:
	.db 8					;height
	.db 4					;width
	.db 2					;starting map
	.db 7*8					;starting x-coord
	.db 6*8					;starting y-coord
	.db enemy_scorp			;4 enemies used in this world
	.db enemy_badguy
	.db enemy_aspidah
	.db enemy_bspidah
	.dw rel(world3_texts)
	.db 0					;intro text ($ff for none)
	.db 22					;extro text
	.dw rel(world3_paths)

	.dw rel(world3_map4),rel(world3_obj4)
	.dw rel(world3_map2),rel(world3_obj2)
	.dw rel(world3_map1),rel(world3_obj1)
	.dw rel(world3_map8),rel(world3_obj8)

	.dw rel(world3_map5),rel(world3_obj5)
	.dw rel(world3_map3),rel(world3_obj3)
	.dw rel(world3_map12),rel(world3_obj12)
	.dw rel(world3_map9),rel(world3_obj9)

	.dw rel(world3_map7),rel(world3_obj7)
	.dw rel(world3_map6),rel(world3_obj6)
	.dw rel(world3_map13),rel(world3_obj13)
	.dw rel(world3_map10),rel(world3_obj10)

	.dw rel(world3_map11),rel(world3_obj11)
	.dw rel(world3_map16),rel(world3_obj16)
	.dw rel(world3_map14),rel(world3_obj14)
	.dw rel(world3_map15),rel(world3_obj15)

	.dw 0,0
	.dw rel(world3_mdeep10),rel(world3_odeep10)
	.dw 0,0
	.dw 0,0

	.dw rel(world3_mdeep7),rel(world3_odeep7)
	.dw rel(world3_mdeep2),rel(world3_odeep2)
	.dw rel(world3_mdeep3),rel(world3_odeep3)
	.dw 0,0

	.dw rel(world3_mdeep8),rel(world3_odeep8)
	.dw rel(world3_mdeep1),rel(world3_odeep1)
	.dw rel(world3_mdeep4),rel(world3_odeep4)
	.dw 0,0

	.dw rel(world3_mdeep9),rel(world3_odeep9)
	.dw rel(world3_mdeep5),rel(world3_odeep5)
	.dw rel(world3_mdeep6),rel(world3_odeep6)
	.dw 0,0


world3_texts:
	.db 24
	.dw rel(w3_intro)
	.dw rel(sdoortext)
	.dw rel(w3_doortrap)
	.dw rel(w3_portal)
	.dw rel(w3_healer)
	.dw rel(w3_injuries)
	.dw rel(w3_badportal)
	.dw rel(w3_goodportal)
	.dw rel(w3_zed)
	.dw rel(w3_morezed)
	.dw rel(w3_zedagain)
	.dw rel(w3_airchest)
	.dw rel(w3_firechest)
	.dw rel(w3_earthchest)
	.dw rel(w3_waterchest)
	.dw rel(w3_geminside)
	.dw rel(w3_gotair)
	.dw rel(w3_gotfire)
	.dw rel(w3_gotearth)
	.dw rel(w3_gotwater)
	.dw rel(mechanism)
	.dw rel(lastdoor)
	.dw rel(w3_leaving)
	.dw rel(w3_fireportal)

w3_intro:
	.db "This portal was not like the others.  It was much more "
	.db "disorienting...",$fe
	.db "and more importantly, it appears to have been one-way.",0

w3_doortrap:
	.db "The door was trapped with a spell.  You suddenly feel defenseless...",0

w3_portal:
	.db "As the door opens, bright light fills the room behind "
	.db "you.  A portal has opened...",0

w3_healer:
	.db $fd
#include texts/healerspeech.lzi

w3_injuries:
	.db "Here, let me treat your wounds, friend.",0

w3_badportal:
	.db "The portal shivers and twists violently as you approach.  Entering it "
	.db "in this state seems impossible...",0

w3_goodportal:
	.db "The portal calms and focuses around you.  You step through...",0

w3_zed:
	.db $fd
#include texts/zedspeech.lzi

w3_zedagain:
	.db "Zed smash!",$ff
	.db "Oh, you again...",$fe
	.db "You not find Zed's sword?  You find, Zed appreciate.",0

w3_morezed:
	.db $fd
#include texts/morezed.lzi

w3_airchest:
	.db "Wind swirls around the chest as it opens.",0

w3_firechest:
	.db "Ash surrounds the chest, and a wave of heat escapes as you "
	.db "open it.",0

w3_earthchest:
	.db "The chest is partially buried under a mound of dirt.",0

w3_waterchest:
	.db "A puddle has formed around the chest.",0

w3_geminside:
	.db "Whatever it once held is missing...",0

w3_gotair:
	.db "Storm-winds blow through the chamber as you place the air gem in "
	.db "the chest",0

w3_gotfire:
	.db "The chest bursts into flames as you place the fire gem inside.",0

w3_gotearth:
	.db "The ground shakes as you set the earth gem in place.",0

w3_gotwater:
	.db "A spring forms beneath the chest as you place the water gem inside.",0

w3_leaving:
	.db $fd
#include texts/exitworld3.lzi

w3_fireportal:
	.db "Flames issue forth from the portal and grow stronger as you approach.",$fe
	.db "Entering it would surely be fatal.",0

world3_paths:

world3_map1:
#include maps\ruins1.lzi
	.db 1
	.db (5*8)+4,(2*8)+2
	.db (9*8)+4,(2*8)+2
	.db $fe
world3_obj1:
	.db 14

	.db 7*8,3*8
	.db object_doordown
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 2*8,6*8
	.db object_doorup
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 12*8,6*8
	.db object_doorup
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 3*8,7*8
	.db object_doorright
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 11*8,7*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	bspidah(2, 7)
	bspidah(12, 7)
	bspidah(7, 2)

	.db 7*8,8*8
	.db object_invis
	.db $80+ai_respond
	.db flag_none
	.dw w3_m1_respond1

	.db 5*8,6*8
	.db object_invis
	.db $80+ai_respond
	.db flag_none
	.dw w3_m1_respond1

	.db 7*8,4*8
	.db object_invis
	.db $80+ai_respond
	.db flag_none
	.dw w3_m1_respond1

	.db 9*8,6*8
	.db object_invis
	.db $80+ai_respond
	.db flag_none
	.dw w3_m1_respond1

	.db 5*8,3*8
	.db object_lampdown
	.db ai_animate4r
	.db $80
	.db 0,0

	.db 9*8,3*8
	.db object_lampdown
	.db ai_animate4r
	.db $80
	.db 0,0

w3_m1_respond1:
	.db 00000001
	.db rai_chain
	.dw w3_m1_script1

w3_m1_script1 equ $-1
	.db 5
	.db rai_link
	.db 1*8,0
	.db rai_link
	.db 2*8,0
	.db rai_link
	.db 3*8,0
	.db rai_link
	.db 4*8,0
	.db rai_link
	.db 5*8

world3_map2:
#include maps\ruins2.lzi
	.db 8
	.db (13*8)+4,(1*8)+3
	.db $ff
	.db (13*8)+4,(1*8)+3
	.db $ff
	.db (13*8)+4,(1*8)+3
	.db $ff
	.db $fe
world3_obj2:
	.db 6

	.db 13*8,2*8
	.db object_lampdown
	.db ai_animate4r
	.db $80
	.db 0,0

	.db 13*8,6*8
	.db object_doorup
	.db ai_static
	.db $40+rai_sdoor
	.db 1,0

	wallblock(10, 3)

	.db 2*8,2*8
	.db object_chestdown
	.db ai_static
	.db rai_givespec
	.dw loot_herb

	bspidah(5, 3)

	.db 13*8,7*8
	.db object_formspawn
	.db ai_animate4
	.db rai_teleport
	.dw w3_m2_teleport1

w3_m2_teleport1:
	.db 12*8,6*8
	.db 9

world3_map3:
#include maps\ruins3.lzi
	.db $fe
world3_obj3:
	.db 6

	.db 13*8,7*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.dw w3_m3_switch1

	bspidah(7, 3)
	lootdown(2, 3, 0, 1)
	bspidah(7, 6)
	bspidah(13, 2)
	bspidah(9, 6)

w3_m3_switch1:
	.db 1
	.db 1*8,4

world3_map4:
#include maps\ruins4.lzi
	.db $fe
world3_obj4:
	.db 5

	lootup(9, 6, 2, 1)
	lootdown(2, 2, 4, 1)
	bspidah(4, 4)
	bspidah(8, 5)
	bspidah(11, 6)

world3_map5:
#include maps\ruins5.lzi
	.db $fe
world3_obj5:
	.db 5

	.db 3*8,4*8
	.db object_doorup
	.db ai_static
	.db $40+rai_sdoor
	.db 1,0

	.db 4*8,3*8
	.db object_chestleft
	.db ai_static
	.db rai_givespec
	.dw loot_herb

	.db 5*8,5*8
	.db object_invis
	.db ai_static
	.db rai_nftrigger
	.dw w3_m5_trigger1

	lootup(11, 7, 6, 2)

	.db 5*8,2*8
	.db object_chestright
	.db ai_static
	.db rai_givespec
	.dw loot_herb

w3_m5_trigger1:
	.db 1
	spawn(7, 5, w3_m5_trigger2)

w3_m5_trigger2:
	aspidah(7, 5)

world3_map6:
#include maps\ruins6.lzi
	.db 1
	.db (14*8)+4,(5*8)+4
	.db $fe
world3_obj6:
	.db 6

	.db 14*8,6*8
	.db object_lampleft
	.db ai_animate4r
	.db $80
	.db 0,0

	wallblock(8, 4)

	.db 13*8,3*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w3_m6_teleport1

	.db 13*8,4*8
	.db object_doordown
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 11*8,5*8
	.db object_switch
	.db ai_static
	.db rai_chain
	.dw w3_m6_script1

	.db 1*8,5*8
	.db object_enemy2
	.db ai_trackandshoot
	.db $80
	.db 45,3

w3_m6_script1:
	.db flag_switch
	.db 2
	.db rai_switch
	.dw w3_m6_switch1
	.db rai_link
	.db 4*8

w3_m6_switch1:
	.db 1
	.db 2*8,1

w3_m6_teleport1:
	.db 13*8,4*8
	.db 1

world3_map7:
#include maps\ruins7.lzi
w3_m7_lights_original:
	.db 1
	.db (11*8)+4,(7*8)+3
	.db $fe
world3_obj7:
	.db 20

	.db 5*8,3*8
	.db object_doordown
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 3*8,3*8
	.db object_doordown
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 9*8,3*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.db 0,0

	.db 9*8,5*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.db 0,0

	.db 13*8,6*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 11*8,3*8
	.db object_enemy2
	.db ai_trackandshoot
	.db $80
	.db 60,3

	lampup(11, 8)

	ststeleport(11, 2, 4, 4)

	lootdown(7, 3, 8, 2)

	.db 6*8,4*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	bspidah(5, 4)

	ststeleport(7, 6, 11, 4)

	lampup(5, 7)

	lampup(3, 7)

	lampdown(3, 1)

	lampdown(5, 1)

	.db 3*8, 6*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_text
	.db 23,0

	.db 5*8, 6*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_text
	.db 23,0

	.db 3*8, 2*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w3_m7_script1

	.db 9*8,7*8
	.db object_switch
	.db ai_static
	.db $40+rai_condition
	.dw w3_m7_script2

w3_m7_script1:
	.db %00001111
	.db rai_condition
	.dw w3_m7_script3

w3_m7_script2:
	.db flag_switch
	.db rai_switch
	.db 0,0
	.db rai_conditionelse
	.dw w3_m7_script5

w3_m7_script3 equ $-1
	.db rai_checkother
	.db 8,3*8
	.db rai_conditionelse
	.dw w3_m7_script4

w3_m7_script4 equ $-1
	.db rai_checkother
	.db 8,4*8
	.db rai_nfsolidtrigger
	.dw w3_m7_trigger1
	.db rai_nfsolidtrigger
	.dw w3_m7_trigger2

w3_m7_script5 equ $-1
	.db rai_checkflag
	.db 0,0
	.db rai_loadlights
	.dw w3_m7_light1
	.db rai_loadlights
	.dw w3_m7_lights_original

w3_m7_trigger1:
	.db 1
	spawn(3, 2, w3_m7_trigger3)

w3_m7_trigger2:
	.db 1
	spawn(5, 2, w3_m7_trigger4)

w3_m7_trigger3:
	.db 3*8,2*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6
	.db 4

w3_m7_trigger4:
	.db 5*8,2*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6
	.db 4

w3_m7_light1:
	.db 1
	.db (11*8)+4,(7*8)+3
	.db (5*8)+4,(6*8)+4
	.db (3*8)+4,(6*8)+4
	.db (5*8)+4,(0*8)+4
	.db (3*8)+4,(0*8)+4
	.db $fe

world3_map8:
#include maps\ruins8.lzi
	.db 1
	.db (14*8)+5,(6*8)+4
	.db (2*8)+3,(6*8)+4
	.db $fe
world3_obj8:
	.db 15

	lampleft(14, 7)
	lampright(2, 7)
	herbdown(10, 3)
	bspidah(10, 4)
	aspidah(3, 7)
	aspidah(3, 8)
	aspidah(4, 7)
	aspidah(12, 7)
	aspidah(13, 7)

	.db 4*8, 6*8
	.db object_doorup
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 12*8, 6*8
	.db object_doorup
	.db ai_static
	.db $40+rai_opendoor
	.db 0,0

	.db 6*8,7*8
	.db object_switch
	.db ai_static
	.db $40+rai_chain
	.dw w3_m8_script1

	.db 10*8,7*8
	.db object_switch
	.db ai_static
	.db $40+rai_chain
	.dw w3_m8_script2

	.db 14*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w3_m8_script3

	.db 8*8,8*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.db 0,0

w3_m8_script1:
	.db flag_switch
	.db 2
	.db rai_link
	.db 10*8,0
	.db rai_switch
	.db 0,0

w3_m8_script2:
	.db flag_switch
	.db 2
	.db rai_link
	.db 11*8,0
	.db rai_switch
	.db 0,0

w3_m8_script3:
	.db %00001111
	.db rai_condition
	.dw w3_m8_script8

w3_m8_script4 equ $-1
	.db rai_checkother
	.db 8,3*8
	.db rai_conditionelse
	.dw w3_m8_script5

w3_m8_script5 equ $-1
	.db rai_checkother
	.db 8,4*8
	.db rai_condition
	.dw w3_m8_script6
	.db rai_condition
	.dw w3_m8_script7

w3_m8_script6 equ $-1
	.db rai_checkother
	.db 8,2*8
	.db rai_nfsolidtrigger
	.dw w3_m8_trigger1

w3_m8_script7 equ $-1
	.db rai_checkother
	.db 8,1*8
	.db rai_nfsolidtrigger
	.dw w3_m8_trigger2

w3_m8_script8 equ $-1
	.db rai_checkother
	.db 3,15*8
	.db rai_condition
	.dw w3_m8_script4

w3_m8_trigger1:
	.db 1
	spawn(4, 4, w3_m8_trigger3)

w3_m8_trigger2:
	.db 1
	spawn(12, 4, w3_m8_trigger4)

w3_m8_trigger3:
	.db 4*8,4*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6
	.db 4

w3_m8_trigger4:
	.db 12*8,4*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6
	.db 4

world3_map9:
#include maps\ruins9.lzi
	.db 12
	.db (2*8)+4,(1*8)+4
	.db (2*8)+4,(4*8)+4
	.db $fe
world3_obj9:
	.db 10

	lampright(2, 2)
	lampright(2, 5)
	badguy(4, 6, 30, 3)
	smartbspidah(3, 5)

	.db 5*8,2*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_condition
	.dw w3_m9_script1

	.db 5*8,4*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_condition
	.dw w3_m9_script1

	block(11, 7)

	.db 9*8,2*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_givespec
	.dw w3_m9_loot1

	lootleft(9, 4, 14, 2)

	.db 4*8,7*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw w3_m9_loot2

w3_m9_loot1:
	.db item_key
	.db pmod_weird
	.db 0

w3_m9_loot2:
	.db item_scroll
	.db pmod_hastily
	.db 0

w3_m9_script1:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_chain
	.dw w3_m9_script2

w3_m9_script2 equ $-1
	.db 2
	.db rai_curse
	.db pmod_defenselessness,250
	.db rai_text
	.db 2

world3_map10:
#include maps\ruins10.lzi
	.db $fe
world3_obj10:
	.db 11

	smartbspidah(7, 3)
	smartbspidah(4, 3)
	aspidah(5, 6)
	herbright(10, 7)

	.db 7*8,5*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_glowgem

	lootright(3, 7, 10, 2)
	lootright(10, 4, 12, 2)
	bspidah(12, 4)

	.db 12*8,6*8
	.db object_invis
	.db ai_static
	.db $40+rai_trigger
	.dw w3_m10_trigger1

	.db 6*8,7*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_condition
	.dw w3_m10_script1

	.db 13*8,7*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_givespec
	.dw w3_m10_loot1

w3_m10_loot1:
	.db item_key
	.db pmod_strange
	.db 0

w3_m10_trigger1:
	.db 1
	spawn(12, 2, w3_m10_trigger2)

w3_m10_trigger2:
	aspidah(12, 2)

w3_m10_script1:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_chain
	.dw w3_m10_script2

w3_m10_script2 equ $-1
	.db 3
	.db rai_text
	.db 3,0
	.db rai_loadlights
	.dw w3_m10_light1
	.db rai_nfsolidtrigger
	.dw w3_m10_trigger3

w3_m10_light1:
	.db 4
	.db (5*8)+3,(4*8)+3
	.db $ff
	.db (5*8)+5,(4*8)+5
	.db $fe

w3_m10_trigger3:
	.db 2

	.db 5*8,5*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w3_m10_teleport1

	.db 1*8,8*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w3_m10_script3

w3_m10_teleport1:
	.db 5*8,4*8
	.db 12

w3_m10_script3:
	.db %00001111
	.db rai_condition
	.dw w3_m10_script4

w3_m10_script4 equ $-1
	.db rai_random
	.db 95,0
	.db rai_nfsolidtrigger
	.dw w3_m10_trigger4

w3_m10_trigger4:
	.db 1
	bspidah(5, 6)

world3_map11:
#include maps\ruins11.lzi
	.db $fe
world3_obj11:
	.db 6

	aspidah(8, 2)
	aspidah(8, 6)

	.db 10*8,3*8
	.db object_fountain
	.db ai_animate2
	.db $40+rai_givehealth
	.db 2,0

	.db 10*8,5*8
	.db object_fountain
	.db ai_animate2
	.db $40+rai_givehealth
	.db 2,0

	.db 4*8,4*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w3_m11_teleport1

	.db 11*8,4*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_givespec
	.dw w3_m11_loot1

w3_m11_loot1:
	.db item_chain
	.db 0
	.db pmod_eternity

w3_m11_teleport1:
	.db 4*8,5*8
	.db 11

world3_map12:
#include maps\ruins12.lzi
	.db $fe
world3_obj12:
	.db 6

	wallblock(10, 7)

	.db 5*8,7*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.db 0,0

	.db 7*8,8*8
	.db object_doorup
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_weird
	.db 0

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w3_m12_script1

	bspidah(7, 6)

	.db 12*8,2*8
	.db object_player
	.db ai_imwander
	.db rai_chain
	.dw w3_m12_script3

w3_m12_script1:
	.db %00001111
	.db rai_conditionelse
	.dw w3_m12_script2

w3_m12_script2:
	.db flag_none
	.db rai_checkother
	.db 6,2*8
	.db $80
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w3_m12_trigger1

w3_m12_script3:
	.db flag_none
	.db 2
	.db rai_condition
	.dw w3_m12_script4
	.db rai_conditionelse
	.dw w3_m12_script5

w3_m12_script4 equ $-1
	.db rai_givehealth
	.db 80,0
	.db rai_text
	.db 5

w3_m12_script5 equ $-1
	.db rai_checkflag
	.db 0,0
	.db $80
	.db 0,0
	.db rai_chain
	.dw w3_m12_script6

w3_m12_script6 equ $-1
	.db 2
	.db rai_text
	.db 4,0
	.db rai_unflagobject

w3_m12_trigger1:
	.db 2
	spawn(10, 3, w3_m12_trigger2)
	spawn(4, 5, w3_m12_trigger3)

w3_m12_trigger2:
	.db 10*8,3*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 4,6

w3_m12_trigger3:
	.db 4*8,5*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 0,6

world3_map13:
#include maps\ruins13.lzi
	.db $fe
world3_obj13:
	.db 6

	wallblock(12, 4)
	lootup(13, 6, 16, 3)
	badguy(3, 5, 30, 3)
	badguy(10, 4, 32, 3)
	badguy(7, 7, 35, 3)

	.db 7*8,8*8
	.db object_doorup
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_strange
	.db 0

world3_map14:
#include maps\ruins14.lzi
	.db $fe
world3_obj14:
	.db 11

	.db 7*8,3*8
	.db object_invis
	.db ai_static
	.db rai_chain
	.dw w3_m14_script3

	.db 3*8,4*8
	.db object_doorup
	.db ai_static
	.db $40+rai_condition
	.dw w3_m14_script1

	lootup(3, 6, 18, 3)

	aspidah(11, 5)

	.db 13*8,4*8
	.db object_doorup
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 7*8,4*8
	.db object_doorup
	.db ai_static
	.db $40+rai_condition
	.dw w3_m14_script2

	.db 7*8,8*8
	.db object_stairsdown
	.db ai_static
	.db $40+rai_chain
	.dw w3_m14_script4

	aspidah(3, 3)
	aspidah(11, 3)

	.db 4*8,3*8
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

	.db 10*8,3*8
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

w3_m14_script1:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w3_m14_trigger2

w3_m14_script2:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w3_m14_trigger3

w3_m14_script3:
	.db flag_die
	.db 3
	.db rai_removeother
	.db 10*8,0
	.db rai_removeother
	.db 11*8,0
	.db rai_remove

w3_m14_script4:
	.db flag_none
	.db 2
	.db rai_setdesc
	.dw catacombs
	.db rai_teleport
	.dw w3_m14_teleport1

w3_m14_teleport1:
	.db 7*8,2*8
	.db 25

catacombs:
	.db "Catacombs of the Hidden",0

w3_m14_trigger2:
	.db 1
	aspidah(7, 3)

w3_m14_trigger3:
	.db 4
	spawn(7, 6, w3_m14_trigger4)
	spawn(7, 1, w3_m14_trigger5)
	spawn(5, 3, w3_m14_trigger6)
	spawn(9, 3, w3_m14_trigger7)

w3_m14_trigger4:
	scorp(7, 6)

w3_m14_trigger5:
	wallblock(7, 1)

w3_m14_trigger6:
	wallblock(5, 3)

w3_m14_trigger7:
	wallblock(9, 3)

world3_map15:
#include maps\ruins15.lzi
	.db 10
	.db (10*8)+4,(5*8)+4
	.db $ff
	.db (10*8)+4,(5*8)+4
	.db $ff
	.db (10*8)+4,(5*8)+4
	.db $ff
	.db $fe
world3_obj15:
	.db 5

	lampup(10, 6)
	herbup(11, 5)
	badguy(9, 4, 28, 3)
	aspidah(5, 6)

	.db 5*8,5*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w3_m15_loot1

w3_m15_loot1:
	.db item_key
	.db pmod_tarnished
	.db 0


world3_map16:
#include maps\ruins16.lzi
	.db $fe
world3_obj16:
	.db 7

	.db 9*8,7*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_tarnished
	.db 0

	aspidah(9, 4)
	herbdown(9, 2)
	lootdown(2, 2, 20, 3)
	lootleft(5, 2, 22, 2)
	lootright(3, 7, 24, 2)
	bspidah(6, 5)


world3_mdeep1:
#include maps\deep1.lzi
	.db $fe
world3_odeep1:
	.db 4

	.db 7*8,1*8
	.db object_stairsup
	.db ai_static
	.db $40+rai_teleport
	.dw w3_md1_teleport1

	.db 7*8,5*8
	.db object_fountain
	.db ai_animate2
	.db $40+rai_condition
	.dw w3_md1_script1

	.db 10*8,6*8
	.db object_doorright
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 4*8,6*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

w3_md1_script1:
	.db flag_none
	.db rai_givehealth
	.db 2,0
	.db rai_condition
	.dw w3_md1_script2

w3_md1_script2 equ $-1
	.db rai_random
	.db 233,0
	.db rai_conditionelse
	.dw w3_md1_script3

w3_md1_script3 equ $-1
	.db rai_random
	.db 70,0
	.db rai_conditionelse
	.dw w3_md1_script4
	.db rai_nfsolidtrigger
	.dw w3_md1_trigger1

w3_md1_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w3_md1_trigger2
	.db rai_nfsolidtrigger
	.dw w3_md1_trigger3

w3_md1_trigger1:
	.db 1
	spawn(5, 2, w3_md1_trigger4)

w3_md1_trigger2:
	.db 1
	spawn(9, 2, w3_md1_trigger5)

w3_md1_trigger3:
	.db 1
	spawn(7, 2, w3_md1_trigger6)

w3_md1_trigger4:
	scorp(5, 2)

w3_md1_trigger5:
	bspidah(9, 2)

w3_md1_trigger6:
	aspidah(7, 2)

w3_md1_teleport1:
	.db 7*8,7*8
	.db 14

world3_mdeep2:
#include maps\deep2.lzi
	.db $fe
world3_odeep2:
	.db 9

	.db 14*8,6*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_triangular
	.db 0

	aspidah(4, 3)

	lootright(2, 2, 36, 3)

	.db 8*8,6*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_conditionelse
	.dw w3_md2_script4

	.db 9*8,5*8
	.db object_chestright
	.db ai_static
	.db $40+rai_conditionelse
	.dw w3_md2_script5

	.db 8*8,4*8
	.db object_chestup
	.db ai_static
	.db $40+rai_conditionelse
	.dw w3_md2_script9

	.db 7*8,5*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_conditionelse
	.dw w3_md2_script13

	.db 8*8,1*8
	.db object_doordown
	.db ai_static
	.db rai_conditionelse
	.dw w3_md2_script20

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w3_md2_script22

w3_md2_script1 equ $-1
	.db rai_checkitem
	.dw loot_airgem
	.db rai_chain
	.dw w3_md2_script3
	.db rai_chain
	.dw w3_md2_script2

w3_md2_script2 equ $-1
	.db 2
	.db rai_text
	.db 11,0
	.db rai_text
	.db 15

w3_md2_script3 equ $-1
	.db 3
	.db rai_takeitem
	.dw loot_airgem
	.db rai_text
	.db 16,0
	.db rai_unflagobject

w3_md2_script4:
	.db flag_none
	.db rai_checkflag
	.db 0,0
	.db $80
	.db 0,0
	.db rai_conditionelse
	.dw w3_md2_script1

w3_md2_script5:
	.db flag_none
	.db rai_checkflag
	.db 0,0
	.db $80
	.db 0,0
	.db rai_conditionelse
	.dw w3_md2_script6

w3_md2_script6 equ $-1
	.db rai_checkitem
	.dw loot_firegem
	.db rai_chain
	.dw w3_md2_script7
	.db rai_chain
	.dw w3_md2_script8

w3_md2_script7 equ $-1
	.db 3
	.db rai_takeitem
	.dw loot_firegem
	.db rai_text
	.db 17,0
	.db rai_unflagobject

w3_md2_script8 equ $-1
	.db 2
	.db rai_text
	.db 12,0
	.db rai_text
	.db 15

w3_md2_script9:
	.db flag_none
	.db rai_checkflag
	.db 0,0
	.db $80
	.db 0,0
	.db rai_conditionelse
	.dw w3_md2_script10

w3_md2_script10 equ $-1
	.db rai_checkitem
	.dw loot_earthgem
	.db rai_chain
	.dw w3_md2_script11
	.db rai_chain
	.dw w3_md2_script12

w3_md2_script11 equ $-1
	.db 3
	.db rai_takeitem
	.dw loot_earthgem
	.db rai_text
	.db 18,0
	.db rai_unflagobject

w3_md2_script12 equ $-1
	.db 2
	.db rai_text
	.db 13,0
	.db rai_text
	.db 15

w3_md2_script13:
	.db flag_none
	.db rai_checkflag
	.db 0,0
	.db $80
	.db 0,0
	.db rai_conditionelse
	.dw w3_md2_script14

w3_md2_script14 equ $-1
	.db rai_checkitem
	.dw loot_watergem
	.db rai_chain
	.dw w3_md2_script15
	.db rai_chain
	.dw w3_md2_script16

w3_md2_script15 equ $-1
	.db 3
	.db rai_takeitem
	.dw loot_watergem
	.db rai_text
	.db 19,0
	.db rai_unflagobject

w3_md2_script16 equ $-1
	.db 2
	.db rai_text
	.db 14,0
	.db rai_text
	.db 15

w3_md2_script17 equ $-1
	.db rai_checkother
	.db 21,4*8
	.db rai_condition
	.dw w3_md2_script18

w3_md2_script18 equ $-1
	.db rai_checkother
	.db 21,5*8
	.db rai_condition
	.dw w3_md2_script19

w3_md2_script19 equ $-1
	.db rai_checkother
	.db 21,6*8
	.db rai_checkother
	.db 21,7*8

w3_md2_script20:
	.db flag_opendoor
	.db rai_condition
	.dw w3_md2_script17
	.db rai_opendoor
	.db 0,0
	.db rai_text
	.db 20

w3_md2_script21 equ $-1
	.db 2
	.db rai_loadlights
	.dw w3_md2_light1
	.db rai_remove

w3_md2_light1:
	.db 6
	.db (8*8)+4,0
	.db $ff
	.db (8*8)+4,3
	.db $ff
	.db (8*8)+4,6
	.db $ff
	.db (8*8)+4,3
	.db $fe

w3_md2_script22:
	.db %00000011
	.db rai_condition
	.dw w3_md2_script23

w3_md2_script23 equ $-1
	.db rai_condition
	.dw w3_md2_script17
	.db rai_condition
	.dw w3_md2_script24

w3_md2_script24 equ $-1
	.db rai_link
	.db 8*8,0
	.db rai_chain
	.dw w3_md2_script21

world3_mdeep3:
#include maps\deep3.lzi
	.db $fe
world3_odeep3:
	.db 4

	lootdown(4, 2, 26, 3)
	aspidah(4, 7)

	.db (10*8)+4
	.db (3*8)+4
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_conditionelse
	.dw w3_md3_script1

	.db 7*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w3_md3_script3

w3_md3_script1:
	.db flag_none
	.db rai_checkitem
	.dw loot_focusing
	.db rai_chain
	.dw w3_md3_script2
	.db rai_text
	.db 6,0

w3_md3_script2 equ $-1
	.db 3
	.db rai_text
	.db 7,0
	.db rai_removeother
	.db 4*8,0
	.db rai_teleport
	.dw w3_md3_teleport1

w3_md3_teleport1:
	.db 4*8,2*8
	.db 26

w3_md3_script3:
	.db %00011111
	.db rai_condition
	.dw w3_md3_script4

w3_md3_script4 equ $-1
	.db rai_random
	.db 150,0
	.db rai_conditionelse
	.dw w3_md3_script5

w3_md3_script5 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w3_md3_trigger2
	.db rai_nfsolidtrigger
	.dw w3_md3_trigger1

w3_md3_trigger1:
	.db 1
	.db 10*8,(2*8)+4
	.db object_enemy3
	.db ai_passivetrack
	.db $80
	.db 0,3

w3_md3_trigger2:
	.db 1
	.db 11*8,(4*8)+4
	.db object_enemy4
	.db ai_passivetrack
	.db $80
	.db 0,2

world3_mdeep4:
#include maps\deep4.lzi
	.db $fe
world3_odeep4:
	.db 7

	.db 8*8,4*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w3_md4_teleport1

	aspidah(7, 5)
	aspidah(3, 6)

	.db 12*8,6*8
	.db object_chestup
	.db ai_static
	.db $40+rai_chain
	.dw w3_md4_script1

	lootup(6, 7, 28, 3)
	herbright(2, 5)

	.db 3*8,7*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_earthgem

w3_md4_script1:
	.db flag_makestatic
	.db 2
	.db rai_givespec
	.dw loot_focusing
	.db rai_nfsolidtrigger
	.dw w3_md4_trigger1

w3_md4_trigger1:
	.db 1
	spawn(12, 1, w3_md4_trigger2)

w3_md4_trigger2:
	aspidah(12, 1)

w3_md4_teleport1:
	.db (10*8)+4,(2*8)+4
	.db 22

world3_mdeep5:
#include maps\deep5.lzi
	.db $fe
world3_odeep5:
	.db 6

	.db 6*8,7*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w3_md5_9_teleport

	herbdown(5, 6)
	lootleft(6, 2, 30, 2)

	.db 9*8,6*8
	.db object_doorup
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_triangular
	.db 0

	.db 3*8,6*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_firegem

	.db 11*8,3*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w3_md5_script1

w3_md5_script1:
	.db %00000111
	.db rai_trigger
	.dw w3_md5_trigger1

w3_md5_trigger1:
	.db 2
	spawn(10, 3, w3_md5_trigger2)
	spawn(12, 4, w3_md5_trigger3)

w3_md5_trigger2:
	aspidah(10, 3)

w3_md5_trigger3:
	aspidah(12, 4)


world3_mdeep6:
#include maps\deep6.lzi
	.db $fe
world3_odeep6:
	.db 6

	.db 10*8,2*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_givespec
	.dw loot_zedsword

	herbleft(10, 6)

	.db 13*8,4*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_condition
	.dw w3_md6_script1

	.db 7*8,4*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

	scorp(3, 2)
	bspidah(5, 6)

w3_md6_script1:
	.db flag_makestatic
	.db rai_givespec
	.dw loot_watergem
	.db rai_nfsolidtrigger
	.dw w3_md6_trigger1

w3_md6_trigger1:
	.db 5
	delay(5, w3_md6_trigger2)
	delay(13, w3_md6_trigger3)
	delay(21, w3_md6_trigger4)
	delay(29, w3_md6_trigger5)
	delay(37, w3_md6_trigger6)

w3_md6_trigger2:
	spawn(12, 4, w3_md6_trigger7)

w3_md6_trigger3:
	spawn(11, 4, w3_md6_trigger8)

w3_md6_trigger4:
	spawn(10, 4, w3_md6_trigger9)

w3_md6_trigger5:
	spawn(9, 4, w3_md6_trigger10)

w3_md6_trigger6:
	spawn(8, 4, w3_md6_trigger11)

w3_md6_trigger7:
	cloudkill(12, 4, %10000000, 5)

w3_md6_trigger8:
	cloudkill(11, 4, %10000000, 5)

w3_md6_trigger9:
	cloudkill(10, 4, %10000000, 5)

w3_md6_trigger10:
	cloudkill(9, 4, %10000000, 5)

w3_md6_trigger11:
	cloudkill(8, 4, %10000000, 5)

world3_mdeep7:
#include maps\deep7.lzi
	.db $fe
world3_odeep7:
	.db 5

	.db 6*8,5*8
	.db object_doorup
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_triangular
	.db 0

	.db 3*8,3*8
	.db object_player
	.db ai_imwander
	.db $40+rai_conditionelse
	.dw w3_md7_script3

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_static
	.db flag_none
	.db 0,0

	aspidah(10, 7)
	aspidah(8, 6)
	herbdown(11, 2)

w3_md7_script1 equ $-1
	.db rai_checkflag
	.db 0,0
	.db rai_conditionelse
	.dw w3_md7_script4
	.db rai_chain
	.dw w3_md7_script2

w3_md7_script2 equ $-1
	.db 2
	.db rai_text
	.db 8,0
	.db rai_givespec
	.dw w3_md7_loot1

w3_md7_script3:
	.db flag_none
	.db rai_checkother
	.db 20,3*8
	.db $80
	.db 0,0
	.db rai_conditionelse
	.dw w3_md7_script1

w3_md7_script4 equ $-1
	.db rai_checkitem
	.dw loot_zedsword
	.db rai_chain
	.dw w3_md7_script5
	.db rai_text
	.db 10,0

w3_md7_script5 equ $-1
	.db 4
	.db rai_text
	.db 9,0
	.db rai_takeitem
	.dw loot_zedsword
	.db rai_givespec
	.dw w3_md7_loot3
	.db rai_removeother
	.db 3*8

w3_md7_loot1:
	.db item_key
	.db pmod_triangular
	.db 0

w3_md7_loot3:
	.db item_round
	.db 0
	.db pmod_zedshield

world3_mdeep8:
#include maps\deep8.lzi
	.db $fe
world3_odeep8:
	.db 9

	.db 11*8,5*8
	.db object_doorright
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_triangular
	.db 0

	lootdown(8, 5, 32, 3)
	aspidah(12, 7)
	lootdown(5, 2, 34, 3)
	aspidah(6, 5)
	scorp(3, 6)
	bspidah(2, 3)

	.db 2*8,5*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_airgem

	scorp(10, 2)

world3_mdeep9:
#include maps\deep9.lzi
	.db $fe
world3_odeep9:
	.db 12

	block(4, 4)
	block(6, 4)
	block(5, 5)
	block(5, 6)
	block(8, 4)

	.db 4*8,4*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 6*8,4*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 5*8,5*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 5*8,6*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 8*8,4*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 10*8,5*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 12*8,5*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_conditionelse
	.dw w3_md9_script1

w3_md9_script1:
	.db flag_none
	.db rai_condition
	.dw w3_md9_script2
	.db rai_teleport
	.dw w3_md5_9_teleport
	.db rai_teleport
	.dw w3_md9_teleport1

w3_md9_script2 equ $-1
	.db rai_checkother
	.db 28,6*8
	.db rai_condition
	.dw w3_md9_script3

w3_md9_script3 equ $-1
	.db rai_checkother
	.db 28,7*8
	.db rai_condition
	.dw w3_md9_script4

w3_md9_script4 equ $-1
	.db rai_checkother
	.db 28,8*8
	.db rai_condition
	.dw w3_md9_script5

w3_md9_script5 equ $-1
	.db rai_checkother
	.db 28,9*8
	.db rai_checkother
	.db 28,10*8

w3_md9_teleport1:
	.db 2*8,7*8
	.db 29

w3_md5_9_teleport:
	.db 4*8,3*8
	.db 29

world3_mdeep10:
#include maps\deep10.lzi
	.db 8
	.db (8*8)+4,0
	.db $ff
	.db (8*8)+4,3
	.db $ff
	.db (8*8)+4,6
	.db $ff
	.db (8*8)+4,3
	.db $fe
world3_odeep10:
	.db 15

	lampdown(8, 1)

	.db 9*8,7*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 7*8,7*8
	.db object_doorright
	.db ai_static
	.db rai_opendoor
	.db 0,0

	herbdown(11, 6)
	herbdown(5, 6)
	lootup(13, 6, 38, 4)

	.db 3*8,6*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_chain
	.dw w3_md10_script10

	badguy(12, 4, 36, 4)
	badguy(4, 4, 36, 4)

	.db 13*8,5*8
	.db object_doorup
	.db ai_static
	.db $40+rai_conditionelse
	.dw w3_md10_script1

	.db 3*8,5*8
	.db object_doorup
	.db ai_static
	.db $40+rai_conditionelse
	.dw w3_md10_script1

	.db 8*8,5*8
	.db object_doorup
	.db ai_static
	.db $40+rai_condition
	.dw w3_md10_script3

	.db 11*8,4*8
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

	.db 5*8,4*8
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w3_md10_script5

w3_md10_script1:
	.db flag_opendoor
	.db rai_condition
	.dw w3_md10_script2
	.db rai_opendoor
	.db 0,0
	.db rai_text
	.db 21

w3_md10_script2 equ $-1
	.db rai_checkother
	.db 17,8*8
	.db rai_checkother
	.db 17,9*8

w3_md10_script3:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_chain
	.dw w3_md10_script4

w3_md10_script4 equ $-1
	.db 2
	.db rai_removeother
	.db 13*8,0
	.db rai_removeother
	.db 14*8,0

w3_md10_script5:
	.db %00001111
	.db rai_condition
	.dw w3_md10_script6

w3_md10_script6 equ $-1
	.db rai_random
	.db 142,0
	.db rai_conditionelse
	.dw w3_md10_script7

w3_md10_script7 equ $-1
	.db rai_condition
	.dw w3_md10_script2
	.db $80
	.db 0,0
	.db rai_condition
	.dw w3_md10_script8

w3_md10_script8 equ $-1
	.db rai_checkother
	.db 17,12*8
	.db rai_conditionelse
	.dw w3_md10_script9

w3_md10_script9 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w3_md10_trigger1
	.db rai_nfsolidtrigger
	.dw w3_md10_trigger2

w3_md10_script10:
	.db flag_none
	.db 2
	.db rai_setdesc
	.dw denanc
	.db rai_advance
	.db 3

w3_md10_trigger1:
	.db 1
	spawn(6, 2, w3_md10_trigger3)

w3_md10_trigger2:
	.db 1
	spawn(10, 2, w3_md10_trigger4)

w3_md10_trigger3:
	.db 6*8, 2*8
	.db object_enemy1
	.db ai_passivetrack
	.db $80
	.db 0
	.db 4

w3_md10_trigger4:
	.db 10*8, 2*8
	.db object_enemy1
	.db ai_passivetrack
	.db $80
	.db 0
	.db 4

denanc:
	.db "Den of the Ancients",0

;***********************
;** Fourth world data **
;***********************

world4:
	.db 5					;height
	.db 3					;width
	.db 9					;starting map
	.db 8*8					;starting x-coord
	.db 6*8					;starting y-coord
	.db enemy_scorp			;4 enemies used in this world
	.db enemy_badguy
	.db enemy_frog
	.db enemy_dino
	.dw rel(world4_texts)
	.db 0					;intro text ($ff for none)
	.db $ff					;extro text
	.dw rel(world4_paths)

	.dw rel(world4_map12),rel(world4_obj12)
	.dw rel(world4_map13),rel(world4_obj13)
	.dw rel(world4_map15),rel(world4_obj15)
	
	.dw rel(world4_map10),rel(world4_obj10)
	.dw rel(world4_map9),rel(world4_obj9)
	.dw rel(world4_map11),rel(world4_obj11)

	.dw rel(world4_map14),rel(world4_obj14)
	.dw rel(world4_map8),rel(world4_obj8)
	.dw rel(world4_map7),rel(world4_obj7)

	.dw rel(world4_map1),rel(world4_obj1)
	.dw rel(world4_map5),rel(world4_obj5)
	.dw rel(world4_map6),rel(world4_obj6)

	.dw rel(world4_map2),rel(world4_obj2)
	.dw rel(world4_map3),rel(world4_obj3)
	.dw rel(world4_map4),rel(world4_obj4)

world4_texts:
	.db 10
	.dw rel(world4_intro)
	.dw rel(mechanism)
	.dw rel(world4_clavius1)
	.dw rel(world4_clavius2)
	.dw rel(world4_clavius3)
	.dw rel(world4_clavius4)
	.dw rel(world4_cloudtrap)
	.dw rel(world4_sealeddoor)
	.dw rel(world4_glowgem)
	.dw rel(world4_damscepter)

world4_intro:
	.db "A chill overcomes you as you step into the room...",$fe
	.db "you know that no man was ever meant to walk these halls.",0

world4_clavius1:
	.db $fd
#include texts\clavius1.lzi
	
world4_clavius2:
	.db "You will also need a key.  Here...",0

world4_clavius3:
	.db "I will speak with you no more.  Do not return here unless your task "
	.db "is completed.",0

world4_clavius4:
	.db "Returned, have you?  Was Kerric not a dangerous enough opponent?",$fe
	.db "Perhaps I can provide you with a more engaging battle, yes?  Fool.",0

world4_cloudtrap:
	.db "The air currents in the room shift "
	.db "as you close the chest.  You have set off a trap...",0

world4_sealeddoor:
	.db $fd
#include texts/sealed.lzi

world4_glowgem:
	.db "You set the glowing gem in the socket.  After a moment, the "
	.db "door slowly opens...",0

world4_damscepter:
	.db "The damascened scepter begins to glow.  Magical energies flow "
	.db "around you...",0

world4_paths:

world4_map1:
#include maps\tunnels1.lzi
	.db $fe
world4_obj1:
	.db 6

	.db 6*8,2*8
	.db object_chestright
	.db ai_static
	.db $40+rai_givespec
	.dw w4_m1_loot1

	.db 8*8,3*8
	.db object_doordown
	.db ai_static
	.db rai_opendoor
	.db 0,0

	.db 6*8,4*8+4
	.db object_invis
	.db ai_static
	.db rai_trigger
	.dw w4_m1_trigger1

	.db 9*8,4*8+4
	.db object_invis
	.db ai_static
	.db rai_trigger
	.dw w4_m1_trigger2

	lootdown(2, 2, 0, 4)
	herbleft(10, 2)

w4_m1_loot1:
	.db item_tome
	.db pmod_clerical
	.db 0

w4_m1_trigger1:
	.db 2
	scorp(4, 2)
	scorp(4, 8)

w4_m1_trigger2:
	.db 1
	frog(12, 2)

world4_map2:
#include maps\tunnels2.lzi
	.db $fe
world4_obj2:
	.db 7

	frog(4, 5)
	herbright(2, 7)

	.db 13*8,2*8
	.db object_switch
	.db ai_static
	.db rai_switch
	.dw 0

	.db 10*8,7*8
	.db object_doorleft
	.db ai_static
	.db rai_condition
	.dw w4_m2_script1

	scorp(10, 5)
	scorp(9, 6)

	lootdown(13, 5, 6, 4)

w4_m2_script1:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_chain
	.dw w4_m2_script2

w4_m2_script2 equ $-1
	.db 2
	.db rai_nfsolidtrigger
	.dw w4_m2_trigger1
	.db rai_conditionelse
	.dw w4_m2_script3

w4_m2_trigger1:
	.db 1
	frog(13, 6)

w4_m2_script3 equ $-1
	.db rai_checkother
	.db 12,3*8
	.db $80
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w4_m2_trigger2

w4_m2_trigger2:
	.db 1
	spawn(5, 7, w4_m2_trigger3)

w4_m2_trigger3:
	.db 5*8,7*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 0,5

world4_map3:
#include maps\tunnels3.lzi
	.db $fe
world4_obj3:
	.db 4

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w4_m3_script1

	lootdown(3, 2, 2, 5)
	
	.db 13*8,6*8
	.db object_switch
	.db ai_static
	.db rai_switch
	.db 0,0

	.db 3*8,4*8
	.db object_doordown
	.db ai_static
	.db $40+rai_conditionelse
	.dw w4_m3_script6

w4_m3_script1:
	.db %00000111
	.db rai_conditionelse
	.dw w4_m3_script2

w4_m3_script2 equ $-1
	.db rai_random
	.db 164,0
	.db rai_conditionelse
	.dw w4_m3_script3
	.db rai_condition
	.dw w4_m3_script4

w4_m3_script3 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w4_m3_trigger1
	.db rai_nfsolidtrigger
	.dw w4_m3_trigger2

w4_m3_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w4_m3_script5

w4_m3_script5 equ $-1
	.db rai_random
	.db 105,0
	.db rai_nfsolidtrigger
	.dw w4_m3_trigger5
	.db rai_nfsolidtrigger
	.dw w4_m3_trigger6

w4_m3_script6
	.db flag_opendoor
	.db rai_checkother
	.db 13,3*8
	.db rai_opendoor
	.db 0,0
	.db rai_text
	.db 1,0

w4_m3_trigger1:	
	.db 1
	spawn(5, 4, w4_m3_trigger3)

w4_m3_trigger2:
	.db 1
	spawn(11, 2, w4_m3_trigger4)

w4_m3_trigger3:
	.db 5*8,4*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 0,4

w4_m3_trigger4:
	.db 11*8,2*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 5,4

w4_m3_trigger5:
	.db 2
	spawn(9, 5, w4_m3_trigger7)
	spawn(9, 5, w4_m3_trigger8)

w4_m3_trigger7:
	.db 9*8,5*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 2,4

w4_m3_trigger8:
	.db 9*8,5*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 4,4

w4_m3_trigger6:
	.db 1
	spawn(12, 3, w4_m3_trigger9)

w4_m3_trigger9:
	frog(12, 3)

world4_map4:
#include maps\tunnels4.lzi
	.db $fe
world4_obj4:
	.db 12

	.db 2*8,7*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w4_m4_teleport1

	badguy(10, 2, 25, 4)
	badguy(10, 7, 24, 4)
	badguy(10, 4, 37, 4)

	.db 9*8,2*8+4
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

	.db 9*8,4*8
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

	.db 9*8,5*8+4
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

	.db 9*8,7*8
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

	.db 4*8,4*8+4
	.db object_invis
	.db ai_static
	.db rai_chain
	.dw w4_m4_script1

	.db 11*8+4,4*8+4
	.db object_enemy2
	.db ai_facer
	.db $40+rai_conditionelse
	.dw w4_m4_script2

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_static
	.db flag_none
	.db 0,0

	lootleft(13, 4, 4, 6)

w4_m4_teleport1:
	.db 8*8,6*8
	.db 9 

w4_m4_script1:
	.db flag_die
	.db 5
	.db rai_removeother
	.db 5*8,0
	.db rai_removeother
	.db 6*8,0
	.db rai_removeother
	.db 7*8,0
	.db rai_removeother
	.db 8*8,0
	.db rai_remove

w4_m4_script2:
	.db flag_die
	.db rai_checkother
	.db 14,11*8
	.db rai_chain
	.dw w4_m4_script7
	.db rai_chain
	.dw w4_m4_script3

w4_m4_script3 equ $-1
	.db 3
	.db rai_text
	.db 2,0
	.db rai_condition
	.dw w4_m4_script4
	.db rai_flagobject

w4_m4_script4 equ $-1
	.db rai_givespec	
	.dw w4_m4_loot1
	.db rai_chain
	.dw w4_m4_script5

w4_m4_loot1:
	.db item_potion
	.db 0
	.db pmod_demonbile

w4_m4_script5 equ $-1
	.db 2
	.db rai_text
	.db 3,0
	.db rai_condition
	.dw w4_m4_script6

w4_m4_script6 equ $-1
	.db rai_givespec
	.dw w4_m4_loot2
	.db rai_chain
	.dw w4_m4_script9

w4_m4_script9 equ $-1
	.db 2
	.db rai_removeother
	.db 11*8,0
	.db rai_text
	.db 4

w4_m4_loot2:
	.db item_key
	.db pmod_crescent
	.db 0

w4_m4_script7 equ $-1
	.db 3
	.db rai_text
	.db 5,0
	.db rai_remove
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w4_m4_trigger1

w4_m4_trigger1:
	.db 2

	.db 11*8+4,4*8+4
	.db object_enemy2
	.db ai_shooter
	.db $80
	.db 0,8

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w4_m4_script8

w4_m4_script8:
	.db %00011111
	.db rai_nfsolidtrigger
	.dw w4_m4_trigger2

w4_m4_trigger2:
	.db 2
	spawn(10, 3, w4_m4_trigger3)
	spawn(10, 6, w4_m4_trigger4)

w4_m4_trigger3:
	dino(10, 3)

w4_m4_trigger4:
	dino(10, 6)

world4_map5:
#include maps\tunnels5.lzi
	.db $fe
world4_obj5:
	.db 11

	block(8, 4)
	block(3, 6)

	.db 2*8,3*8
	.db object_doordown
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_crescent
	.db 0

	scorp(10, 7)

	.db 7*8,3*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 8*8,3*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 9*8,3*8
	.db object_invis
	.db $80+ai_respondelse
	.db flag_none
	.dw sokobanscript

	.db 12*8,3*8
	.db object_doorleft
	.db ai_static
	.db rai_conditionelse
	.dw w4_m5_script1

	.db 13*8,5*8
	.db object_switch
	.db ai_static
	.db rai_switch
	.dw 0

	.db 4*8,2*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_conditionelse
	.dw w4_m5_script4

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_static
	.db flag_none
	.db 0,0

w4_m5_script1:
	.db flag_opendoor
	.db rai_condition
	.dw w4_m5_script2
	.db rai_opendoor
	.db 0,0
	.db $40+rai_text
	.db 1

w4_m5_script2 equ $-1
	.db rai_checkother
	.db 10,5*8
	.db rai_condition
	.dw w4_m5_script3

w4_m5_script3 equ $-1
	.db rai_checkother
	.db 10,6*8
	.db rai_checkother
	.db 10,7*8

w4_m5_script4:
	.db flag_makestatic
	.db rai_random
	.db 128,0
	.db rai_givespec
	.dw w4_m5_loot1
	.db rai_condition
	.dw w4_m5_script5

w4_m5_script5 equ $-1
	.db rai_givespec
	.dw w4_m5_loot2
	.db rai_removeother
	.db 11*8
	
w4_m5_loot1:
	.db item_scroll
	.db pmod_foreman1
	.db 0

w4_m5_loot2:
	.db item_scroll
	.db pmod_foreman2
	.db 0


world4_map6:
#include maps\tunnels6.lzi
	.db $fe
world4_obj6:
	.db 8

	.db 13*8,6*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w4_m6_loot1

	.db 10*8,7*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_crescent
	.db 0

	.db 5*8,5*8
	.db object_chestright
	.db ai_static
	.db $40+rai_condition
	.dw w4_m6_script1

	frog(3, 1)
	scorp(4, 7)

	.db 10*8,2*8	
	.db object_chestleft
	.db ai_static
	.db $40+rai_condition
	.dw w4_m6_script3

	herbright(5, 2)

	.db 10*8,5*8
	.db object_doorleft
	.db ai_static
	.db rai_condition
	.dw w4_m6_script5

w4_m6_script1:
	.db flag_makestatic
	.db rai_giveloot
	.db 8,4
	.db rai_chain
	.dw w4_m6_script2

w4_m6_script2 equ $-1
	.db 2
	.db rai_text
	.db 6,0
	.db rai_nfsolidtrigger
	.dw w4_m6_trigger1
	
w4_m6_script3:
	.db flag_makestatic
	.db rai_giveloot
	.db 10,4
	.db rai_chain
	.dw w4_m6_script4

w4_m6_script4 equ $-1
	.db 3
	.db rai_text
	.db 6,0
	.db rai_curse
	.db pmod_hurtin,150
	.db rai_nfsolidtrigger
	.dw w4_m6_trigger7

w4_m6_trigger1:
	.db 5
	spawn(6, 5, w4_m6_trigger2)
	spawn(6, 4, w4_m6_trigger3)
	spawn(6, 6, w4_m6_trigger4)	
	spawn(9, 5, w4_m6_trigger5)
	spawn(8, 2, w4_m6_trigger6)
	spawn(6, 1, w4_m6_trigger11)

w4_m6_trigger2:
	cloudkill(6, 5, %10000000, 4)

w4_m6_trigger3:
	cloudkill(6, 4, %00000100, 4)

w4_m6_trigger4:
	cloudkill(6, 6, %00100000, 4)

w4_m6_trigger5:
	.db 9*8,5*8
	.db object_gooballleft
	.db $80+ai_shootr
	.db $80
	.db 4,4

w4_m6_trigger6:
	.db 8*8,2*8
	.db object_gooballleft
	.db $80+ai_shootr
	.db $80
	.db 5,4

w4_m6_trigger11:
	.db 6*8,1*8
	.db object_gooballdown
	.db $80+ai_shootr
	.db $80
	.db 6,4

w4_m6_trigger7:
	.db 2
	spawn(8, 4, w4_m6_trigger8)
	spawn(7, 1, w4_m6_trigger9)

w4_m6_trigger8:
	scorp(8, 4)

w4_m6_trigger9:
	scorp(7, 1)

w4_m6_loot1:
	.db item_short
	.db 0
	.db mods_sswords+7				;of fire

w4_m6_script5:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w4_m6_trigger10

w4_m6_trigger10:
	.db 1
	frog(12, 1)


world4_map7:
#include maps\tunnels7.lzi
	.db $fe
world4_obj7:
	.db 14

	.db 7*8+4,5*8+4
	.db object_fountain
	.db ai_animate2
	.db $40+rai_conditionelse
	.dw w4_m7_script1

	.db 4*8,2*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.db 0,0

	.db 11*8,2*8
	.db object_switch
	.db ai_static
	.db $40+rai_switch
	.db 0,0

	cloudkill(7, 4, %01000000, 4)
	cloudkill(6, 5, %00000001, 4)
	cloudkill(9, 4, %00010000, 4)
	cloudkill(8, 3, %00000010, 4)
	cloudkill(9, 5, %10000000, 4)
	cloudkill(10, 6, %00001000, 4)
	cloudkill(6, 6, %00100000, 4)
	cloudkill(6, 7, %00000001, 4)
	cloudkill(5, 6, %00001000, 4)

	scorp(2, 2)
	frog(13, 2)

w4_m7_script1:
	.db flag_none
	.db rai_condition
	.dw w4_m7_script2
	.db rai_givehealth
	.db 3,0
	.db rai_condition
	.dw w4_m7_script3

w4_m7_script2 equ $-1
	.db rai_checkother
	.db 8,2*8
	.db rai_checkother
	.db 8,3*8

w4_m7_script3 equ $-1
	.db rai_random
	.db 210,0
	.db rai_conditionelse
	.dw w4_m7_script4

w4_m7_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w4_m7_trigger1
	.db rai_nfsolidtrigger
	.dw w4_m7_trigger2

w4_m7_trigger1:
	.db 1
	spawn(6, 8, w4_m7_trigger3)

w4_m7_trigger2:
	.db 1
	spawn(9, 8, w4_m7_trigger4)

w4_m7_trigger3:
	.db 6*8,8*8
	.db object_gooballright
	.db $80+ai_shootr
	.db $80
	.db 1,4

w4_m7_trigger4:
	.db 9*8,8*8
	.db object_gooballleft
	.db $80+ai_shootr
	.db $80
	.db 3,4


world4_map8:
#include maps\tunnels8.lzi
	.db $fe
world4_obj8:
	.db 17

	.db 5*8+4,4*8
	.db object_invis
	.db ai_static
	.db rai_chain
	.dw w4_m8_script1

	.db 3*8,4*8
	.db object_formspawn
	.db ai_animate4
	.db rai_condition
	.dw w4_m8_script5

	lampdown(3, 1)
	lampdown(12, 1)

	.db 8*8+4,4*8
	.db object_invis
	.db ai_static
	.db rai_chain
	.dw w4_m8_script6

	.db 11*8,4*8
	.db object_formspawn
	.db ai_animate4
	.db rai_condition
	.dw w4_m8_script10

	scorp(7, 7)

	dino(11, 2)
	dino(12, 2)
	dino(13, 4)
	dino(12, 4)
	dino(12, 3)
	dino(3, 2)
	dino(3, 3)
	dino(3, 5)
	dino(3, 6)
	dino(2, 4)

w4_m8_script1:
	.db flag_die
	.db 2
	.db rai_conditionelse
	.dw w4_m8_script2
	.db rai_remove

w4_m8_script2 equ $-1
	.db rai_checkother
	.db 10,9*8
	.db rai_condition
	.dw w4_m8_script3
	.db rai_chain
	.dw w4_m8_script4

w4_m8_script3 equ $-1
	.db rai_checkother
	.db 10,11*8
	.db rai_chain
	.dw w4_m8_script4

w4_m8_script4 equ $-1
	.db 4
	.db rai_xorothers
	.dw w4_m8_switch1
	.db rai_loadlights
	.dw w4_m8_light1
	.db rai_nfsolidtrigger
	.dw w4_m8_trigger1
	.db rai_curse
	.db pmod_libtrap,255

w4_m8_script5:
	.db flag_none
	.db rai_checkflag
	.db 0,0
	.db rai_ststele
	.db 6*8,7*8

w4_m8_script6:
	.db flag_die
	.db 2
	.db rai_conditionelse
	.dw w4_m8_script7
	.db rai_remove

w4_m8_script7 equ $-1
	.db rai_checkother
	.db 10,9*8
	.db rai_conditionelse
	.dw w4_m8_script8
	.db rai_chain
	.dw w4_m8_script9

w4_m8_script8 equ $-1
	.db rai_checkother
	.db 10,11*8
	.db $80
	.db 0,0
	.db rai_chain
	.dw w4_m8_script9

w4_m8_script9 equ $-1
	.db 4
	.db rai_xorothers
	.dw w4_m8_switch2
	.db rai_loadlights
	.dw w4_m8_light2
	.db rai_nfsolidtrigger
	.dw w4_m8_trigger8
	.db rai_curse
	.db pmod_libtrap,255

w4_m8_script10:
	.db flag_none
	.db rai_checkflag
	.db 0,0
	.db rai_ststele
	.db 9*8,7*8

w4_m8_light1:
	.db 1
	.db 3*8+4,5
	.db $fe

w4_m8_light2:
	.db 1
	.db 12*8+4,5
	.db $fe

w4_m8_switch1:
	.db 1
	.db 2*8,7

w4_m8_switch2:
	.db 1
	.db 6*8,7

w4_m8_trigger1:
	.db 4
	spawn(5, 1, w4_m8_trigger2)
	spawn(6, 1, w4_m8_trigger3)
	delay(8, w4_m8_trigger4)
	delay(8, w4_m8_trigger5)

w4_m8_trigger2:
	.db 5*8+4,1*8
	.db object_gooballdown
	.db $80+ai_shootr
	.db $80
	.db 6,7

w4_m8_trigger3:
	.db 5*8+4,2*8
	.db object_gooballdown
	.db $80+ai_shootr
	.db $80
	.db 6,7

w4_m8_trigger4:
	spawn(5, 1, w4_m8_trigger6)

w4_m8_trigger5:
	spawn(6, 1, w4_m8_trigger7)

w4_m8_trigger6:
	wallblock(5, 1)

w4_m8_trigger7:
	wallblock(6, 1)

w4_m8_trigger8:
	.db 4
	spawn(8, 1, w4_m8_trigger9)
	spawn(9, 1, w4_m8_trigger10)
	delay(8, w4_m8_trigger11)
	delay(8, w4_m8_trigger12)

w4_m8_trigger9:
	.db 8*8+4,1*8
	.db object_gooballdown
	.db $80+ai_shootr
	.db $80
	.db 6,7

w4_m8_trigger10:
	.db 9*8+4,2*8
	.db object_gooballdown
	.db $80+ai_shootr
	.db $80
	.db 6,7

w4_m8_trigger11:
	spawn(8, 1, w4_m8_trigger13)

w4_m8_trigger12:
	spawn(9, 1, w4_m8_trigger14)

w4_m8_trigger13:
	wallblock(8, 1)

w4_m8_trigger14:
	wallblock(9, 1)


world4_map9:
#include maps\tunnels9.lzi
	.db 15
	.db 7*8+3,1*8+4
	.db $ff
	.db 7*8+5,1*8+4
	.db $fe
world4_obj9:
	.db 24

	.db 7*8,6*8
	.db object_doordown
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_crescent
	.db 0

	lampdown(7, 2)

	.db 1*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 2*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 3*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 4*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 5*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 9*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 10*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 11*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 12*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 13*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 14*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 14*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 13*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 12*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 11*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 10*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 9*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 5*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 4*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 3*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 2*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 1*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext


world4_map10:
#include maps\tunnels10.lzi
	.db 12
	.db 2*8+3,7*8+4
	.db 10*8+5,7*8+4
	.db $ff
	.db 2*8+5,7*8+4
	.db 10*8+3,7*8+4
	.db $fe
world4_obj10:
	.db 16

	lampup(2, 8)
	lampup(10, 8)

	dino(3, 6)
	dino(8, 2)

	.db 14*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 13*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 12*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 14*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 13*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 12*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext
	
	.db 8*8,3*8
	.db object_chestright
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 8*8,5*8
	.db object_chestright
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	lootleft(4, 3, 16, 4)
	lootleft(4, 5, 18, 4)

	.db 6*8,7*8
	.db object_doorup
	.db ai_static
	.db $40+rai_conditionelse
	.dw w4_m10_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_static
	.db $80
	.db 0,0

w4_m10_script1:
	.db flag_opendoor
	.db rai_checkother
	.db 3,16*8
	.db rai_conditionelse
	.dw w4_m10_script2
	.db rai_chain
	.dw w4_m10_script4

w4_m10_script2 equ $-1
	.db rai_checkflag
	.db 0,0
	.db rai_opendoor
	.db 0,0
	.db rai_chain
	.dw w4_m10_script3

w4_m10_script3 equ $-1
	.db 2
	.db rai_text
	.db 8,0
	.db rai_unflagobject

w4_m10_script4 equ $-1
	.db 2
	.db rai_text
	.db 7,0
	.db rai_condition
	.dw w4_m10_script5

w4_m10_script5 equ $-1
	.db rai_checkitem
	.dw loot_glowgem
	.db rai_chain
	.dw w4_m10_script6

w4_m10_script6 equ $-1
	.db 2
	.db rai_removeother
	.db 16*8,0
	.db rai_takeitem
	.dw loot_glowgem

world4_map11:
#include maps\tunnels11.lzi
	.db 1
	.db 11*8+4,7*8+3
	.db $fe
world4_obj11:
	.db 20
	
	lampup(11, 8)

	.db 1*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 2*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 3*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 4*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 1*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 2*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 3*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 4*8,5*8
	.db object_chestup
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 13*8,2*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	.db 13*8,3*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_givespec
	.dw loot_untext

	lootleft(13, 5, 10, 4)
	lootleft(13, 6, 12, 4)
	lootleft(13, 7, 14, 4)

	wallblock(8, 7)

	dino(6, 2)
	dino(12, 6)

	.db 7*8,5*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_damscepter

	.db 2*8+4,3*8+4
	.db object_invis
	.db $80+ai_respondelse
	.db flag_die
	.dw w4_m11_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_static
	.db flag_die
	.db 0,0

w4_m11_script1:
	.db %00011111
	.db $40+rai_conditionelse
	.dw w4_m11_script2
	.db rai_condition
	.dw w4_m11_script7

w4_m11_script2 equ $-1
	.db rai_checkflag
	.db 0,0
	.db rai_conditionelse
	.dw w4_m11_script5
	.db rai_condition
	.dw w4_m11_script3

w4_m11_script3 equ $-1
	.db rai_checkitem
	.dw loot_damscepter
	.db rai_chain
	.dw w4_m11_script4

w4_m11_script4 equ $-1
	.db 2
	.db rai_text
	.db 9,0
	.db rai_unflagobject
	.db 0,0
	
w4_m11_script5 equ $-1
	.db rai_checkother
	.db 5,20*8
	.db rai_teleport
	.dw w4_m11_teleport1
	.db rai_chain
	.dw w4_m11_script6
	
w4_m11_script6 equ $-1
	.db 2
	.db rai_removeother
	.db 20*8,0
	.db rai_nfsolidtrigger
	.dw w4_m11_trigger1

w4_m11_script7 equ $-1
	.db rai_checkflag
	.db 0,0
	.db rai_remove

w4_m11_teleport1:
	.db 11*8,3*8
	.db 0

w4_m11_trigger1:
	.db 4

	.db 2*8+4, 2*8+4
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0

	.db 2*8+4, 4*8+4
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0

	.db 1*8+4, 3*8+4
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0

	.db 3*8+4, 3*8+4
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0

world4_map12:
#include maps\tunnels12.lzi
	.db $fe
world4_obj12:
	.db 11

	.db 2*8+4,3*8+4
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w4_m1213_teleport1

	frog(6, 4)
	scorp(7, 6)
	lootright(4, 7, 20, 4)
	
	.db 8*8,7*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0
	
	cloudkill(9, 7, %10000000, 4)
	cloudkill(10, 7, %10000000, 3)	
	cloudkill(12, 7, %10000000, 4)
	cloudkill(12, 6, %10000000, 3)
	cloudkill(13, 7, %10000000, 4)	
	cloudkill(14, 6, %10000000, 4)

world4_map13:
#include maps\tunnels13.lzi
	.db $fe
world4_obj13:
	.db 8

	herbdown(2, 4)
	dino(5, 7)
	dino(4, 2)
	dino(9, 7)
	dino(11, 4)

	.db 12*8,3*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w4_m1213_teleport1	

	.db 10*8,7*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0
	
	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w4_m13_script1

w4_m13_script1:
	.db %00011111
	.db rai_condition
	.dw w4_m13_script2

w4_m13_script2 equ $-1
	.db rai_random
	.db 85,0
	.db rai_conditionelse
	.dw w4_m13_script3

w4_m13_script3 equ $-1
	.db rai_random
	.db 26,0	
	.db rai_conditionelse
	.dw w4_m13_script4
	.db rai_nfsolidtrigger
	.dw w4_m13_trigger1

w4_m13_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w4_m13_trigger2
	.db rai_nfsolidtrigger
	.dw w4_m13_trigger3

w4_m13_trigger1:
	.db 1
	spawn(9, 2, w4_m13_trigger6)

w4_m13_trigger2:
	.db 1
	spawn(9, 4, w4_m13_trigger4)

w4_m13_trigger3:
	.db 1
	spawn(7, 2, w4_m13_trigger5)

w4_m13_trigger4:
	dino(9, 4)

w4_m13_trigger5:
	dino(7, 2)

w4_m13_trigger6:
	.db 9*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w4_m13_loot1

w4_m13_loot1:
	.db item_cloak
	.db 0
	.db pmod_palemoon2

w4_m1213_teleport1:
	.db 12*8+4,3*8+4
	.db 3


world4_map14:
#include maps\tunnels14.lzi
	.db 12
	.db 3*8+4,5*8+3
	.db 9*8+4,5*8+5
	.db $ff
	.db 3*8+4,5*8+5
	.db 9*8+4,5*8+3
	.db $fe
world4_obj14:
	.db 5

	.db 4*8,3*8
	.db object_fountain
	.db ai_animate2
	.db $40+rai_givehealth
	.db 3,0
	
	.db 8*8,3*8
	.db object_fountain
	.db ai_animate2
	.db $40+rai_givehealth
	.db 3,0

	lampright(3, 6)
	lampleft(9, 6)

	.db 6*8,6*8
	.db object_chestup
	.db ai_static
	.db rai_givespec
	.dw loot_gildedtome


world4_map15:
#include maps\tunnels15.lzi
	.db $fe
world4_obj15:
	.db 14

	herbdown(6, 5)

	.db 8*8,6*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

	lootright(2, 4, 22, 4)
	herbdown(13, 2)
	dino(13, 6)
	dino(11, 2)
	dino(2, 2)
	dino(3, 2)
	dino(4, 2)

	.db 5*8,2*8
	.db object_invis
	.db ai_static
	.db $40+rai_remove
	.db 0,0

	.db 3*8,3*8
	.db object_invis
	.db ai_static
	.db $80
	.db 0,0

	.db 5*8,7*8
	.db object_invis
	.db ai_static
	.db rai_chain
	.dw w4_m15_script1

	.db 3*8,5*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w4_m15_script2

	.db 13*8,8*8
	.db object_stairsdown
	.db ai_static
	.db $40+rai_chain
	.dw w4_m15_script5

w4_m15_script1:
	.db flag_die
	.db 2
	.db rai_removeother
	.db 11*8,0
	.db rai_remove

w4_m15_script2:
	.db %00000111
	.db $40+rai_chain
	.dw w4_m15_script3

w4_m15_script3 equ $-1
	.db 2
	.db rai_nfsolidtrigger
	.dw w4_m15_trigger1
	.db rai_condition
	.dw w4_m15_script4

w4_m15_script4 equ $-1
	.db rai_random
	.db 150,0
	.db rai_remove

w4_m15_script5:
	.db flag_none
	.db 2
	.db rai_advance
	.db 4,0
	.db rai_setdesc
	.dw ruinpath

ruinpath:
	.db "Path to Oblivion",0

w4_m15_trigger1:
	.db 1
	spawn(3, 7, w4_m15_trigger2)

w4_m15_trigger2:
	dino(3, 7)
	

;**********************
;** Fifth World Data **
;**********************

world5:
	.db 5					;height
	.db 4					;width
	.db 6					;starting map
	.db 13*8				;starting x-coord
	.db 3*8					;starting y-coord
	.db enemy_blob			;4 enemies used in this world
	.db enemy_bugdude
	.db enemy_swordguy
	.db enemy_dino
	.dw rel(world5_texts)
	.db 0					;intro text ($ff for none)
	.db $ff					;extro text
	.dw rel(world5_paths)

	.dw 0,0
	.dw 0,0
	.dw rel(world5_map2),rel(world5_obj2)
	.dw 0,0

	.dw rel(world5_map6),rel(world5_obj6)
	.dw rel(world5_map5),rel(world5_obj5)	
	.dw rel(world5_map1),rel(world5_obj1)
	.dw 0,0

	.dw 0,0
	.dw rel(world5_map11),rel(world5_obj11)
	.dw rel(world5_map3),rel(world5_obj3)
	.dw 0,0

	.dw 0,0
	.dw rel(world5_map7),rel(world5_obj7)
	.dw rel(world5_map4),rel(world5_obj4)
	.dw rel(world5_map9),rel(world5_obj9)

	.dw 0,0
	.dw rel(world5_map10),rel(world5_obj10)
	.dw rel(world5_map8),rel(world5_obj8)
	.dw 0,0

world5_texts:
	.db 4
	.dw rel(w5_crumble)
	.dw rel(sdoortext)
	.dw rel(w5_badfountain)
	.dw rel(w5_goodfountain)

w5_crumble:
	.db $fd
#include texts/crumble.lzi

w5_badfountain:
	.db $fd
#include texts/badfountain.lzi

w5_goodfountain:
	.db $fd
#include texts/goodfountain.lzi

world5_paths:


world5_map1:
#include maps\lower1.lzi
	.db $fe
world5_obj1:
	.db 5
	
	.db 13*8,2*8
	.db object_stairsup
	.db ai_static
	.db $80
	.db 0,0

	blob(6, 1)
	blob(3, 6)
	blob(8, 8)

	lootright(4, 2, 0, 5)


world5_map2:
#include maps\lower2.lzi
	.db $fe
world5_obj2:
	.db 9

	swordguy(4, 5)
	swordguy(10, 6)
	lootdown(13, 2, 14, 6)
	herbdown(2, 5)

	.db 7*8,4*8
	.db object_fountain
	.db ai_animate2
	.db $40+rai_conditionelse
	.dw w5_m2_script1

	cloudkill(6, 2, %00010000, 4)
	cloudkill(5, 3, %00010000, 4)
	cloudkill(8, 3, %00010000, 4)
	cloudkill(9, 5, %00010000, 4)

w5_m2_script1:
	.db flag_none
	.db rai_checkitem
	.dw loot_oldchalice
	.db rai_chain
	.dw w5_m2_script2
	.db rai_text
	.db 2

w5_m2_script2 equ $-1
	.db 3
	.db rai_text
	.db 3,0
	.db rai_curse
	.db pmod_taint,150
	.db rai_nfsolidtrigger
	.dw w5_m2_trigger1

w5_m2_trigger1:
	.db 1
	.db 7*8,7*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_teleport
	.dw w5_m2_teleport1

w5_m2_teleport1:
	.db 6*8+4,4*8+4
	.db 9

world5_map3:
#include maps\lower3.lzi
	.db $fe
world5_obj3:
	.db 6

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w5_m3_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w5_m3_script1

	bugdude(7, 8)

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w5_m3_script9

	lootup(2, 7, 20, 5)

	.db 2*8,2*8
	.db object_formspawn
	.db ai_animate4
	.db $40+rai_chain
	.dw w5_m3_script12

w5_m3_script12:
	.db flag_none
	.db 2
	.db rai_advance
	.db 5,0
	.db rai_setdesc
	.dw castchamber

castchamber:
	.db "The Casting Chamber",0

w5_m3_script1:
	.db %00001111
	.db rai_conditionelse
	.dw w5_m3_script2

w5_m3_script2 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m3_script3
	.db rai_conditionelse
	.dw w5_m3_script4

w5_m3_script3 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m3_script5
	.db rai_conditionelse
	.dw w5_m3_script6
	
w5_m3_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m3_script7
	.db rai_conditionelse
	.dw w5_m3_script8

w5_m3_script5 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m3_trigger1
	.db rai_nfsolidtrigger
	.dw w5_m3_trigger2

w5_m3_script6 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m3_trigger3
	.db rai_nfsolidtrigger
	.dw w5_m3_trigger4

w5_m3_script7 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m3_trigger5
	.db rai_nfsolidtrigger
	.dw w5_m3_trigger6

w5_m3_script8 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m3_trigger7
	.db rai_nfsolidtrigger
	.dw w5_m3_trigger8

w5_m3_trigger1:
	.db 1
	bubble(6, 4)

w5_m3_trigger2:
	.db 1
	delay(3, w5_m3_trigger9)
w5_m3_trigger9:
	bubble(5, 6)

w5_m3_trigger3:
	.db 1
	delay(4, w5_m3_trigger10)
w5_m3_trigger10:
	bubble(10, 3)

w5_m3_trigger4:
	.db 1
	delay(6, w5_m3_trigger11)
w5_m3_trigger11:
	bubble(11, 5)

w5_m3_trigger5:
	.db 1
	delay(1, w5_m3_trigger12)
w5_m3_trigger12:
	bubble(9, 6)

w5_m3_trigger6:
	.db 1
	delay(7, w5_m3_trigger13)
w5_m3_trigger13:
	bubble(6, 7)

w5_m3_trigger7:
	.db 1
	bubble(10, 5)

w5_m3_trigger8:
	.db 1
	delay(9, w5_m3_trigger14)
w5_m3_trigger14:
	bubble(11, 7)

w5_m3_script9:
	.db %00000001
	.db rai_condition
	.dw w5_m3_script10

w5_m3_script10 equ $-1
	.db rai_checkother
	.db 10,3*8
	.db rai_chain
	.dw w5_m3_script11

w5_m3_script11 equ $-1
	.db 2
	.db rai_remove
	.db 0,0
	.db rai_reltrigger
	.dw w5_m3_trigger15

w5_m3_trigger15:
	blob(0, 0)
	.db 3*8


world5_map4:
#include maps\lower4.lzi
	.db $fe
world5_obj4:
	.db 6

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w5_m4_script1

	blob(10, 3)
	blob(7, 4)
	swordguy(12, 6)

	lootdown(2, 3, 2, 5)

	.db 8*8+4,6*8+4
	.db object_invis
	.db ai_static
	.db rai_nftrigger
	.dw w5_m4_trigger5

w5_m4_script1:
	.db %00001111
	.db rai_conditionelse
	.dw w5_m4_script2

w5_m4_script2 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m4_script3
	.db rai_conditionelse
	.dw w5_m4_script4

w5_m4_script3 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m4_trigger1
	.db rai_nfsolidtrigger
	.dw w5_m4_trigger2

w5_m4_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m4_trigger3
	.db rai_nfsolidtrigger
	.dw w5_m4_trigger4

w5_m4_trigger1:
	.db 1
	bubble(5, 2)

w5_m4_trigger2:
	.db 1
	bubble(4, 3)

w5_m4_trigger3:
	.db 1
	.db 5*8,3*8+4
	.db object_bubble
	.db $80+ai_spawnform
	.db $80
	.db 0,0

w5_m4_trigger4:
	.db 1
	.db 4*8+4,1*8
	.db object_bubble
	.db $80+ai_spawnform
	.db $80
	.db 0,0

w5_m4_trigger5:
	.db 3

	.db 7*8,3*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6,6

	.db 8*8+4,3*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6,6

	.db 10*8,3*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 6,6

world5_map5:
#include maps\lower5.lzi
	.db $fe
world5_obj5:
	.db 8

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db $80
	.dw w5_m5_script1

	lootright(3, 2, 4, 5)

	blob(8, 2)
	dino(5, 4)
	dino(2, 5)

	.db 3*8,4*8+4
	.db object_invis
	.db ai_static
	.db rai_chain
	.dw w5_m5_script5

	.db 10*8,7*8
	.db object_switch
	.db ai_static
	.db rai_switch
	.dw w5_m5_switch2

	herbdown(9, 2)

w5_m5_script1:
	.db %00001111
	.db rai_conditionelse
	.dw w5_m5_script2

w5_m5_script2 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m5_script3
	.db rai_conditionelse
	.dw w5_m5_script4

w5_m5_script3 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m5_trigger1
	.db rai_nfsolidtrigger
	.dw w5_m5_trigger2

w5_m5_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m5_trigger3
	.db rai_nfsolidtrigger
	.dw w5_m5_trigger4

w5_m5_script5:
	.db flag_die
	.db 2
	.db rai_xorothers
	.dw w5_m5_switch1
	.db rai_remove
	
w5_m5_switch1:
	.db 1
	.db 1*8,4

w5_m5_switch2:
	.db 2
	.db 1*8,4
	.db 2*8,4

w5_m5_trigger1:
	.db 1
	bubble(5, 8)

w5_m5_trigger2:
	.db 1
	bubble(6, 8)

w5_m5_trigger3:
	.db 1
	bubble(6, 7)

w5_m5_trigger4:
	.db 1
	bubble(4, 7)



world5_map6:
#include maps\lower6.lzi
	.db $fe
world5_obj6:
	.db 11

	.db 4*8, 7*8
	.db object_doorright
	.db ai_static
	.db $40+rai_sdoor
	.db 1,0

	.db 11*8, 3*8
	.db object_doordown
	.db ai_static
	.db $40+rai_sdoor
	.db 1,0

	herbleft(13, 2)
	lootright(9, 2, 8, 6)

	.db 6*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w5_m6_loot1

	blob(9, 4)
	blob(7, 5)
	blob(9, 6)
	dino(4, 4)
	dino(2, 2)
	dino(2, 6)

w5_m6_loot1:
	.db item_key
	.db pmod_singletooth
	.db 0

world5_map7:
#include maps\lower7.lzi
	.db $fe
world5_obj7:
	.db 10

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db $80
	.dw w5_m7_script1

	herbleft(12, 2)
	herbleft(12, 4)
	swordguy(11, 3)
	lootup(5, 5, 10, 5)
	swordguy(8, 6)
	swordguy(6, 7)
	swordguy(2, 7)

	.db 5*8,7*8
	.db object_doorright
	.db ai_static
	.db $40+rai_condition
	.dw w5_m7_script5

	.db 2*8,4*8
	.db object_switch
	.db ai_static
	.db rai_chain
	.dw w5_m7_script6

w5_m7_script6:
	.db flag_switch
	.db 2
	.db rai_switch
	.db 0,0
	.db rai_link
	.db 9*8

w5_m7_script5:
	.db flag_opendoor
	.db rai_opendoor
	.db 0,0
	.db rai_nfsolidtrigger
	.dw w5_m7_trigger5

w5_m7_trigger5:
	.db 2

	.db 10*8,7*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 4, 8	

	.db 12*8,7*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 4, 7

w5_m7_script1:
	.db %00001111
	.db rai_conditionelse
	.dw w5_m7_script2

w5_m7_script2 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m7_script3
	.db rai_conditionelse
	.dw w5_m7_script4

w5_m7_script3 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m7_trigger1
	.db rai_nfsolidtrigger
	.dw w5_m7_trigger2

w5_m7_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m7_trigger3
	.db rai_nfsolidtrigger
	.dw w5_m7_trigger4

w5_m7_trigger1:
	.db 1
	bubble(4, 2)

w5_m7_trigger2:
	.db 1
	bubble(4, 1)

w5_m7_trigger3:
	.db 1
	bubble(5, 1)

w5_m7_trigger4:
	.db 1
	bubble(6, 2)


world5_map8:
#include maps\lower8.lzi
	.db $fe
world5_obj8:
	.db 7

	bugdude(9, 3)
	bugdude(4, 3)

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w5_m8_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w5_m8_script4

	.db 13*8,6*8
	.db object_chestleft
	.db ai_static
	.db $40+rai_givespec
	.dw w5_m8_loot1

	.db 2*8,7*8
	.db object_doorright
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_doubletooth
	.db 0

	.db 11*8,7*8
	.db object_invis
	.db ai_static
	.db rai_trigger
	.dw w5_m8_trigger3

w5_m8_loot1:
	.db item_key
	.db pmod_doubletooth
	.db 0

w5_m8_script1:
	.db %00000001
	.db rai_condition
	.dw w5_m8_script2

w5_m8_script2 equ $-1
	.db rai_checkother
	.db 18,1*8
	.db rai_chain
	.dw w5_m8_script3

w5_m8_script3 equ $-1
	.db 2
	.db rai_remove
	.db 0,0
	.db rai_reltrigger
	.dw w5_m8_trigger1

w5_m8_trigger1:
	blob(0, 0)
	.db 1*8

w5_m8_script4:
	.db %00000001
	.db rai_condition
	.dw w5_m8_script5

w5_m8_script5 equ $-1
	.db rai_checkother
	.db 18,2*8
	.db rai_chain
	.dw w5_m8_script6

w5_m8_script6 equ $-1
	.db 2
	.db rai_remove
	.db 0,0
	.db rai_reltrigger
	.dw w5_m8_trigger2

w5_m8_trigger2:
	blob(0, 0)
	.db 2*8

w5_m8_trigger3:
	.db 2
	swordguy(3, 7)
	swordguy(5, 7)

world5_map9:
#include maps\lower9.lzi
	.db 1
	.db 5*8+4,4*8+4
	.db $fe
world5_obj9:
	.db 10

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db $80
	.dw w5_m9_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db $80
	.dw w5_m9_script1

	.db 2*8,5*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_singletooth
	.db 0

	.db 7*8,5*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_doubletooth
	.db 0

	.db 11*8,5*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_tripletooth
	.db 0

	.db 5*8,5*8
	.db object_invis
	.db ai_static
	.db rai_lighttrigger
	.dw w5_m9_light1

	.db 9*8,5*8
	.db object_invis
	.db ai_static
	.db rai_lighttrigger
	.dw w5_m9_light2

	lootup(13, 7, 6, 6)

	.db 13*8,3*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw loot_oldchalice

	.db 13*8-1,5*8
	.db object_invis
	.db ai_static
	.db $40+rai_trigger
	.dw w5_m9_trigger13

w5_m9_light1:
	.db 1
	.db 9*8+4,4*8+4
	.db $fe

w5_m9_light2:
	.db 1
	.db 13*8+4,4*8+4
	.db $fe

w5_m9_script1:
	.db %00001111
	.db rai_conditionelse
	.dw w5_m9_script2

w5_m9_script2 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m9_script3
	.db rai_conditionelse
	.dw w5_m9_script4

w5_m9_script3 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m9_script5
	.db rai_conditionelse
	.dw w5_m9_script6

w5_m9_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w5_m9_script7
	.db rai_conditionelse
	.dw w5_m9_script8

w5_m9_script5 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m9_trigger1
	.db rai_nfsolidtrigger
	.dw w5_m9_trigger2

w5_m9_script6 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m9_trigger3
	.db rai_nfsolidtrigger
	.dw w5_m9_trigger4

w5_m9_script7 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m9_trigger5
	.db rai_nfsolidtrigger
	.dw w5_m9_trigger6

w5_m9_script8 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w5_m9_trigger7
	.db rai_nfsolidtrigger
	.dw w5_m9_trigger8

w5_m9_trigger1:
	.db 1
	bubble(5, 2)

w5_m9_trigger2:
	.db 1
	bubble(9, 2)

w5_m9_trigger3:
	.db 1
	bubble(5, 8)

w5_m9_trigger4:
	.db 1
	bubble(9, 8)

w5_m9_trigger5:
	.db 1
	delay(3, w5_m9_trigger9)
w5_m9_trigger9:
	bubble(6, 2)

w5_m9_trigger6:
	.db 1
	delay(4, w5_m9_trigger10)
w5_m9_trigger10:
	bubble(10, 2)

w5_m9_trigger7:
	.db 1
	delay(5, w5_m9_trigger11)
w5_m9_trigger11:
	bubble(4, 8)

w5_m9_trigger8:
	.db 1
	delay(6, w5_m9_trigger12)
w5_m9_trigger12:
	bubble(10, 8)

w5_m9_trigger13:
	.db 4
	delay(1, w5_m9_trigger14)
	delay(40, w5_m9_trigger15)
	delay(80, w5_m9_trigger14)
	delay(120, w5_m9_trigger15)

w5_m9_trigger14:
	spawn(9, 5, w5_m9_trigger16)

w5_m9_trigger15:
	spawn(5, 5, w5_m9_trigger17)

w5_m9_trigger16:
	blob(9, 5)

w5_m9_trigger17:
	blob(5, 5)


world5_map10:
#include maps\lower10.lzi
	.db $fe
world5_obj10:
	.db 16

	herbup(10, 5)
	swordguy(10, 4)

	.db 8*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w5_m10_loot1

	.db 3*8,3*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	.db 3*8,5*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	.db 3*8,7*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	.db 5*8,3*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	.db 5*8,5*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	.db 5*8,7*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	.db 7*8,3*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	.db 7*8,5*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	.db 7*8,7*8
	.db object_invis
	.db $80+ai_respond
	.db flag_die
	.dw w5_m10_script1

	lootdown(4, 2, 12, 5)

	.db 12*8,4*8
	.db object_switch
	.db ai_static
	.db rai_condition
	.dw w5_m10_script2

	.db 9*8,7*8
	.db object_doorleft
	.db ai_static
	.db $40+rai_keydoor
	.db pmod_tripletooth
	.db 0

	swordguy(10, 7)

w5_m10_script1:
	.db %00000111
	.db $40+rai_teleport
	.dw w5_m10_teleport1

w5_m10_teleport1:
	.db 2*8,2*8
	.db 17

w5_m10_script2:
	.db flag_switch
	.db rai_switch
	.db 0,0
	.db rai_chain
	.dw w5_m10_script3

w5_m10_script3 equ $-1
	.db 12
	.db rai_flagother
	.db 17,4*8
	.db rai_flagother
	.db 17,5*8
	.db rai_flagother
	.db 17,6*8
	.db rai_flagother
	.db 17,7*8
	.db rai_flagother
	.db 17,8*8
	.db rai_flagother
	.db 17,9*8
	.db rai_flagother
	.db 17,10*8
	.db rai_flagother
	.db 17,11*8
	.db rai_flagother
	.db 17,12*8
	.db rai_conditionelse
	.dw w5_m10_script4
	.db rai_conditionelse
	.dw w5_m10_script6
	.db rai_conditionelse
	.dw w5_m10_script8

w5_m10_script4 equ $-1
	.db rai_random
	.db 85,0
	.db rai_conditionelse
	.dw w5_m10_script5
	.db rai_removeother
	.db 4*8

w5_m10_script5 equ $-1
	.db rai_random
	.db 128,0
	.db rai_removeother
	.db 5*8,0
	.db rai_removeother
	.db 6*8

w5_m10_script6 equ $-1
	.db rai_random
	.db 85,0
	.db rai_conditionelse
	.dw w5_m10_script7
	.db rai_removeother
	.db 7*8

w5_m10_script7 equ $-1
	.db rai_random
	.db 128,0
	.db rai_removeother
	.db 8*8,0
	.db rai_removeother
	.db 9*8

w5_m10_script8 equ $-1
	.db rai_random
	.db 85,0
	.db rai_conditionelse
	.dw w5_m10_script9
	.db rai_removeother
	.db 10*8

w5_m10_script9 equ $-1
	.db rai_random
	.db 128,0
	.db rai_removeother
	.db 11*8,0
	.db rai_removeother
	.db 12*8

w5_m10_loot1:
	.db item_key
	.db pmod_tripletooth
	.db 0


world5_map11:
#include maps\lower11.lzi
	.db $fe
world5_obj11:
	.db 8

	bugdude(3, 4)
	bugdude(11, 5)

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w5_m11_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w5_m11_script4

	block(2, 6)
	herbdown(13, 2)
	lootleft(3, 7, 18, 6)

	.db 12*8,5*8
	.db object_doorleft
	.db ai_static
	.db rai_opendoor
	.db 0,0

w5_m11_script1:
	.db %00000001
	.db rai_condition
	.dw w5_m11_script2

w5_m11_script2 equ $-1
	.db rai_checkother
	.db 9,1*8
	.db rai_chain
	.dw w5_m11_script3

w5_m11_script3 equ $-1
	.db 4
	.db rai_remove
	.db 0,0
	.db rai_reltrigger
	.dw w5_m11_trigger1
	.db rai_reltrigger
	.dw w5_m11_trigger2
	.db rai_reltrigger
	.dw w5_m11_trigger3

w5_m11_trigger1:
	blob(0, 0)
	.db 1*8
w5_m11_trigger2:
	blob(-1, 1)
	.db 1*8
w5_m11_trigger3:
	blob(-1, -1)
	.db 1*8

w5_m11_script4:
	.db %00000001
	.db rai_condition
	.dw w5_m11_script5

w5_m11_script5 equ $-1
	.db rai_checkother
	.db 9,2*8
	.db rai_chain
	.dw w5_m11_script6

w5_m11_script6 equ $-1
	.db 4
	.db rai_remove
	.db 0,0
	.db rai_reltrigger
	.dw w5_m11_trigger4
	.db rai_reltrigger
	.dw w5_m11_trigger5
	.db rai_reltrigger
	.dw w5_m11_trigger6

w5_m11_trigger4:
	blob(0, 0)
	.db 2*8
w5_m11_trigger5:
	blob(1, 1)
	.db 2*8
w5_m11_trigger6:
	blob(1, -1)
	.db 2*8



;**********************
;** Sixth World Data **
;**********************

world6:
	.db 4					;height
	.db 1					;width
	.db 3					;starting map
	.db 3*8					;starting x-coord
	.db 6*8					;starting y-coord
	.db enemy_blob			;4 enemies used in this world
	.db enemy_badguy
	.db enemy_swordguy
	.db enemy_someguy
	.dw rel(world6_texts)
	.db 0					;intro text ($ff for none)
	.db $ff					;extro text
	.dw rel(world6_paths)

	.dw rel(world6_map4),rel(world6_obj4)
	.dw rel(world6_map3),rel(world6_obj3)
	.dw rel(world6_map2),rel(world6_obj2)
	.dw rel(world6_map1),rel(world6_obj1)

world6_texts:
	.db 5
	.dw rel(w6_intro)
	.dw rel(w6_kerricsays)
	.dw rel(endgame)
	.dw rel(extro1)
	.dw rel(extro2)

w6_intro:
	.db $fd
#include texts/finalintro.lzi

endgame:
	.db $fd
#include texts/extroleadin.lzi

extro1:
	.db $fd
#include texts/badextro.lzi

extro2:
	.db $fd
#include texts/goodextro.lzi

w6_kerricsays:
	.db "Come at last, have you barbarian?  You will die, "
	.db "like the rest of your kind.",0

world6_paths:


world6_map1:
#include maps/final1.lzi
	.db 2
	.db 8*8+2,3*8+4
	.db $ff
	.db 8*8,3*8+2
	.db $ff
	.db 8*8-2,3*8+4
	.db $ff
	.db 8*8,3*8+6
	.db $fe
world6_obj1:
	.db 9
	
	.db 7*8+4,4*8
	.db object_fountain
	.db ai_animate2
	.db $40+rai_givehealth
	.db 4,0

	lootleft(13, 2, 0, 5)
	herbleft(13, 3)
	lootright(2, 2, 2, 6)
	lootright(2, 3, 4, 5)

	swordguy(12, 6)
	swordguy(3, 3)
	swordguy(11, 2)
	someguy(8, 1)

world6_map2:
#include maps/final2.lzi
	.db $fe
world6_obj2:
	.db 6

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w6_m2_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w6_m2_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w6_m2_script1

	swordguy(8, 7)
	someguy(4, 2)
	someguy(10, 2)

w6_m2_script1:
	.db %00001111
	.db rai_conditionelse
	.dw w6_m2_script2

w6_m2_script2 equ $-1
	.db rai_random
	.db 172,0
	.db rai_conditionelse
	.dw w6_m2_script3
	.db rai_conditionelse
	.dw w6_m2_script4

w6_m2_script3 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w6_m2_script7
	.db rai_conditionelse
	.dw w6_m2_script8

w6_m2_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w6_m2_script5
 	.db rai_conditionelse
	.dw w6_m2_script6

w6_m2_script5 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w6_m2_script9
	.db rai_conditionelse
	.dw w6_m2_script10	

w6_m2_script6 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w6_m2_script11
	.db rai_conditionelse
	.dw w6_m2_script12

w6_m2_script7 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger1
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger2

w6_m2_script8 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger3
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger4

w6_m2_script9 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger5
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger6

w6_m2_script10 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger7
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger8

w6_m2_script11 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger9
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger10

w6_m2_script12 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger11
	.db rai_nfsolidtrigger
	.dw w6_m2_trigger12

w6_m2_trigger1:
	.db 1
	bubble(7, 5)

w6_m2_trigger2:
	.db 1
	delay(3, w6_m2_trigger13)
w6_m2_trigger13:
	bubble(6, 3)

w6_m2_trigger3:
	.db 1
	delay(5, w6_m2_trigger14)
w6_m2_trigger14:
	bubble(7, 2)

w6_m2_trigger4:
	.db 1
	delay(2, w6_m2_trigger15)
w6_m2_trigger15:
	bubble(9, 6)

w6_m2_trigger5:
	.db 1
	delay(7, w6_m2_trigger16)
w6_m2_trigger16:
	bubble(8, 3)

w6_m2_trigger6:
	.db 1
	delay(1, w6_m2_trigger17)
w6_m2_trigger17:
	bubble(9, 1)

w6_m2_trigger7:
	.db 1
	delay(4, w6_m2_trigger18)
w6_m2_trigger18:
	bubble(2, 6)

w6_m2_trigger8:
	.db 1
	delay(9, w6_m2_trigger19)
w6_m2_trigger19:
	bubble(3, 4)

w6_m2_trigger9:
	.db 1
	delay(10, w6_m2_trigger20)
w6_m2_trigger20:
	bubble(2, 2)

w6_m2_trigger10:
	.db 1
	delay(1, w6_m2_trigger21)
w6_m2_trigger21:
	bubble(13, 5)

w6_m2_trigger11:
	.db 1
	delay(6, w6_m2_trigger22)
w6_m2_trigger22:
	bubble(12, 4)

w6_m2_trigger12:
	.db 1
	bubble(12, 2)

world6_map3:
#include maps/final3.lzi
	.db $fe
world6_obj3:
	.db 8

	swordguy(6, 4)
	someguy(3, 1)
	someguy(12, 1)
	swordguy(10, 4)

	lootdown(7, 2, 6, 6)
	
	.db 8*8,2*8
	.db object_chestdown
	.db ai_static
	.db $40+rai_givespec
	.dw w6_m3_loot1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w6_m3_script1

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w6_m3_script1

w6_m3_script1:
	.db %00001111
	.db rai_conditionelse
	.dw w6_m3_script2

w6_m3_script2 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w6_m3_script3
	.db rai_conditionelse
	.dw w6_m3_script4	

w6_m3_script3 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w6_m3_script5
	.db rai_conditionelse
	.dw w6_m3_script6	
	
w6_m3_script4 equ $-1
	.db rai_random
	.db 128,0
	.db rai_conditionelse
	.dw w6_m3_script7
	.db rai_conditionelse
	.dw w6_m3_script8

w6_m3_script5 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m3_trigger1
	.db rai_nfsolidtrigger
	.dw w6_m3_trigger2

w6_m3_script6 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m3_trigger3
	.db rai_nfsolidtrigger
	.dw w6_m3_trigger4

w6_m3_script7 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m3_trigger5
	.db rai_nfsolidtrigger
	.dw w6_m3_trigger6

w6_m3_script8 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m3_trigger7
	.db rai_nfsolidtrigger
	.dw w6_m3_trigger8

w6_m3_trigger1:
	.db 1
	bubble(2, 5)

w6_m3_trigger2:
	.db 1
	bubble(13, 8)

w6_m3_trigger3:
	.db 1
	delay(3, w6_m3_trigger9)
w6_m3_trigger9:
	bubble(3, 7)

w6_m3_trigger4:
	.db 1
	delay(3, w6_m3_trigger10)
w6_m3_trigger10:
	bubble(12, 6)

w6_m3_trigger5:
	.db 1
	delay(7, w6_m3_trigger11)
w6_m3_trigger11:
	bubble(6, 5)

w6_m3_trigger6:
	.db 1
	delay(8, w6_m3_trigger12)
w6_m3_trigger12:
	bubble(9, 7)

w6_m3_trigger7:
	.db 1
	delay(11, w6_m3_trigger13)
w6_m3_trigger13:
	bubble(7, 8)

w6_m3_trigger8:
	.db 1
	delay(3, w6_m3_trigger14)
w6_m3_trigger14:
	bubble(8, 6)

w6_m3_loot1:
	.db item_scroll
	.db pmod_finalbook
	.db 0

world6_map4:
#include maps/final4.lzi
	.db $fe
world6_obj4:
	.db 8

	.db 7*8,5*8
	.db object_invis
	.db ai_static
	.db rai_chain
	.dw w6_m4_script1

	.db 6*8,4*8
	.db object_invis
	.db ai_static
	.db rai_link
	.db 1*8,0

	.db 5*8,3*8
	.db object_invis
	.db ai_static
	.db rai_link
	.db 1*8,0

	.db 8*8,5*8
	.db object_invis
	.db ai_static
	.db rai_link
	.db 1*8,0

	.db 9*8,4*8
	.db object_invis
	.db ai_static
	.db rai_link
	.db 1*8,0

	.db 10*8,3*8
	.db object_invis
	.db ai_static
	.db rai_link
	.db 1*8,0

	.db 7*8+4,3*8
	.db object_enemy2
	.db ai_facer
	.db $80+flag_none
	.db 0,0

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w6_m4_script3

w6_m4_script1:
	.db flag_die
	.db 9
	.db rai_text
	.db 1,0
	.db rai_remove
	.db 0,0
	.db rai_removeother
	.db 2*8,0
	.db rai_removeother
	.db 3*8,0
	.db rai_removeother
	.db 4*8,0
	.db rai_removeother
	.db 5*8,0
	.db rai_removeother
	.db 6*8,0
	.db rai_nfsolidtrigger
	.dw w6_m4_trigger1
	.db rai_alterai
	.dw w6_m4_script2

w6_m4_script2:
	.db 7*8					;object number
	.db object_enemy2		;new graphic
	.db ai_trackandshoot	;new ai bytes
	.db $80
	.db 56,9

w6_m4_script3:
	.db %00000111
	.db rai_condition
	.dw w6_m4_script4

w6_m4_script4 equ $-1
	.db rai_checkother
	.db 0,7*8
	.db rai_nfsolidtrigger
	.dw w6_m4_trigger28

w6_m4_script5 equ $-1
	.db 4
	.db rai_text
	.db 2,0
	.db rai_conditionelse
	.dw w6_m4_script16
	.db rai_code
	.db 0,0
	.db rai_endgame

w6_m4_script6:
	.db %00011111
	.db rai_conditionelse
	.dw w6_m4_script7

w6_m4_script7 equ $-1
	.db rai_random
	.db 128,0
	.db rai_condition
	.dw w6_m4_script9
	.db rai_conditionelse
	.dw w6_m4_script8

w6_m4_script8 equ $-1
	.db rai_random
	.db 75,0
	.db rai_chain
	.dw w6_m4_script10
	.db rai_chain
	.dw w6_m4_script13

w6_m4_script9 equ $-1
	.db rai_random
	.db 128,0
	.db rai_nfsolidtrigger
	.dw w6_m4_trigger26

w6_m4_script10 equ $-1
	.db 5
	.db rai_nfsolidtrigger
	.dw w6_m4_trigger12
	.db rai_reltrigger
	.dw w6_m4_trigger13
	.db rai_reltrigger
	.dw w6_m4_trigger14
	.db rai_reltrigger
	.dw w6_m4_trigger15
	.db rai_reltrigger
	.dw w6_m4_trigger16	

w6_m4_script11:
	.db %00000001
	.db rai_chain
	.dw w6_m4_script12

w6_m4_script12 equ $-1
	.db 5
	.db rai_remove
	.db 0,0
	.db rai_reltrigger
	.dw w6_m4_trigger18
	.db rai_reltrigger
	.dw w6_m4_trigger19
	.db rai_reltrigger
	.dw w6_m4_trigger20
	.db rai_reltrigger
	.dw w6_m4_trigger21

w6_m4_script13 equ $-1
	.db 2
	.db rai_nfsolidtrigger
	.dw w6_m4_trigger22
	.db rai_reltrigger
	.dw w6_m4_trigger23

w6_m4_script14:
	.db %00000001
	.db rai_chain
	.dw w6_m4_script15

w6_m4_script15 equ $-1
	.db 2
	.db rai_remove
	.db 0,0
	.db rai_reltrigger
	.dw w6_m4_trigger25

w6_m4_script16 equ $-1
	.db rai_checkitem
	.dw loot_gildedtome
	.db rai_text
	.db 4,0
	.db rai_text
	.db 3,0

w6_m4_script17:
	.db %00000001
	.db rai_chain
	.dw w6_m4_script5

w6_m4_trigger1:
	.db 11
	spawn(3, 8, w6_m4_trigger2)
	spawn(4, 8, w6_m4_trigger3)
	spawn(5, 8, w6_m4_trigger4)
	spawn(10, 8, w6_m4_trigger5)
	spawn(11, 8, w6_m4_trigger6)
	spawn(12, 8, w6_m4_trigger7)

	spawn(5, 7, w6_m4_trigger8)
	spawn(3, 7, w6_m4_trigger9)
	spawn(10, 7, w6_m4_trigger10)
	spawn(12, 7, w6_m4_trigger11)

	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w6_m4_script6

w6_m4_trigger2:
	wallblock(3, 8)

w6_m4_trigger3:
	wallblock(4, 8)

w6_m4_trigger4:
	wallblock(5, 8)

w6_m4_trigger5:
	wallblock(10, 8)

w6_m4_trigger6:
	wallblock(11, 8)

w6_m4_trigger7:
	wallblock(12, 8)

w6_m4_trigger8:
	blob(5, 7)

w6_m4_trigger9:
	blob(3, 7)

w6_m4_trigger10:
	blob(10, 7)

w6_m4_trigger11:
	blob(12, 7)

w6_m4_trigger12:
	.db 1
	delay(4, w6_m4_trigger17)

w6_m4_trigger13:
	.db 1*8,1*8
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0
	.db 7*8
	
w6_m4_trigger14:
	.db -1*8,1*8
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0
	.db 7*8

w6_m4_trigger15:
	.db 1*8,-1*8
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0
	.db 7*8

w6_m4_trigger16:
	.db -1*8,-1*8
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0
	.db 7*8

w6_m4_trigger17:
	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w6_m4_script11

w6_m4_trigger18:
	.db 1*8,1*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 7,5
	.db 7*8

w6_m4_trigger19:
	.db -1*8,1*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 5,5
	.db 7*8

w6_m4_trigger20:
	.db 1*8,-1*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 1,5
	.db 7*8

w6_m4_trigger21:
	.db -1*8,-1*8
	.db object_fireball
	.db $80+ai_shoot
	.db $80
	.db 3,5
	.db 7*8

w6_m4_trigger22:
	.db 1
	delay(4, w6_m4_trigger24)

w6_m4_trigger23:
	.db 0,0
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.db 0,0
	.db 0

w6_m4_trigger24:
	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_die
	.dw w6_m4_script14

w6_m4_trigger25:
	cloudkill(0, 0, %00010000, 5)
	.db 0

w6_m4_trigger26:
	.db 1
	.db 7*8+4,7*8
	.db object_formspawn
	.db $80+ai_spawnform
	.db $80
	.dw w6_m4_trigger27

w6_m4_trigger27:
	.db 7*8+4,7*8
	.db object_enemy1
	.db ai_rtrackandshoot
	.db $80	
	.db 45,4

w6_m4_trigger28:
	.db 1
	delay(14, w6_m4_trigger29)

w6_m4_trigger29:
	.db 1*8,1*8
	.db object_invis
	.db $80+ai_respondcon
	.db flag_none
	.dw w6_m4_script17


	;***********************************
	;** texts used in multiple levels **
	;***********************************
	;these should be kept at the end of the file because
	;the relative pointers are not allowed to be negative

sdoortext:
	.db "This door cannot be opened from here",0
mechanism:
	.db "This door is held shut by some sort of mechanism",0
lastdoor:
	.db "This door is protected by a powerful spell",0


.end




