#include blind.inc

;quick objects
#define snake(x, y) .db x*8, y*8, object_enemy1, ai_track, $80, 0, 0
#define bigsnake(x, y) .db x*8, y*8, object_enemy1, ai_track, $80, 0, 1
#define smartsnake(x, y) .db x*8, y*8, object_enemy1, ai_passivetrack, $80, 0, 1
#define block(x, y) .db x*8, y*8, object_block, ai_static, rai_pushblock, 0, 0
#define lootup(x, y, INDEX, LEVEL) .db x*8, y*8, object_chestup, ai_static, $40+rai_giveloot, INDEX, LEVEL
#define lootdown(x, y, INDEX, LEVEL) .db x*8, y*8, object_chestdown, ai_static, $40+rai_giveloot, INDEX, LEVEL
#define lootright(x, y, INDEX, LEVEL) .db x*8, y*8, object_chestright, ai_static, $40+rai_giveloot, INDEX, LEVEL
#define lootleft(x, y, INDEX, LEVEL) .db x*8, y*8, object_chestleft, ai_static, $40+rai_giveloot, INDEX, LEVEL
#define spawn(x, y, OBJECT) .db x*8, y*8, object_formspawn, $80+ai_spawnform, $80\ .dw OBJECT
#define bspidah(x, y) .db x*8, y*8, object_enemy4, ai_track, $80, 0, 2
#define aspidah(x, y) .db x*8, y*8, object_enemy3, ai_passivetrack, $80, 0, 3
#define ststeleport(x, y, x2, y2) .db x*8, y*8, object_formspawn, ai_animate4, rai_ststele, x2*8, y2*8
#define lampup(x, y) .db x*8, y*8, object_lampup, ai_animate4r, $80, 0,0
#define lampdown(x, y) .db x*8, y*8, object_lampdown, ai_animate4r, $80, 0,0
#define lampright(x, y) .db x*8, y*8, object_lampright, ai_animate4r, $80, 0,0
#define lampleft(x, y) .db x*8, y*8, object_lampleft, ai_animate4r, $80, 0,0
#define herbup(x, y) .db x*8, y*8, object_chestup, ai_static, $40+rai_givespec\ .dw loot_herb
#define herbdown(x, y) .db x*8, y*8, object_chestdown, ai_static, $40+rai_givespec\ .dw loot_herb
#define herbright(x, y) .db x*8, y*8, object_chestright, ai_static, $40+rai_givespec\ .dw loot_herb
#define herbleft(x, y) .db x*8, y*8, object_chestleft, ai_static, $40+rai_givespec\ .dw loot_herb
#define badguy(x, y, PROB, LEVEL) .db x*8, y*8, object_enemy2, ai_trackandshoot, $80, PROB, LEVEL
#define smartbspidah(x, y) .db x*8, y*8, object_enemy4, ai_passivetrack, $80, 0, 2
#define wallblock(x, y) .db x*8, y*8, object_wallblock, ai_static, rai_pushblock, 0, 0
#define delay(TIME, OBJECT) .db TIME, 8, object_invis, $80+ai_delay, $80 \ .dw OBJECT
#define cloudkill(x, y, FREQ, LEVEL) .db x*8, y*8, object_cloud, $80+ai_cloudkill, flag_none, FREQ, LEVEL
#define scorp(x, y) .db x*8,y*8, object_enemy1, ai_track, $80, 0, 4
#define frog(x, y) .db x*8, y*8, object_enemy3, ai_track, $80, 0, 4
#define dino(x, y) .db x*8, y*8, object_enemy4, ai_passivetrack, $80, 0, 5
#define blob(x, y) .db x*8, y*8, object_enemy1, ai_rtrackandshoot, $80, 45, 4
#define bubble(x, y) .db x*8, y*8, object_bubble, $80+ai_spawnform, $80, 0, 0
#define bugdude(x, y) .db x*8, y*8, object_enemy2, ai_track, $80, 0, 6
#define swordguy(x, y) .db x*8, y*8, object_enemy3, ai_passivetrack, $80, 0, 7
#define someguy(x, y) .db x*8, y*8, object_enemy4, ai_trackandshoot, $80, 30, 5
#define bigblob(x, y) .db x*8, y*8, object_enemy1, ai_rtrackandshoot, $80, 40, 5

pmod_silver equ modtotal+1
pmod_defenselessness equ modtotal+1			;these two overlap
pmod_gold equ modtotal+2
pmod_hurtin equ modtotal+2					;these two also overlap
pmod_heavyiron equ modtotal+3
pmod_taint equ modtotal+3					;as do these
pmod_stone equ modtotal+4
pmod_libtrap equ modtotal+4					;and these...
pmod_tattered equ modtotal+5
pmod_warding equ modtotal+6
pmod_historical equ modtotal+7
pmod_glowing equ modtotal+8
pmod_weird equ modtotal+9
pmod_strange equ modtotal+10
pmod_eternity equ modtotal+11
pmod_hastily equ modtotal+12
pmod_tarnished equ modtotal+13
pmod_focusing equ modtotal+14
pmod_triangular equ modtotal+15
pmod_zedsword equ modtotal+16
pmod_zedshield equ modtotal+17
pmod_airgem equ modtotal+18
pmod_firegem equ modtotal+19
pmod_earthgem equ modtotal+20
pmod_watergem equ modtotal+21
pmod_clerical equ modtotal+22
pmod_demonbile equ modtotal+23
pmod_crescent equ modtotal+24
pmod_foreman1 equ modtotal+25
pmod_foreman2 equ modtotal+26
pmod_ancient equ modtotal+27
pmod_damascened equ modtotal+28
pmod_palemoon2 equ modtotal+29
pmod_gilded equ modtotal+30
pmod_singletooth equ modtotal+31
pmod_doubletooth equ modtotal+32
pmod_tripletooth equ modtotal+33
pmod_finalbook equ modtotal+34

.end